/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         FRONTEND_VERILOG_YYSTYPE
#define YYLTYPE         FRONTEND_VERILOG_YYLTYPE
/* Substitute the variable and function names.  */
#define yyparse         frontend_verilog_yyparse
#define yylex           frontend_verilog_yylex
#define yyerror         frontend_verilog_yyerror
#define yydebug         frontend_verilog_yydebug
#define yynerrs         frontend_verilog_yynerrs

/* First part of user prologue.  */
#line 36 "frontends/verilog/verilog_parser.y"

#include <list>
#include <stack>
#include <string.h>
#include "frontends/verilog/verilog_frontend.h"
#include "frontends/verilog/verilog_parser.tab.hh"
#include "kernel/log.h"

#define YYLEX_PARAM &yylval, &yylloc

USING_YOSYS_NAMESPACE
using namespace AST;
using namespace VERILOG_FRONTEND;

YOSYS_NAMESPACE_BEGIN
namespace VERILOG_FRONTEND {
	int port_counter;
	dict<std::string, int> port_stubs;
	dict<IdString, AstNode*> *attr_list, default_attr_list;
	std::stack<dict<IdString, AstNode*> *> attr_list_stack;
	dict<IdString, AstNode*> *albuf;
	std::vector<UserTypeMap> user_type_stack;
	dict<std::string, AstNode*> pkg_user_types;
	std::vector<AstNode*> ast_stack;
	struct AstNode *astbuf1, *astbuf2, *astbuf3;
	struct AstNode *current_function_or_task;
	struct AstNode *current_ast, *current_ast_mod;
	int current_function_or_task_port_id;
	std::vector<char> case_type_stack;
	bool do_not_require_port_stubs;
	bool default_nettype_wire;
	bool sv_mode, formal_mode, lib_mode, specify_mode;
	bool noassert_mode, noassume_mode, norestrict_mode;
	bool assume_asserts_mode, assert_assumes_mode;
	bool current_wire_rand, current_wire_const;
	bool current_modport_input, current_modport_output;
	std::istream *lexin;
}
YOSYS_NAMESPACE_END

#define SET_AST_NODE_LOC(WHICH, BEGIN, END) \
    do { (WHICH)->location.first_line = (BEGIN).first_line; \
    (WHICH)->location.first_column = (BEGIN).first_column; \
    (WHICH)->location.last_line = (END).last_line; \
    (WHICH)->location.last_column = (END).last_column; } while(0)

#define SET_RULE_LOC(LHS, BEGIN, END) \
    do { (LHS).first_line = (BEGIN).first_line; \
    (LHS).first_column = (BEGIN).first_column; \
    (LHS).last_line = (END).last_line; \
    (LHS).last_column = (END).last_column; } while(0)

int frontend_verilog_yylex(YYSTYPE *yylval_param, YYLTYPE *yyloc_param);

static void append_attr(AstNode *ast, dict<IdString, AstNode*> *al)
{
	for (auto &it : *al) {
		if (ast->attributes.count(it.first) > 0)
			delete ast->attributes[it.first];
		ast->attributes[it.first] = it.second;
	}
	delete al;
}

static void append_attr_clone(AstNode *ast, dict<IdString, AstNode*> *al)
{
	for (auto &it : *al) {
		if (ast->attributes.count(it.first) > 0)
			delete ast->attributes[it.first];
		ast->attributes[it.first] = it.second->clone();
	}
}

static void free_attr(dict<IdString, AstNode*> *al)
{
	for (auto &it : *al)
		delete it.second;
	delete al;
}

struct specify_target {
	char polarity_op;
	AstNode *dst, *dat;
};

struct specify_triple {
	AstNode *t_min, *t_avg, *t_max;
};

struct specify_rise_fall {
	specify_triple rise;
	specify_triple fall;
};

static void addWiretypeNode(std::string *name, AstNode *node)
{
	log_assert(node);
	node->is_custom_type = true;
	node->children.push_back(new AstNode(AST_WIRETYPE));
	node->children.back()->str = *name;
	delete name;
}

static void addTypedefNode(std::string *name, AstNode *node)
{
	log_assert(node);
	auto *tnode = new AstNode(AST_TYPEDEF, node);
	tnode->str = *name;
	auto &user_types = user_type_stack.back();
	user_types[*name] = tnode;
	if (current_ast_mod && current_ast_mod->type == AST_PACKAGE) {
		// typedef inside a package so we need the qualified name
		auto qname = current_ast_mod->str + "::" + (*name).substr(1);
		pkg_user_types[qname] = tnode;
	}
	delete name;
	ast_stack.back()->children.push_back(tnode);
}

static void enterTypeScope()
{
	user_type_stack.push_back(UserTypeMap());
}

static void exitTypeScope()
{
	user_type_stack.pop_back();
}

static bool isInLocalScope(const std::string *name)
{
	// tests if a name was declared in the current block scope
	auto &user_types = user_type_stack.back();
	return (user_types.count(*name) > 0);
}

static AstNode *getTypeDefinitionNode(std::string type_name)
{
	// check current scope then outer scopes for a name
	for (auto it = user_type_stack.rbegin(); it != user_type_stack.rend(); ++it) {
		if (it->count(type_name) > 0) {
			// return the definition nodes from the typedef statement
			auto typedef_node = (*it)[type_name];
			log_assert(typedef_node->type == AST_TYPEDEF);
			return typedef_node->children[0];
		}
	}

	// The lexer recognized the name as a TOK_USER_TYPE, but now we can't find it anymore?
	log_error("typedef for user type `%s' not found", type_name.c_str());
}

static AstNode *copyTypeDefinition(std::string type_name)
{
	// return a copy of the template from a typedef definition
	auto typedef_node = getTypeDefinitionNode(type_name);
	return typedef_node->clone();
}

static AstNode *makeRange(int msb = 31, int lsb = 0, bool isSigned = true)
{
	auto range = new AstNode(AST_RANGE);
	range->children.push_back(AstNode::mkconst_int(msb, true));
	range->children.push_back(AstNode::mkconst_int(lsb, true));
	range->is_signed = isSigned;
	return range;
}

static void addRange(AstNode *parent, int msb = 31, int lsb = 0, bool isSigned = true)
{
	auto range = makeRange(msb, lsb, isSigned);
	parent->children.push_back(range);
}

static AstNode *checkRange(AstNode *type_node, AstNode *range_node)
{
	if (type_node->range_left >= 0 && type_node->range_right >= 0) {
		// type already restricts the range
		if (range_node) {
			frontend_verilog_yyerror("integer/genvar types cannot have packed dimensions.");
		}
		else {
			range_node = makeRange(type_node->range_left, type_node->range_right, false);
		}
	}
	if (range_node && range_node->children.size() != 2) {
		frontend_verilog_yyerror("wire/reg/logic packed dimension must be of the form: [<expr>:<expr>], [<expr>+:<expr>], or [<expr>-:<expr>]");
	}
	return range_node;
}

static void rewriteRange(AstNode *rangeNode)
{
	if (rangeNode->type == AST_RANGE && rangeNode->children.size() == 1) {
		// SV array size [n], rewrite as [n-1:0]
		rangeNode->children[0] = new AstNode(AST_SUB, rangeNode->children[0], AstNode::mkconst_int(1, true));
		rangeNode->children.push_back(AstNode::mkconst_int(0, false));
	}
}

static void rewriteAsMemoryNode(AstNode *node, AstNode *rangeNode)
{
	node->type = AST_MEMORY;
	if (rangeNode->type == AST_MULTIRANGE) {
		for (auto *itr : rangeNode->children)
			rewriteRange(itr);
	} else
		rewriteRange(rangeNode);
	node->children.push_back(rangeNode);
}

static void checkLabelsMatch(const char *element, const std::string *before, const std::string *after)
{
	if (!before && after)
		frontend_verilog_yyerror("%s missing where end label (%s) was given.",
			element, after->c_str() + 1);
	if (before && after && *before != *after)
		frontend_verilog_yyerror("%s (%s) and end label (%s) don't match.",
			element, before->c_str() + 1, after->c_str() + 1);
}

// This transforms a loop like
//   for (genvar i = 0; i < 10; i++) begin : blk
// to
//   genvar _i;
//   for (_i = 0; _i < 10; _i++) begin : blk
//     localparam i = _i;
// where `_i` is actually some auto-generated name.
static void rewriteGenForDeclInit(AstNode *loop)
{
	// check if this generate for loop contains an inline declaration
	log_assert(loop->type == AST_GENFOR);
	AstNode *decl = loop->children[0];
	if (decl->type == AST_ASSIGN_EQ)
		return;
	log_assert(decl->type == AST_GENVAR);
	log_assert(loop->children.size() == 5);

	// identify each component of the loop
	AstNode *init = loop->children[1];
	AstNode *cond = loop->children[2];
	AstNode *incr = loop->children[3];
	AstNode *body = loop->children[4];
	log_assert(init->type == AST_ASSIGN_EQ);
	log_assert(incr->type == AST_ASSIGN_EQ);
	log_assert(body->type == AST_GENBLOCK);

	// create a unique name for the genvar
	std::string old_str = decl->str;
	std::string new_str = stringf("$genfordecl$%d$%s", autoidx++, old_str.c_str());

	// rename and move the genvar declaration to the containing description
	decl->str = new_str;
	loop->children.erase(loop->children.begin());
	log_assert(current_ast_mod != nullptr);
	current_ast_mod->children.push_back(decl);

	// create a new localparam with old name so that the items in the loop
	// can simply use the old name and shadow it as necessary
	AstNode *indirect = new AstNode(AST_LOCALPARAM);
	indirect->str = old_str;
	AstNode *ident = new AstNode(AST_IDENTIFIER);
	ident->str = new_str;
	indirect->children.push_back(ident);

	body->children.insert(body->children.begin(), indirect);

	// only perform the renaming for the initialization, guard, and
	// incrementation to enable proper shadowing of the synthetic localparam
	std::function<void(AstNode*)> substitute = [&](AstNode *node) {
		if (node->type == AST_IDENTIFIER && node->str == old_str)
			node->str = new_str;
		for (AstNode *child : node->children)
			substitute(child);
	};
	substitute(init);
	substitute(cond);
	substitute(incr);
}


#line 360 "frontends/verilog/verilog_parser.tab.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "verilog_parser.tab.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_STRING = 3,                 /* TOK_STRING  */
  YYSYMBOL_TOK_ID = 4,                     /* TOK_ID  */
  YYSYMBOL_TOK_CONSTVAL = 5,               /* TOK_CONSTVAL  */
  YYSYMBOL_TOK_REALVAL = 6,                /* TOK_REALVAL  */
  YYSYMBOL_TOK_PRIMITIVE = 7,              /* TOK_PRIMITIVE  */
  YYSYMBOL_TOK_SVA_LABEL = 8,              /* TOK_SVA_LABEL  */
  YYSYMBOL_TOK_SPECIFY_OPER = 9,           /* TOK_SPECIFY_OPER  */
  YYSYMBOL_TOK_MSG_TASKS = 10,             /* TOK_MSG_TASKS  */
  YYSYMBOL_TOK_BASE = 11,                  /* TOK_BASE  */
  YYSYMBOL_TOK_BASED_CONSTVAL = 12,        /* TOK_BASED_CONSTVAL  */
  YYSYMBOL_TOK_UNBASED_UNSIZED_CONSTVAL = 13, /* TOK_UNBASED_UNSIZED_CONSTVAL  */
  YYSYMBOL_TOK_USER_TYPE = 14,             /* TOK_USER_TYPE  */
  YYSYMBOL_TOK_PKG_USER_TYPE = 15,         /* TOK_PKG_USER_TYPE  */
  YYSYMBOL_TOK_ASSERT = 16,                /* TOK_ASSERT  */
  YYSYMBOL_TOK_ASSUME = 17,                /* TOK_ASSUME  */
  YYSYMBOL_TOK_RESTRICT = 18,              /* TOK_RESTRICT  */
  YYSYMBOL_TOK_COVER = 19,                 /* TOK_COVER  */
  YYSYMBOL_TOK_FINAL = 20,                 /* TOK_FINAL  */
  YYSYMBOL_ATTR_BEGIN = 21,                /* ATTR_BEGIN  */
  YYSYMBOL_ATTR_END = 22,                  /* ATTR_END  */
  YYSYMBOL_DEFATTR_BEGIN = 23,             /* DEFATTR_BEGIN  */
  YYSYMBOL_DEFATTR_END = 24,               /* DEFATTR_END  */
  YYSYMBOL_TOK_MODULE = 25,                /* TOK_MODULE  */
  YYSYMBOL_TOK_ENDMODULE = 26,             /* TOK_ENDMODULE  */
  YYSYMBOL_TOK_PARAMETER = 27,             /* TOK_PARAMETER  */
  YYSYMBOL_TOK_LOCALPARAM = 28,            /* TOK_LOCALPARAM  */
  YYSYMBOL_TOK_DEFPARAM = 29,              /* TOK_DEFPARAM  */
  YYSYMBOL_TOK_PACKAGE = 30,               /* TOK_PACKAGE  */
  YYSYMBOL_TOK_ENDPACKAGE = 31,            /* TOK_ENDPACKAGE  */
  YYSYMBOL_TOK_PACKAGESEP = 32,            /* TOK_PACKAGESEP  */
  YYSYMBOL_TOK_INTERFACE = 33,             /* TOK_INTERFACE  */
  YYSYMBOL_TOK_ENDINTERFACE = 34,          /* TOK_ENDINTERFACE  */
  YYSYMBOL_TOK_MODPORT = 35,               /* TOK_MODPORT  */
  YYSYMBOL_TOK_VAR = 36,                   /* TOK_VAR  */
  YYSYMBOL_TOK_WILDCARD_CONNECT = 37,      /* TOK_WILDCARD_CONNECT  */
  YYSYMBOL_TOK_INPUT = 38,                 /* TOK_INPUT  */
  YYSYMBOL_TOK_OUTPUT = 39,                /* TOK_OUTPUT  */
  YYSYMBOL_TOK_INOUT = 40,                 /* TOK_INOUT  */
  YYSYMBOL_TOK_WIRE = 41,                  /* TOK_WIRE  */
  YYSYMBOL_TOK_WAND = 42,                  /* TOK_WAND  */
  YYSYMBOL_TOK_WOR = 43,                   /* TOK_WOR  */
  YYSYMBOL_TOK_REG = 44,                   /* TOK_REG  */
  YYSYMBOL_TOK_LOGIC = 45,                 /* TOK_LOGIC  */
  YYSYMBOL_TOK_INTEGER = 46,               /* TOK_INTEGER  */
  YYSYMBOL_TOK_SIGNED = 47,                /* TOK_SIGNED  */
  YYSYMBOL_TOK_ASSIGN = 48,                /* TOK_ASSIGN  */
  YYSYMBOL_TOK_ALWAYS = 49,                /* TOK_ALWAYS  */
  YYSYMBOL_TOK_INITIAL = 50,               /* TOK_INITIAL  */
  YYSYMBOL_TOK_ALWAYS_FF = 51,             /* TOK_ALWAYS_FF  */
  YYSYMBOL_TOK_ALWAYS_COMB = 52,           /* TOK_ALWAYS_COMB  */
  YYSYMBOL_TOK_ALWAYS_LATCH = 53,          /* TOK_ALWAYS_LATCH  */
  YYSYMBOL_TOK_BEGIN = 54,                 /* TOK_BEGIN  */
  YYSYMBOL_TOK_END = 55,                   /* TOK_END  */
  YYSYMBOL_TOK_IF = 56,                    /* TOK_IF  */
  YYSYMBOL_TOK_ELSE = 57,                  /* TOK_ELSE  */
  YYSYMBOL_TOK_FOR = 58,                   /* TOK_FOR  */
  YYSYMBOL_TOK_WHILE = 59,                 /* TOK_WHILE  */
  YYSYMBOL_TOK_REPEAT = 60,                /* TOK_REPEAT  */
  YYSYMBOL_TOK_DPI_FUNCTION = 61,          /* TOK_DPI_FUNCTION  */
  YYSYMBOL_TOK_POSEDGE = 62,               /* TOK_POSEDGE  */
  YYSYMBOL_TOK_NEGEDGE = 63,               /* TOK_NEGEDGE  */
  YYSYMBOL_TOK_OR = 64,                    /* TOK_OR  */
  YYSYMBOL_TOK_AUTOMATIC = 65,             /* TOK_AUTOMATIC  */
  YYSYMBOL_TOK_CASE = 66,                  /* TOK_CASE  */
  YYSYMBOL_TOK_CASEX = 67,                 /* TOK_CASEX  */
  YYSYMBOL_TOK_CASEZ = 68,                 /* TOK_CASEZ  */
  YYSYMBOL_TOK_ENDCASE = 69,               /* TOK_ENDCASE  */
  YYSYMBOL_TOK_DEFAULT = 70,               /* TOK_DEFAULT  */
  YYSYMBOL_TOK_FUNCTION = 71,              /* TOK_FUNCTION  */
  YYSYMBOL_TOK_ENDFUNCTION = 72,           /* TOK_ENDFUNCTION  */
  YYSYMBOL_TOK_TASK = 73,                  /* TOK_TASK  */
  YYSYMBOL_TOK_ENDTASK = 74,               /* TOK_ENDTASK  */
  YYSYMBOL_TOK_SPECIFY = 75,               /* TOK_SPECIFY  */
  YYSYMBOL_TOK_IGNORED_SPECIFY = 76,       /* TOK_IGNORED_SPECIFY  */
  YYSYMBOL_TOK_ENDSPECIFY = 77,            /* TOK_ENDSPECIFY  */
  YYSYMBOL_TOK_SPECPARAM = 78,             /* TOK_SPECPARAM  */
  YYSYMBOL_TOK_SPECIFY_AND = 79,           /* TOK_SPECIFY_AND  */
  YYSYMBOL_TOK_IGNORED_SPECIFY_AND = 80,   /* TOK_IGNORED_SPECIFY_AND  */
  YYSYMBOL_TOK_GENERATE = 81,              /* TOK_GENERATE  */
  YYSYMBOL_TOK_ENDGENERATE = 82,           /* TOK_ENDGENERATE  */
  YYSYMBOL_TOK_GENVAR = 83,                /* TOK_GENVAR  */
  YYSYMBOL_TOK_REAL = 84,                  /* TOK_REAL  */
  YYSYMBOL_TOK_SYNOPSYS_FULL_CASE = 85,    /* TOK_SYNOPSYS_FULL_CASE  */
  YYSYMBOL_TOK_SYNOPSYS_PARALLEL_CASE = 86, /* TOK_SYNOPSYS_PARALLEL_CASE  */
  YYSYMBOL_TOK_SUPPLY0 = 87,               /* TOK_SUPPLY0  */
  YYSYMBOL_TOK_SUPPLY1 = 88,               /* TOK_SUPPLY1  */
  YYSYMBOL_TOK_TO_SIGNED = 89,             /* TOK_TO_SIGNED  */
  YYSYMBOL_TOK_TO_UNSIGNED = 90,           /* TOK_TO_UNSIGNED  */
  YYSYMBOL_TOK_POS_INDEXED = 91,           /* TOK_POS_INDEXED  */
  YYSYMBOL_TOK_NEG_INDEXED = 92,           /* TOK_NEG_INDEXED  */
  YYSYMBOL_TOK_PROPERTY = 93,              /* TOK_PROPERTY  */
  YYSYMBOL_TOK_ENUM = 94,                  /* TOK_ENUM  */
  YYSYMBOL_TOK_TYPEDEF = 95,               /* TOK_TYPEDEF  */
  YYSYMBOL_TOK_RAND = 96,                  /* TOK_RAND  */
  YYSYMBOL_TOK_CONST = 97,                 /* TOK_CONST  */
  YYSYMBOL_TOK_CHECKER = 98,               /* TOK_CHECKER  */
  YYSYMBOL_TOK_ENDCHECKER = 99,            /* TOK_ENDCHECKER  */
  YYSYMBOL_TOK_EVENTUALLY = 100,           /* TOK_EVENTUALLY  */
  YYSYMBOL_TOK_INCREMENT = 101,            /* TOK_INCREMENT  */
  YYSYMBOL_TOK_DECREMENT = 102,            /* TOK_DECREMENT  */
  YYSYMBOL_TOK_UNIQUE = 103,               /* TOK_UNIQUE  */
  YYSYMBOL_TOK_UNIQUE0 = 104,              /* TOK_UNIQUE0  */
  YYSYMBOL_TOK_PRIORITY = 105,             /* TOK_PRIORITY  */
  YYSYMBOL_TOK_STRUCT = 106,               /* TOK_STRUCT  */
  YYSYMBOL_TOK_PACKED = 107,               /* TOK_PACKED  */
  YYSYMBOL_TOK_UNSIGNED = 108,             /* TOK_UNSIGNED  */
  YYSYMBOL_TOK_INT = 109,                  /* TOK_INT  */
  YYSYMBOL_TOK_BYTE = 110,                 /* TOK_BYTE  */
  YYSYMBOL_TOK_SHORTINT = 111,             /* TOK_SHORTINT  */
  YYSYMBOL_TOK_LONGINT = 112,              /* TOK_LONGINT  */
  YYSYMBOL_TOK_UNION = 113,                /* TOK_UNION  */
  YYSYMBOL_TOK_BIT_OR_ASSIGN = 114,        /* TOK_BIT_OR_ASSIGN  */
  YYSYMBOL_TOK_BIT_AND_ASSIGN = 115,       /* TOK_BIT_AND_ASSIGN  */
  YYSYMBOL_TOK_BIT_XOR_ASSIGN = 116,       /* TOK_BIT_XOR_ASSIGN  */
  YYSYMBOL_TOK_ADD_ASSIGN = 117,           /* TOK_ADD_ASSIGN  */
  YYSYMBOL_TOK_SUB_ASSIGN = 118,           /* TOK_SUB_ASSIGN  */
  YYSYMBOL_TOK_DIV_ASSIGN = 119,           /* TOK_DIV_ASSIGN  */
  YYSYMBOL_TOK_MOD_ASSIGN = 120,           /* TOK_MOD_ASSIGN  */
  YYSYMBOL_TOK_MUL_ASSIGN = 121,           /* TOK_MUL_ASSIGN  */
  YYSYMBOL_TOK_SHL_ASSIGN = 122,           /* TOK_SHL_ASSIGN  */
  YYSYMBOL_TOK_SHR_ASSIGN = 123,           /* TOK_SHR_ASSIGN  */
  YYSYMBOL_TOK_SSHL_ASSIGN = 124,          /* TOK_SSHL_ASSIGN  */
  YYSYMBOL_TOK_SSHR_ASSIGN = 125,          /* TOK_SSHR_ASSIGN  */
  YYSYMBOL_TOK_BIND = 126,                 /* TOK_BIND  */
  YYSYMBOL_OP_LOR = 127,                   /* OP_LOR  */
  YYSYMBOL_OP_LAND = 128,                  /* OP_LAND  */
  YYSYMBOL_129_ = 129,                     /* '|'  */
  YYSYMBOL_OP_NOR = 130,                   /* OP_NOR  */
  YYSYMBOL_131_ = 131,                     /* '^'  */
  YYSYMBOL_OP_XNOR = 132,                  /* OP_XNOR  */
  YYSYMBOL_133_ = 133,                     /* '&'  */
  YYSYMBOL_OP_NAND = 134,                  /* OP_NAND  */
  YYSYMBOL_OP_EQ = 135,                    /* OP_EQ  */
  YYSYMBOL_OP_NE = 136,                    /* OP_NE  */
  YYSYMBOL_OP_EQX = 137,                   /* OP_EQX  */
  YYSYMBOL_OP_NEX = 138,                   /* OP_NEX  */
  YYSYMBOL_139_ = 139,                     /* '<'  */
  YYSYMBOL_OP_LE = 140,                    /* OP_LE  */
  YYSYMBOL_OP_GE = 141,                    /* OP_GE  */
  YYSYMBOL_142_ = 142,                     /* '>'  */
  YYSYMBOL_OP_SHL = 143,                   /* OP_SHL  */
  YYSYMBOL_OP_SHR = 144,                   /* OP_SHR  */
  YYSYMBOL_OP_SSHL = 145,                  /* OP_SSHL  */
  YYSYMBOL_OP_SSHR = 146,                  /* OP_SSHR  */
  YYSYMBOL_147_ = 147,                     /* '+'  */
  YYSYMBOL_148_ = 148,                     /* '-'  */
  YYSYMBOL_149_ = 149,                     /* '*'  */
  YYSYMBOL_150_ = 150,                     /* '/'  */
  YYSYMBOL_151_ = 151,                     /* '%'  */
  YYSYMBOL_OP_POW = 152,                   /* OP_POW  */
  YYSYMBOL_OP_CAST = 153,                  /* OP_CAST  */
  YYSYMBOL_UNARY_OPS = 154,                /* UNARY_OPS  */
  YYSYMBOL_FAKE_THEN = 155,                /* FAKE_THEN  */
  YYSYMBOL_156_ = 156,                     /* ','  */
  YYSYMBOL_157_ = 157,                     /* '='  */
  YYSYMBOL_158_ = 158,                     /* '.'  */
  YYSYMBOL_159_ = 159,                     /* '('  */
  YYSYMBOL_160_ = 160,                     /* ')'  */
  YYSYMBOL_161_ = 161,                     /* ';'  */
  YYSYMBOL_162_ = 162,                     /* '#'  */
  YYSYMBOL_163_ = 163,                     /* ':'  */
  YYSYMBOL_164_ = 164,                     /* '['  */
  YYSYMBOL_165_ = 165,                     /* ']'  */
  YYSYMBOL_166_ = 166,                     /* '{'  */
  YYSYMBOL_167_ = 167,                     /* '}'  */
  YYSYMBOL_168_ = 168,                     /* '@'  */
  YYSYMBOL_169_ = 169,                     /* '?'  */
  YYSYMBOL_170_ = 170,                     /* '~'  */
  YYSYMBOL_171_ = 171,                     /* '!'  */
  YYSYMBOL_YYACCEPT = 172,                 /* $accept  */
  YYSYMBOL_input = 173,                    /* input  */
  YYSYMBOL_174_1 = 174,                    /* $@1  */
  YYSYMBOL_design = 175,                   /* design  */
  YYSYMBOL_attr = 176,                     /* attr  */
  YYSYMBOL_177_2 = 177,                    /* $@2  */
  YYSYMBOL_attr_opt = 178,                 /* attr_opt  */
  YYSYMBOL_defattr = 179,                  /* defattr  */
  YYSYMBOL_180_3 = 180,                    /* $@3  */
  YYSYMBOL_181_4 = 181,                    /* $@4  */
  YYSYMBOL_opt_attr_list = 182,            /* opt_attr_list  */
  YYSYMBOL_attr_list = 183,                /* attr_list  */
  YYSYMBOL_attr_assign = 184,              /* attr_assign  */
  YYSYMBOL_hierarchical_id = 185,          /* hierarchical_id  */
  YYSYMBOL_hierarchical_type_id = 186,     /* hierarchical_type_id  */
  YYSYMBOL_module = 187,                   /* module  */
  YYSYMBOL_188_5 = 188,                    /* $@5  */
  YYSYMBOL_189_6 = 189,                    /* $@6  */
  YYSYMBOL_module_para_opt = 190,          /* module_para_opt  */
  YYSYMBOL_191_7 = 191,                    /* $@7  */
  YYSYMBOL_192_8 = 192,                    /* $@8  */
  YYSYMBOL_module_para_list = 193,         /* module_para_list  */
  YYSYMBOL_single_module_para = 194,       /* single_module_para  */
  YYSYMBOL_195_9 = 195,                    /* $@9  */
  YYSYMBOL_196_10 = 196,                   /* $@10  */
  YYSYMBOL_module_args_opt = 197,          /* module_args_opt  */
  YYSYMBOL_module_args = 198,              /* module_args  */
  YYSYMBOL_optional_comma = 199,           /* optional_comma  */
  YYSYMBOL_module_arg_opt_assignment = 200, /* module_arg_opt_assignment  */
  YYSYMBOL_module_arg = 201,               /* module_arg  */
  YYSYMBOL_202_11 = 202,                   /* $@11  */
  YYSYMBOL_203_12 = 203,                   /* $@12  */
  YYSYMBOL_204_13 = 204,                   /* $@13  */
  YYSYMBOL_205_14 = 205,                   /* $@14  */
  YYSYMBOL_package = 206,                  /* package  */
  YYSYMBOL_207_15 = 207,                   /* $@15  */
  YYSYMBOL_208_16 = 208,                   /* $@16  */
  YYSYMBOL_package_body = 209,             /* package_body  */
  YYSYMBOL_package_body_stmt = 210,        /* package_body_stmt  */
  YYSYMBOL_interface = 211,                /* interface  */
  YYSYMBOL_212_17 = 212,                   /* $@17  */
  YYSYMBOL_213_18 = 213,                   /* $@18  */
  YYSYMBOL_interface_body = 214,           /* interface_body  */
  YYSYMBOL_interface_body_stmt = 215,      /* interface_body_stmt  */
  YYSYMBOL_bind_directive = 216,           /* bind_directive  */
  YYSYMBOL_217_19 = 217,                   /* $@19  */
  YYSYMBOL_218_20 = 218,                   /* $@20  */
  YYSYMBOL_219_21 = 219,                   /* $@21  */
  YYSYMBOL_bind_target = 220,              /* bind_target  */
  YYSYMBOL_opt_bind_target_instance_list = 221, /* opt_bind_target_instance_list  */
  YYSYMBOL_bind_target_instance_list = 222, /* bind_target_instance_list  */
  YYSYMBOL_bind_target_instance = 223,     /* bind_target_instance  */
  YYSYMBOL_mintypmax_expr = 224,           /* mintypmax_expr  */
  YYSYMBOL_non_opt_delay = 225,            /* non_opt_delay  */
  YYSYMBOL_delay = 226,                    /* delay  */
  YYSYMBOL_io_wire_type = 227,             /* io_wire_type  */
  YYSYMBOL_228_22 = 228,                   /* $@22  */
  YYSYMBOL_non_io_wire_type = 229,         /* non_io_wire_type  */
  YYSYMBOL_230_23 = 230,                   /* $@23  */
  YYSYMBOL_wire_type = 231,                /* wire_type  */
  YYSYMBOL_wire_type_token_io = 232,       /* wire_type_token_io  */
  YYSYMBOL_wire_type_signedness = 233,     /* wire_type_signedness  */
  YYSYMBOL_wire_type_const_rand = 234,     /* wire_type_const_rand  */
  YYSYMBOL_opt_wire_type_token = 235,      /* opt_wire_type_token  */
  YYSYMBOL_wire_type_token = 236,          /* wire_type_token  */
  YYSYMBOL_logic_type = 237,               /* logic_type  */
  YYSYMBOL_integer_atom_type = 238,        /* integer_atom_type  */
  YYSYMBOL_integer_vector_type = 239,      /* integer_vector_type  */
  YYSYMBOL_non_opt_range = 240,            /* non_opt_range  */
  YYSYMBOL_non_opt_multirange = 241,       /* non_opt_multirange  */
  YYSYMBOL_range = 242,                    /* range  */
  YYSYMBOL_range_or_multirange = 243,      /* range_or_multirange  */
  YYSYMBOL_module_body = 244,              /* module_body  */
  YYSYMBOL_module_body_stmt = 245,         /* module_body_stmt  */
  YYSYMBOL_checker_decl = 246,             /* checker_decl  */
  YYSYMBOL_247_24 = 247,                   /* $@24  */
  YYSYMBOL_task_func_decl = 248,           /* task_func_decl  */
  YYSYMBOL_249_25 = 249,                   /* $@25  */
  YYSYMBOL_250_26 = 250,                   /* $@26  */
  YYSYMBOL_251_27 = 251,                   /* $@27  */
  YYSYMBOL_252_28 = 252,                   /* $@28  */
  YYSYMBOL_253_29 = 253,                   /* $@29  */
  YYSYMBOL_func_return_type = 254,         /* func_return_type  */
  YYSYMBOL_opt_type_vec = 255,             /* opt_type_vec  */
  YYSYMBOL_opt_signedness_default_signed = 256, /* opt_signedness_default_signed  */
  YYSYMBOL_opt_signedness_default_unsigned = 257, /* opt_signedness_default_unsigned  */
  YYSYMBOL_dpi_function_arg = 258,         /* dpi_function_arg  */
  YYSYMBOL_opt_dpi_function_args = 259,    /* opt_dpi_function_args  */
  YYSYMBOL_dpi_function_args = 260,        /* dpi_function_args  */
  YYSYMBOL_opt_automatic = 261,            /* opt_automatic  */
  YYSYMBOL_task_func_args_opt = 262,       /* task_func_args_opt  */
  YYSYMBOL_263_30 = 263,                   /* $@30  */
  YYSYMBOL_264_31 = 264,                   /* $@31  */
  YYSYMBOL_task_func_args = 265,           /* task_func_args  */
  YYSYMBOL_task_func_port = 266,           /* task_func_port  */
  YYSYMBOL_267_32 = 267,                   /* $@32  */
  YYSYMBOL_268_33 = 268,                   /* $@33  */
  YYSYMBOL_task_func_body = 269,           /* task_func_body  */
  YYSYMBOL_specify_block = 270,            /* specify_block  */
  YYSYMBOL_specify_item_list = 271,        /* specify_item_list  */
  YYSYMBOL_specify_item = 272,             /* specify_item  */
  YYSYMBOL_specify_opt_triple = 273,       /* specify_opt_triple  */
  YYSYMBOL_specify_if = 274,               /* specify_if  */
  YYSYMBOL_specify_condition = 275,        /* specify_condition  */
  YYSYMBOL_specify_target = 276,           /* specify_target  */
  YYSYMBOL_specify_edge = 277,             /* specify_edge  */
  YYSYMBOL_specify_rise_fall = 278,        /* specify_rise_fall  */
  YYSYMBOL_specify_triple = 279,           /* specify_triple  */
  YYSYMBOL_ignored_specify_block = 280,    /* ignored_specify_block  */
  YYSYMBOL_ignored_specify_item_opt = 281, /* ignored_specify_item_opt  */
  YYSYMBOL_ignored_specify_item = 282,     /* ignored_specify_item  */
  YYSYMBOL_specparam_declaration = 283,    /* specparam_declaration  */
  YYSYMBOL_specparam_range = 284,          /* specparam_range  */
  YYSYMBOL_list_of_specparam_assignments = 285, /* list_of_specparam_assignments  */
  YYSYMBOL_specparam_assignment = 286,     /* specparam_assignment  */
  YYSYMBOL_ignspec_opt_cond = 287,         /* ignspec_opt_cond  */
  YYSYMBOL_path_declaration = 288,         /* path_declaration  */
  YYSYMBOL_simple_path_declaration = 289,  /* simple_path_declaration  */
  YYSYMBOL_path_delay_value = 290,         /* path_delay_value  */
  YYSYMBOL_list_of_path_delay_extra_expressions = 291, /* list_of_path_delay_extra_expressions  */
  YYSYMBOL_specify_edge_identifier = 292,  /* specify_edge_identifier  */
  YYSYMBOL_parallel_path_description = 293, /* parallel_path_description  */
  YYSYMBOL_full_path_description = 294,    /* full_path_description  */
  YYSYMBOL_list_of_path_inputs = 295,      /* list_of_path_inputs  */
  YYSYMBOL_more_path_inputs = 296,         /* more_path_inputs  */
  YYSYMBOL_list_of_path_outputs = 297,     /* list_of_path_outputs  */
  YYSYMBOL_opt_polarity_operator = 298,    /* opt_polarity_operator  */
  YYSYMBOL_specify_input_terminal_descriptor = 299, /* specify_input_terminal_descriptor  */
  YYSYMBOL_specify_output_terminal_descriptor = 300, /* specify_output_terminal_descriptor  */
  YYSYMBOL_system_timing_declaration = 301, /* system_timing_declaration  */
  YYSYMBOL_system_timing_arg = 302,        /* system_timing_arg  */
  YYSYMBOL_system_timing_args = 303,       /* system_timing_args  */
  YYSYMBOL_ignspec_constant_expression = 304, /* ignspec_constant_expression  */
  YYSYMBOL_ignspec_expr = 305,             /* ignspec_expr  */
  YYSYMBOL_ignspec_id = 306,               /* ignspec_id  */
  YYSYMBOL_307_34 = 307,                   /* $@34  */
  YYSYMBOL_param_signed = 308,             /* param_signed  */
  YYSYMBOL_param_integer = 309,            /* param_integer  */
  YYSYMBOL_param_real = 310,               /* param_real  */
  YYSYMBOL_param_range = 311,              /* param_range  */
  YYSYMBOL_param_integer_type = 312,       /* param_integer_type  */
  YYSYMBOL_param_range_type = 313,         /* param_range_type  */
  YYSYMBOL_param_implicit_type = 314,      /* param_implicit_type  */
  YYSYMBOL_param_type = 315,               /* param_type  */
  YYSYMBOL_param_decl = 316,               /* param_decl  */
  YYSYMBOL_317_35 = 317,                   /* $@35  */
  YYSYMBOL_localparam_decl = 318,          /* localparam_decl  */
  YYSYMBOL_319_36 = 319,                   /* $@36  */
  YYSYMBOL_param_decl_list = 320,          /* param_decl_list  */
  YYSYMBOL_single_param_decl = 321,        /* single_param_decl  */
  YYSYMBOL_single_param_decl_ident = 322,  /* single_param_decl_ident  */
  YYSYMBOL_defparam_decl = 323,            /* defparam_decl  */
  YYSYMBOL_defparam_decl_list = 324,       /* defparam_decl_list  */
  YYSYMBOL_single_defparam_decl = 325,     /* single_defparam_decl  */
  YYSYMBOL_enum_type = 326,                /* enum_type  */
  YYSYMBOL_327_37 = 327,                   /* $@37  */
  YYSYMBOL_enum_base_type = 328,           /* enum_base_type  */
  YYSYMBOL_type_atom = 329,                /* type_atom  */
  YYSYMBOL_type_vec = 330,                 /* type_vec  */
  YYSYMBOL_type_signing = 331,             /* type_signing  */
  YYSYMBOL_enum_name_list = 332,           /* enum_name_list  */
  YYSYMBOL_enum_name_decl = 333,           /* enum_name_decl  */
  YYSYMBOL_opt_enum_init = 334,            /* opt_enum_init  */
  YYSYMBOL_enum_var_list = 335,            /* enum_var_list  */
  YYSYMBOL_enum_var = 336,                 /* enum_var  */
  YYSYMBOL_enum_decl = 337,                /* enum_decl  */
  YYSYMBOL_struct_decl = 338,              /* struct_decl  */
  YYSYMBOL_struct_type = 339,              /* struct_type  */
  YYSYMBOL_340_38 = 340,                   /* $@38  */
  YYSYMBOL_struct_union = 341,             /* struct_union  */
  YYSYMBOL_struct_body = 342,              /* struct_body  */
  YYSYMBOL_opt_packed = 343,               /* opt_packed  */
  YYSYMBOL_opt_signed_struct = 344,        /* opt_signed_struct  */
  YYSYMBOL_struct_member_list = 345,       /* struct_member_list  */
  YYSYMBOL_struct_member = 346,            /* struct_member  */
  YYSYMBOL_member_name_list = 347,         /* member_name_list  */
  YYSYMBOL_member_name = 348,              /* member_name  */
  YYSYMBOL_349_39 = 349,                   /* $@39  */
  YYSYMBOL_struct_member_type = 350,       /* struct_member_type  */
  YYSYMBOL_351_40 = 351,                   /* $@40  */
  YYSYMBOL_member_type_token = 352,        /* member_type_token  */
  YYSYMBOL_353_41 = 353,                   /* $@41  */
  YYSYMBOL_354_42 = 354,                   /* $@42  */
  YYSYMBOL_member_type = 355,              /* member_type  */
  YYSYMBOL_struct_var_list = 356,          /* struct_var_list  */
  YYSYMBOL_struct_var = 357,               /* struct_var  */
  YYSYMBOL_wire_decl = 358,                /* wire_decl  */
  YYSYMBOL_359_43 = 359,                   /* $@43  */
  YYSYMBOL_360_44 = 360,                   /* $@44  */
  YYSYMBOL_361_45 = 361,                   /* $@45  */
  YYSYMBOL_362_46 = 362,                   /* $@46  */
  YYSYMBOL_opt_supply_wires = 363,         /* opt_supply_wires  */
  YYSYMBOL_wire_name_list = 364,           /* wire_name_list  */
  YYSYMBOL_wire_name_and_opt_assign = 365, /* wire_name_and_opt_assign  */
  YYSYMBOL_wire_name = 366,                /* wire_name  */
  YYSYMBOL_assign_stmt = 367,              /* assign_stmt  */
  YYSYMBOL_assign_expr_list = 368,         /* assign_expr_list  */
  YYSYMBOL_assign_expr = 369,              /* assign_expr  */
  YYSYMBOL_type_name = 370,                /* type_name  */
  YYSYMBOL_typedef_decl = 371,             /* typedef_decl  */
  YYSYMBOL_typedef_base_type = 372,        /* typedef_base_type  */
  YYSYMBOL_enum_struct_type = 373,         /* enum_struct_type  */
  YYSYMBOL_cell_stmt = 374,                /* cell_stmt  */
  YYSYMBOL_375_47 = 375,                   /* $@47  */
  YYSYMBOL_376_48 = 376,                   /* $@48  */
  YYSYMBOL_tok_prim_wrapper = 377,         /* tok_prim_wrapper  */
  YYSYMBOL_cell_list = 378,                /* cell_list  */
  YYSYMBOL_single_cell = 379,              /* single_cell  */
  YYSYMBOL_single_cell_no_array = 380,     /* single_cell_no_array  */
  YYSYMBOL_381_49 = 381,                   /* $@49  */
  YYSYMBOL_single_cell_arraylist = 382,    /* single_cell_arraylist  */
  YYSYMBOL_383_50 = 383,                   /* $@50  */
  YYSYMBOL_cell_list_no_array = 384,       /* cell_list_no_array  */
  YYSYMBOL_prim_list = 385,                /* prim_list  */
  YYSYMBOL_single_prim = 386,              /* single_prim  */
  YYSYMBOL_387_51 = 387,                   /* $@51  */
  YYSYMBOL_cell_parameter_list_opt = 388,  /* cell_parameter_list_opt  */
  YYSYMBOL_cell_parameter_list = 389,      /* cell_parameter_list  */
  YYSYMBOL_cell_parameter = 390,           /* cell_parameter  */
  YYSYMBOL_cell_port_list = 391,           /* cell_port_list  */
  YYSYMBOL_cell_port_list_rules = 392,     /* cell_port_list_rules  */
  YYSYMBOL_cell_port = 393,                /* cell_port  */
  YYSYMBOL_always_comb_or_latch = 394,     /* always_comb_or_latch  */
  YYSYMBOL_always_or_always_ff = 395,      /* always_or_always_ff  */
  YYSYMBOL_always_stmt = 396,              /* always_stmt  */
  YYSYMBOL_397_52 = 397,                   /* $@52  */
  YYSYMBOL_398_53 = 398,                   /* $@53  */
  YYSYMBOL_399_54 = 399,                   /* $@54  */
  YYSYMBOL_400_55 = 400,                   /* $@55  */
  YYSYMBOL_always_cond = 401,              /* always_cond  */
  YYSYMBOL_always_events = 402,            /* always_events  */
  YYSYMBOL_always_event = 403,             /* always_event  */
  YYSYMBOL_opt_label = 404,                /* opt_label  */
  YYSYMBOL_opt_sva_label = 405,            /* opt_sva_label  */
  YYSYMBOL_opt_property = 406,             /* opt_property  */
  YYSYMBOL_modport_stmt = 407,             /* modport_stmt  */
  YYSYMBOL_408_56 = 408,                   /* $@56  */
  YYSYMBOL_409_57 = 409,                   /* $@57  */
  YYSYMBOL_modport_args_opt = 410,         /* modport_args_opt  */
  YYSYMBOL_modport_args = 411,             /* modport_args  */
  YYSYMBOL_modport_arg = 412,              /* modport_arg  */
  YYSYMBOL_modport_member = 413,           /* modport_member  */
  YYSYMBOL_modport_type_token = 414,       /* modport_type_token  */
  YYSYMBOL_assert = 415,                   /* assert  */
  YYSYMBOL_assert_property = 416,          /* assert_property  */
  YYSYMBOL_simple_behavioral_stmt = 417,   /* simple_behavioral_stmt  */
  YYSYMBOL_asgn_binop = 418,               /* asgn_binop  */
  YYSYMBOL_for_initialization = 419,       /* for_initialization  */
  YYSYMBOL_behavioral_stmt = 420,          /* behavioral_stmt  */
  YYSYMBOL_421_58 = 421,                   /* $@58  */
  YYSYMBOL_422_59 = 422,                   /* $@59  */
  YYSYMBOL_423_60 = 423,                   /* $@60  */
  YYSYMBOL_424_61 = 424,                   /* $@61  */
  YYSYMBOL_425_62 = 425,                   /* $@62  */
  YYSYMBOL_426_63 = 426,                   /* $@63  */
  YYSYMBOL_427_64 = 427,                   /* $@64  */
  YYSYMBOL_428_65 = 428,                   /* $@65  */
  YYSYMBOL_429_66 = 429,                   /* $@66  */
  YYSYMBOL_430_67 = 430,                   /* $@67  */
  YYSYMBOL_431_68 = 431,                   /* $@68  */
  YYSYMBOL_432_69 = 432,                   /* $@69  */
  YYSYMBOL_case_attr = 433,                /* case_attr  */
  YYSYMBOL_case_type = 434,                /* case_type  */
  YYSYMBOL_opt_synopsys_attr = 435,        /* opt_synopsys_attr  */
  YYSYMBOL_behavioral_stmt_list = 436,     /* behavioral_stmt_list  */
  YYSYMBOL_optional_else = 437,            /* optional_else  */
  YYSYMBOL_438_70 = 438,                   /* $@70  */
  YYSYMBOL_case_body = 439,                /* case_body  */
  YYSYMBOL_case_item = 440,                /* case_item  */
  YYSYMBOL_441_71 = 441,                   /* $@71  */
  YYSYMBOL_442_72 = 442,                   /* $@72  */
  YYSYMBOL_gen_case_body = 443,            /* gen_case_body  */
  YYSYMBOL_gen_case_item = 444,            /* gen_case_item  */
  YYSYMBOL_445_73 = 445,                   /* $@73  */
  YYSYMBOL_446_74 = 446,                   /* $@74  */
  YYSYMBOL_case_select = 447,              /* case_select  */
  YYSYMBOL_case_expr_list = 448,           /* case_expr_list  */
  YYSYMBOL_rvalue = 449,                   /* rvalue  */
  YYSYMBOL_lvalue = 450,                   /* lvalue  */
  YYSYMBOL_lvalue_concat_list = 451,       /* lvalue_concat_list  */
  YYSYMBOL_opt_arg_list = 452,             /* opt_arg_list  */
  YYSYMBOL_arg_list = 453,                 /* arg_list  */
  YYSYMBOL_arg_list2 = 454,                /* arg_list2  */
  YYSYMBOL_single_arg = 455,               /* single_arg  */
  YYSYMBOL_module_gen_body = 456,          /* module_gen_body  */
  YYSYMBOL_gen_stmt_or_module_body_stmt = 457, /* gen_stmt_or_module_body_stmt  */
  YYSYMBOL_genvar_identifier = 458,        /* genvar_identifier  */
  YYSYMBOL_genvar_initialization = 459,    /* genvar_initialization  */
  YYSYMBOL_gen_stmt = 460,                 /* gen_stmt  */
  YYSYMBOL_461_75 = 461,                   /* $@75  */
  YYSYMBOL_462_76 = 462,                   /* $@76  */
  YYSYMBOL_463_77 = 463,                   /* $@77  */
  YYSYMBOL_464_78 = 464,                   /* $@78  */
  YYSYMBOL_465_79 = 465,                   /* $@79  */
  YYSYMBOL_gen_block = 466,                /* gen_block  */
  YYSYMBOL_467_80 = 467,                   /* $@80  */
  YYSYMBOL_468_81 = 468,                   /* $@81  */
  YYSYMBOL_gen_stmt_block = 469,           /* gen_stmt_block  */
  YYSYMBOL_470_82 = 470,                   /* $@82  */
  YYSYMBOL_opt_gen_else = 471,             /* opt_gen_else  */
  YYSYMBOL_expr = 472,                     /* expr  */
  YYSYMBOL_basic_expr = 473,               /* basic_expr  */
  YYSYMBOL_474_83 = 474,                   /* $@83  */
  YYSYMBOL_concat_list = 475,              /* concat_list  */
  YYSYMBOL_integral_number = 476           /* integral_number  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL \
             && defined FRONTEND_VERILOG_YYSTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2872

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  172
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  305
/* YYNRULES -- Number of rules.  */
#define YYNRULES  689
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1329

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   400


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   171,     2,   162,     2,   151,   133,     2,
     159,   160,   149,   147,   156,   148,   158,   150,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   163,   161,
     139,   157,   142,   169,   168,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   164,     2,   165,   131,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   166,   129,   167,   170,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   130,   132,   134,   135,   136,   137,
     138,   140,   141,   143,   144,   145,   146,   152,   153,   154,
     155
};

#if FRONTEND_VERILOG_YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   417,   417,   417,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   441,   441,   457,   460,   463,   470,
     463,   481,   481,   484,   485,   488,   494,   502,   505,   513,
     523,   524,   525,   529,   531,   529,   556,   556,   556,   556,
     559,   559,   562,   563,   563,   569,   569,   575,   578,   578,
     578,   581,   581,   584,   584,   587,   605,   608,   608,   622,
     627,   622,   637,   637,   653,   658,   660,   658,   677,   677,
     680,   680,   680,   680,   683,   685,   683,   706,   706,   709,
     709,   709,   709,   709,   709,   709,   710,   710,   713,   718,
     722,   713,   750,   755,   756,   759,   760,   765,   773,   774,
     777,   778,   779,   780,   781,   782,   785,   785,   788,   788,
     793,   793,   798,   799,   802,   805,   808,   814,   815,   816,
     819,   823,   826,   829,   832,   832,   835,   838,   842,   844,
     847,   850,   854,   857,   860,   863,   872,   874,   879,   884,
     885,   886,   887,   888,   891,   892,   895,   900,   906,   912,
     918,   921,   927,   930,   935,   936,   939,   941,   942,   943,
     944,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   948,   948,   948,   949,   949,   949,   949,   949,   949,
     952,   952,   963,   963,   973,   973,   984,   984,   996,   996,
    1008,  1008,  1033,  1038,  1041,  1045,  1050,  1051,  1052,  1056,
    1057,  1058,  1061,  1062,  1063,  1067,  1072,  1078,  1079,  1082,
    1083,  1084,  1085,  1088,  1089,  1092,  1092,  1092,  1096,  1092,
    1104,  1104,  1107,  1107,  1128,  1128,  1142,  1143,  1148,  1151,
    1152,  1155,  1239,  1313,  1316,  1321,  1324,  1329,  1332,  1337,
    1343,  1349,  1355,  1363,  1364,  1365,  1368,  1376,  1383,  1392,
    1404,  1424,  1430,  1440,  1441,  1444,  1445,  1448,  1451,  1452,
    1456,  1457,  1463,  1466,  1466,  1469,  1472,  1472,  1475,  1481,
    1482,  1486,  1487,  1488,  1492,  1493,  1497,  1497,  1500,  1501,
    1502,  1505,  1506,  1507,  1511,  1512,  1515,  1516,  1519,  1520,
    1523,  1523,  1523,  1527,  1531,  1534,  1537,  1538,  1539,  1542,
    1543,  1544,  1551,  1554,  1555,  1562,  1562,  1568,  1570,  1572,
    1575,  1580,  1585,  1591,  1593,  1596,  1599,  1602,  1602,  1602,
    1602,  1603,  1611,  1611,  1620,  1620,  1629,  1629,  1632,  1638,
    1651,  1668,  1671,  1671,  1674,  1687,  1687,  1710,  1711,  1712,
    1716,  1722,  1723,  1727,  1728,  1729,  1732,  1733,  1737,  1752,
    1753,  1757,  1758,  1761,  1773,  1780,  1783,  1783,  1787,  1788,
    1791,  1795,  1796,  1799,  1800,  1801,  1804,  1805,  1808,  1812,
    1813,  1816,  1816,  1825,  1825,  1829,  1830,  1847,  1849,  1847,
    1861,  1862,  1865,  1866,  1869,  1882,  1886,  1882,  1892,  1892,
    1900,  1900,  1910,  1911,  1922,  1922,  1925,  1967,  1995,  2041,
    2044,  2044,  2047,  2053,  2054,  2058,  2071,  2075,  2080,  2089,
    2098,  2099,  2103,  2103,  2112,  2112,  2122,  2125,  2130,  2131,
    2134,  2134,  2137,  2137,  2148,  2148,  2159,  2160,  2163,  2164,
    2167,  2168,  2168,  2176,  2176,  2179,  2179,  2182,  2183,  2188,
    2191,  2200,  2227,  2227,  2230,  2235,  2241,  2249,  2256,  2265,
    2273,  2276,  2281,  2284,  2289,  2296,  2289,  2309,  2309,  2325,
    2325,  2339,  2340,  2341,  2342,  2343,  2344,  2347,  2348,  2349,
    2352,  2358,  2364,  2371,  2374,  2379,  2382,  2387,  2390,  2393,
    2398,  2404,  2398,  2410,  2410,  2413,  2413,  2416,  2417,  2420,
    2430,  2430,  2433,  2446,  2459,  2472,  2485,  2494,  2503,  2512,
    2527,  2544,  2553,  2562,  2571,  2580,  2589,  2602,  2617,  2623,
    2629,  2635,  2641,  2657,  2658,  2659,  2660,  2661,  2662,  2663,
    2664,  2665,  2666,  2667,  2668,  2671,  2678,  2681,  2719,  2719,
    2719,  2719,  2719,  2719,  2720,  2721,  2722,  2725,  2725,  2735,
    2735,  2745,  2747,  2745,  2772,  2777,  2779,  2772,  2790,  2790,
    2804,  2804,  2818,  2829,  2818,  2836,  2836,  2849,  2852,  2856,
    2860,  2867,  2870,  2873,  2878,  2882,  2886,  2889,  2890,  2893,
    2893,  2904,  2907,  2908,  2911,  2917,  2911,  2930,  2931,  2934,
    2940,  2934,  2949,  2950,  2953,  2958,  2965,  2968,  2973,  2978,
    2988,  2996,  2999,  3004,  3008,  3014,  3015,  3018,  3019,  3022,
    3023,  3026,  3031,  3032,  3033,  3036,  3036,  3037,  3042,  3049,
    3052,  3068,  3076,  3080,  3076,  3087,  3087,  3096,  3096,  3105,
    3105,  3117,  3119,  3117,  3135,  3135,  3142,  3145,  3145,  3148,
    3151,  3161,  3164,  3174,  3188,  3195,  3207,  3212,  3212,  3223,
    3227,  3231,  3234,  3239,  3242,  3245,  3250,  3255,  3260,  3265,
    3270,  3275,  3280,  3285,  3291,  3296,  3303,  3308,  3313,  3318,
    3323,  3328,  3333,  3338,  3343,  3348,  3353,  3358,  3363,  3368,
    3373,  3378,  3383,  3388,  3393,  3398,  3403,  3408,  3413,  3418,
    3423,  3428,  3434,  3440,  3448,  3451,  3457,  3458,  3459,  3464
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_STRING", "TOK_ID",
  "TOK_CONSTVAL", "TOK_REALVAL", "TOK_PRIMITIVE", "TOK_SVA_LABEL",
  "TOK_SPECIFY_OPER", "TOK_MSG_TASKS", "TOK_BASE", "TOK_BASED_CONSTVAL",
  "TOK_UNBASED_UNSIZED_CONSTVAL", "TOK_USER_TYPE", "TOK_PKG_USER_TYPE",
  "TOK_ASSERT", "TOK_ASSUME", "TOK_RESTRICT", "TOK_COVER", "TOK_FINAL",
  "ATTR_BEGIN", "ATTR_END", "DEFATTR_BEGIN", "DEFATTR_END", "TOK_MODULE",
  "TOK_ENDMODULE", "TOK_PARAMETER", "TOK_LOCALPARAM", "TOK_DEFPARAM",
  "TOK_PACKAGE", "TOK_ENDPACKAGE", "TOK_PACKAGESEP", "TOK_INTERFACE",
  "TOK_ENDINTERFACE", "TOK_MODPORT", "TOK_VAR", "TOK_WILDCARD_CONNECT",
  "TOK_INPUT", "TOK_OUTPUT", "TOK_INOUT", "TOK_WIRE", "TOK_WAND",
  "TOK_WOR", "TOK_REG", "TOK_LOGIC", "TOK_INTEGER", "TOK_SIGNED",
  "TOK_ASSIGN", "TOK_ALWAYS", "TOK_INITIAL", "TOK_ALWAYS_FF",
  "TOK_ALWAYS_COMB", "TOK_ALWAYS_LATCH", "TOK_BEGIN", "TOK_END", "TOK_IF",
  "TOK_ELSE", "TOK_FOR", "TOK_WHILE", "TOK_REPEAT", "TOK_DPI_FUNCTION",
  "TOK_POSEDGE", "TOK_NEGEDGE", "TOK_OR", "TOK_AUTOMATIC", "TOK_CASE",
  "TOK_CASEX", "TOK_CASEZ", "TOK_ENDCASE", "TOK_DEFAULT", "TOK_FUNCTION",
  "TOK_ENDFUNCTION", "TOK_TASK", "TOK_ENDTASK", "TOK_SPECIFY",
  "TOK_IGNORED_SPECIFY", "TOK_ENDSPECIFY", "TOK_SPECPARAM",
  "TOK_SPECIFY_AND", "TOK_IGNORED_SPECIFY_AND", "TOK_GENERATE",
  "TOK_ENDGENERATE", "TOK_GENVAR", "TOK_REAL", "TOK_SYNOPSYS_FULL_CASE",
  "TOK_SYNOPSYS_PARALLEL_CASE", "TOK_SUPPLY0", "TOK_SUPPLY1",
  "TOK_TO_SIGNED", "TOK_TO_UNSIGNED", "TOK_POS_INDEXED", "TOK_NEG_INDEXED",
  "TOK_PROPERTY", "TOK_ENUM", "TOK_TYPEDEF", "TOK_RAND", "TOK_CONST",
  "TOK_CHECKER", "TOK_ENDCHECKER", "TOK_EVENTUALLY", "TOK_INCREMENT",
  "TOK_DECREMENT", "TOK_UNIQUE", "TOK_UNIQUE0", "TOK_PRIORITY",
  "TOK_STRUCT", "TOK_PACKED", "TOK_UNSIGNED", "TOK_INT", "TOK_BYTE",
  "TOK_SHORTINT", "TOK_LONGINT", "TOK_UNION", "TOK_BIT_OR_ASSIGN",
  "TOK_BIT_AND_ASSIGN", "TOK_BIT_XOR_ASSIGN", "TOK_ADD_ASSIGN",
  "TOK_SUB_ASSIGN", "TOK_DIV_ASSIGN", "TOK_MOD_ASSIGN", "TOK_MUL_ASSIGN",
  "TOK_SHL_ASSIGN", "TOK_SHR_ASSIGN", "TOK_SSHL_ASSIGN", "TOK_SSHR_ASSIGN",
  "TOK_BIND", "OP_LOR", "OP_LAND", "'|'", "OP_NOR", "'^'", "OP_XNOR",
  "'&'", "OP_NAND", "OP_EQ", "OP_NE", "OP_EQX", "OP_NEX", "'<'", "OP_LE",
  "OP_GE", "'>'", "OP_SHL", "OP_SHR", "OP_SSHL", "OP_SSHR", "'+'", "'-'",
  "'*'", "'/'", "'%'", "OP_POW", "OP_CAST", "UNARY_OPS", "FAKE_THEN",
  "','", "'='", "'.'", "'('", "')'", "';'", "'#'", "':'", "'['", "']'",
  "'{'", "'}'", "'@'", "'?'", "'~'", "'!'", "$accept", "input", "$@1",
  "design", "attr", "$@2", "attr_opt", "defattr", "$@3", "$@4",
  "opt_attr_list", "attr_list", "attr_assign", "hierarchical_id",
  "hierarchical_type_id", "module", "$@5", "$@6", "module_para_opt", "$@7",
  "$@8", "module_para_list", "single_module_para", "$@9", "$@10",
  "module_args_opt", "module_args", "optional_comma",
  "module_arg_opt_assignment", "module_arg", "$@11", "$@12", "$@13",
  "$@14", "package", "$@15", "$@16", "package_body", "package_body_stmt",
  "interface", "$@17", "$@18", "interface_body", "interface_body_stmt",
  "bind_directive", "$@19", "$@20", "$@21", "bind_target",
  "opt_bind_target_instance_list", "bind_target_instance_list",
  "bind_target_instance", "mintypmax_expr", "non_opt_delay", "delay",
  "io_wire_type", "$@22", "non_io_wire_type", "$@23", "wire_type",
  "wire_type_token_io", "wire_type_signedness", "wire_type_const_rand",
  "opt_wire_type_token", "wire_type_token", "logic_type",
  "integer_atom_type", "integer_vector_type", "non_opt_range",
  "non_opt_multirange", "range", "range_or_multirange", "module_body",
  "module_body_stmt", "checker_decl", "$@24", "task_func_decl", "$@25",
  "$@26", "$@27", "$@28", "$@29", "func_return_type", "opt_type_vec",
  "opt_signedness_default_signed", "opt_signedness_default_unsigned",
  "dpi_function_arg", "opt_dpi_function_args", "dpi_function_args",
  "opt_automatic", "task_func_args_opt", "$@30", "$@31", "task_func_args",
  "task_func_port", "$@32", "$@33", "task_func_body", "specify_block",
  "specify_item_list", "specify_item", "specify_opt_triple", "specify_if",
  "specify_condition", "specify_target", "specify_edge",
  "specify_rise_fall", "specify_triple", "ignored_specify_block",
  "ignored_specify_item_opt", "ignored_specify_item",
  "specparam_declaration", "specparam_range",
  "list_of_specparam_assignments", "specparam_assignment",
  "ignspec_opt_cond", "path_declaration", "simple_path_declaration",
  "path_delay_value", "list_of_path_delay_extra_expressions",
  "specify_edge_identifier", "parallel_path_description",
  "full_path_description", "list_of_path_inputs", "more_path_inputs",
  "list_of_path_outputs", "opt_polarity_operator",
  "specify_input_terminal_descriptor",
  "specify_output_terminal_descriptor", "system_timing_declaration",
  "system_timing_arg", "system_timing_args", "ignspec_constant_expression",
  "ignspec_expr", "ignspec_id", "$@34", "param_signed", "param_integer",
  "param_real", "param_range", "param_integer_type", "param_range_type",
  "param_implicit_type", "param_type", "param_decl", "$@35",
  "localparam_decl", "$@36", "param_decl_list", "single_param_decl",
  "single_param_decl_ident", "defparam_decl", "defparam_decl_list",
  "single_defparam_decl", "enum_type", "$@37", "enum_base_type",
  "type_atom", "type_vec", "type_signing", "enum_name_list",
  "enum_name_decl", "opt_enum_init", "enum_var_list", "enum_var",
  "enum_decl", "struct_decl", "struct_type", "$@38", "struct_union",
  "struct_body", "opt_packed", "opt_signed_struct", "struct_member_list",
  "struct_member", "member_name_list", "member_name", "$@39",
  "struct_member_type", "$@40", "member_type_token", "$@41", "$@42",
  "member_type", "struct_var_list", "struct_var", "wire_decl", "$@43",
  "$@44", "$@45", "$@46", "opt_supply_wires", "wire_name_list",
  "wire_name_and_opt_assign", "wire_name", "assign_stmt",
  "assign_expr_list", "assign_expr", "type_name", "typedef_decl",
  "typedef_base_type", "enum_struct_type", "cell_stmt", "$@47", "$@48",
  "tok_prim_wrapper", "cell_list", "single_cell", "single_cell_no_array",
  "$@49", "single_cell_arraylist", "$@50", "cell_list_no_array",
  "prim_list", "single_prim", "$@51", "cell_parameter_list_opt",
  "cell_parameter_list", "cell_parameter", "cell_port_list",
  "cell_port_list_rules", "cell_port", "always_comb_or_latch",
  "always_or_always_ff", "always_stmt", "$@52", "$@53", "$@54", "$@55",
  "always_cond", "always_events", "always_event", "opt_label",
  "opt_sva_label", "opt_property", "modport_stmt", "$@56", "$@57",
  "modport_args_opt", "modport_args", "modport_arg", "modport_member",
  "modport_type_token", "assert", "assert_property",
  "simple_behavioral_stmt", "asgn_binop", "for_initialization",
  "behavioral_stmt", "$@58", "$@59", "$@60", "$@61", "$@62", "$@63",
  "$@64", "$@65", "$@66", "$@67", "$@68", "$@69", "case_attr", "case_type",
  "opt_synopsys_attr", "behavioral_stmt_list", "optional_else", "$@70",
  "case_body", "case_item", "$@71", "$@72", "gen_case_body",
  "gen_case_item", "$@73", "$@74", "case_select", "case_expr_list",
  "rvalue", "lvalue", "lvalue_concat_list", "opt_arg_list", "arg_list",
  "arg_list2", "single_arg", "module_gen_body",
  "gen_stmt_or_module_body_stmt", "genvar_identifier",
  "genvar_initialization", "gen_stmt", "$@75", "$@76", "$@77", "$@78",
  "$@79", "gen_block", "$@80", "$@81", "gen_stmt_block", "$@82",
  "opt_gen_else", "expr", "basic_expr", "$@83", "concat_list",
  "integral_number", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   124,
     384,    94,   385,    38,   386,   387,   388,   389,   390,    60,
     391,   392,    62,   393,   394,   395,   396,    43,    45,    42,
      47,    37,   397,   398,   399,   400,    44,    61,    46,    40,
      41,    59,    35,    58,    91,    93,   123,   125,    64,    63,
     126,    33
};
#endif

#define YYPACT_NINF (-1008)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-585)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1008,   126,   328, -1008, -1008, -1008,   743, -1008, -1008,   461,
   -1008,   328,   328,   328,   328,   328,   328,   328,   328,   328,
     144,   156, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008,
   -1008, -1008, -1008, -1008,   167, -1008,    58,    59, -1008, -1008,
   -1008,    -1,   312,   144, -1008, -1008, -1008, -1008,   242,   235,
     235,   298, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008,
   -1008, -1008, -1008,   176, -1008,    87, -1008,   562,   193, -1008,
   -1008, -1008, -1008, -1008, -1008,   255,  1956, -1008,   312, -1008,
   -1008,   210,    66, -1008,   226,   409,   777,   777,   415,    71,
   -1008,   771,   426,   144,   429,   144,   458,  1956,   464,   270,
   -1008, -1008, -1008,   348,    74,    74, -1008,    90, -1008,   361,
   -1008,   495, -1008,   524, -1008,   396, -1008, -1008,   399, -1008,
   -1008, -1008, -1008, -1008, -1008, -1008, -1008,  1956,  1956, -1008,
   -1008,   218, -1008,    70,  2562, -1008,    -1, -1008,   561,   144,
   -1008, -1008, -1008, -1008, -1008, -1008,    -1,   111, -1008, -1008,
   -1008, -1008,   568, -1008,   111,   568, -1008, -1008,   570,   578,
   -1008, -1008, -1008,    58,   581,    59, -1008,   576, -1008, -1008,
   -1008, -1008, -1008,   444,   453,   610, -1008, -1008, -1008,    -1,
   -1008, -1008, -1008, -1008,   626, -1008,   506,   509,   533,   535,
    1956,  1956,  1956,  1956,  1956,  1956,  1956,  1956,   243,   164,
     477,  1956,  1956,  1956, -1008,    -1,    -1, -1008, -1008,  1956,
    1956,  1956, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008,
   -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008,
   -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008,   544,
   -1008,    -1, -1008,   552, -1008,   572, -1008,   270, -1008, -1008,
   -1008, -1008,   188, -1008,   573,    -1,   222,   593,   575,   758,
     609, -1008, -1008,    -1,   611, -1008, -1008,   103,   608,   615,
     617, -1008, -1008,   612, -1008,   776,   799, -1008,  1956,  1956,
    1956,  1956, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008,
     488,  1956,  1956,  1956, -1008, -1008, -1008,   205,   622, -1008,
   -1008,   618,   619,   628,  1956,  1956,  1956,  1956,  1956,  1956,
    1956,  1956,  1956,  1956,  1956,  1956,  1956,  1956,  1956,  1956,
    1956,  1956,  1956,  1956,  1956,  1956,  1956,  1956,  1956,  1956,
    1956,  1956, -1008,   620,   144,   453,   568, -1008,  1956, -1008,
   -1008, -1008,   791,   636, -1008,   794,   611, -1008,   641,   639,
      76,   798,   645, -1008,   637,   649, -1008, -1008,  1956, -1008,
     610,   651, -1008, -1008, -1008,   284, -1008, -1008,    74,    74,
   -1008,   212, -1008,   659,   667,   668,   669, -1008,   663,   674,
   -1008,   665,   675,  1956, -1008, -1008, -1008,  2631,  2656,  2679,
    2679,  2700,  2700,  2719,  2719,  1699,  1699,  1699,  1699,   510,
     510,   510,   510,   591,   591,   591,   591,   537,   537,   364,
     364,   364,   681,   676,   672,   679,   835, -1008,   680, -1008,
   -1008,    69,   836, -1008,   178, -1008,   575,   843,   689, -1008,
     847, -1008,   238,   701, -1008, -1008,   703,   858,   705, -1008,
     644, -1008,   376,    -1,   151,   704,   442,  2605, -1008, -1008,
      -1,   776, -1008, -1008,    -1, -1008, -1008, -1008, -1008, -1008,
    1956,   717,   144,   734, -1008, -1008, -1008, -1008,  1956,  1124,
   -1008, -1008,   326, -1008,   728,   387, -1008, -1008, -1008, -1008,
   -1008, -1008,   791, -1008,   731, -1008, -1008,   637,   737, -1008,
     890,   323, -1008, -1008,    76,   736,  1956, -1008, -1008, -1008,
   -1008, -1008, -1008,   376,   801, -1008,   666,   896, -1008, -1008,
      -1, -1008,   897,   741,   582, -1008, -1008, -1008, -1008, -1008,
   -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008,   255,   744,
   -1008,    29, -1008,  1956,   745, -1008,   902,   299, -1008, -1008,
     748,   835, -1008,  2266,   908, -1008, -1008, -1008,   575,   340,
      -1,    81, -1008,    -1, -1008,   750, -1008,   146,  2212, -1008,
     408, -1008, -1008, -1008, -1008,   631, -1008,   753, -1008,   638,
     777,   777, -1008, -1008, -1008,   703,   666, -1008,  1176,  1228,
   -1008, -1008, -1008, -1008, -1008, -1008,   246, -1008, -1008, -1008,
     144,   354, -1008, -1008, -1008,    55, -1008, -1008, -1008, -1008,
   -1008,   911,   914,    -1, -1008, -1008, -1008, -1008, -1008, -1008,
     760,  1124, -1008, -1008, -1008, -1008,   728, -1008,   761,   763,
   -1008, -1008, -1008,   153,   309,    56, -1008,   920, -1008,  2600,
   -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008,
   -1008,   921, -1008, -1008,   922, -1008, -1008, -1008, -1008, -1008,
     682, -1008,   768, -1008, -1008, -1008,   770, -1008, -1008, -1008,
     772, -1008, -1008, -1008, -1008, -1008,  1956, -1008, -1008,   774,
     778,   779,   780, -1008, -1008, -1008, -1008,  1956,    49, -1008,
    1489, -1008,   102,   102,   102,   149, -1008,   781,   568,   568,
   -1008,   246, -1008, -1008, -1008, -1008, -1008, -1008, -1008,   703,
     784,    -1, -1008,   783,   370, -1008,   787,   408, -1008, -1008,
   -1008,   408,   767,  1488, -1008,   985,   785,   790, -1008,   788,
   -1008,   728,  1956, -1008,   789,   792,   875,   153,   795, -1008,
     796, -1008,   313, -1008, -1008,   797, -1008,   800, -1008,   803,
    1956,   949,   377, -1008,   802,  2394,   805, -1008, -1008, -1008,
     741, -1008,   386, -1008, -1008,   417, -1008,   864,   867,   871,
     876,  1956, -1008,   890, -1008,   352,   807,   788,   728,  1956,
   -1008,  1956,  1956,   810,   812,   788, -1008, -1008, -1008, -1008,
   -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008,
     741,   741,   741, -1008, -1008,   813,   815,   820, -1008,   821,
    1956, -1008, -1008, -1008, -1008,  1956, -1008,    91, -1008,    55,
   -1008,  1956, -1008, -1008, -1008,   741, -1008,   165, -1008, -1008,
     822, -1008,   977, -1008, -1008, -1008,  1956,   823, -1008,   825,
     113,   467,  1956, -1008, -1008,   467,    -1,  1956, -1008, -1008,
     304,   826,   829, -1008,   589,   824, -1008,   419,   949, -1008,
    1956, -1008,  1000, -1008, -1008, -1008, -1008, -1008,   620, -1008,
     921, -1008,   922, -1008,   833,   834,   838,   844,   842, -1008,
    1956, -1008,  1956,   845, -1008,   848,   990,   850,   851, -1008,
    1956,   852,  1956,  1956,  1956,  1555,  1620,  1666,  1726,   856,
   -1008, -1008, -1008, -1008, -1008,   849, -1008, -1008,  1011,   857,
   -1008, -1008,   425,   428,   890,   860, -1008,  1319,   408, -1008,
     862, -1008,   734, -1008, -1008, -1008, -1008,  1013,   866,   863,
   -1008, -1008,  1956,   865,  1956, -1008,   870,   868, -1008, -1008,
     949,   884,   357, -1008,  2002,  2002,   949,   949, -1008,   173,
   -1008,  1956, -1008, -1008, -1008, -1008, -1008,  1030,  1030, -1008,
   -1008,  1772,  1818,  1864,  1956, -1008,   406,   872, -1008, -1008,
   -1008,   879,    -1,   880, -1008, -1008, -1008, -1008, -1008, -1008,
   -1008,  1956,   877,  1956,   882,  1956,   883,   885,   888, -1008,
     395,   894, -1008, -1008,  1040, -1008, -1008,   889, -1008,   899,
   -1008, -1008,  1956,  1956,   898,    92, -1008, -1008, -1008,  1910,
     900,  2486,  1003,   905,  1956,  1956,   980, -1008,  1054, -1008,
    1956,   916,   322,   924, -1008, -1008,   949,   372,   910,  1956,
   -1008,   912, -1008, -1008, -1008,   589,   589,   909,   904,  2340,
      -1,   435, -1008, -1008, -1008, -1008,   443, -1008,   913,  1956,
     917,  1956,   918,  1956,   925,   926, -1008,  1956, -1008,  1956,
     356,   408,  1956,  1076,  1956,   408,   408,   929,   931,   930,
     933,   935,   936, -1008,   938, -1008, -1008, -1008, -1008,   890,
     939,  1956, -1008, -1008, -1008,  1350,  1350, -1008, -1008,   941,
   -1008,   728, -1008,  1024,  2520,  1956, -1008, -1008,  1956,   940,
    2048,   942,   961,   965, -1008,   949, -1008,   949, -1008,   966,
     912,   287,  1956, -1008, -1008, -1008, -1008, -1008, -1008, -1008,
    1030, -1008,  1030, -1008, -1008,   951,   948,   952,   960,   953,
     962,   963,  1053,   971, -1008,   728, -1008, -1008, -1008,   968,
   -1008, -1008, -1008,   973, -1008,   975, -1008,   978, -1008, -1008,
     640, -1008, -1008, -1008, -1008, -1008, -1008, -1008,  1003, -1008,
   -1008, -1008,   979, -1008,   467,  1956,   981, -1008,  1956,   983,
     986,   457, -1008, -1008, -1008,   949,   987,  1956,   912,   991,
   -1008, -1008,   989,   996, -1008,   997, -1008,  1001, -1008, -1008,
   -1008, -1008,  1417, -1008, -1008,  1089,  1956,  1004, -1008, -1008,
   -1008, -1008, -1008,  1095, -1008, -1008,  1956,   289,  1009, -1008,
     949,   949,   949, -1008,  1007, -1008,  1006, -1008, -1008, -1008,
   -1008, -1008, -1008, -1008,   -32, -1008,     9, -1008, -1008, -1008,
   -1008, -1008, -1008, -1008,  1417,    55,  1010,   980,  1956,  1956,
    1956,  2094,   261,   294, -1008, -1008,  1956,  1012,  1003,  1956,
   -1008,   408,  1014, -1008,  1003,  1019,  1016,  1018,   320,  1956,
    1031, -1008,  1017,  1956,  1032,  1956,  1034,   744, -1008, -1008,
   -1008, -1008, -1008,   408, -1008,  1956, -1008, -1008, -1008,  1043,
     334, -1008,  1956,  1041,  1956,  1042,  1956,   408, -1008,  1047,
    1956,  1956,  1044,  1048,  1049,  1050,  1051, -1008,  1956,  1052,
     459,  1055,  1956, -1008,  1057, -1008,  1059, -1008,  1062,  1956,
   -1008,  1956, -1008, -1008, -1008, -1008,   468,   744,  1956, -1008,
    1068,  1956,  1070,  1956,   485,  1956, -1008,  1071,  1956,  1072,
    1956,  1073,  1956,  1074,  1956,  1075,  1956,  1077, -1008
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,    14,     1,    18,    74,     0,    88,     3,     0,
      17,    14,    14,    14,    14,    14,    14,    14,    14,    14,
      22,     0,    30,    31,   145,   144,   139,   335,   358,   140,
     143,   141,   142,   359,     0,   407,   199,   202,   410,   411,
     356,   153,     0,     0,    33,   322,   324,    65,     0,   214,
     214,    15,     5,     4,    10,    11,    12,     6,     7,     8,
       9,    27,    19,    21,    23,    25,    75,   339,     0,   200,
     201,   409,   203,   204,   408,   362,     0,   152,     0,   403,
     404,     0,    97,    89,    94,     0,   309,   309,     0,     0,
     213,   196,     0,    22,     0,     0,     0,     0,     0,    39,
     341,   342,   340,     0,   345,   345,    32,   365,   357,     0,
     636,   686,   635,     0,   687,     0,    14,    14,     0,    14,
      14,    14,    14,    14,    14,    14,    14,     0,     0,    14,
      14,   153,   631,     0,   629,   634,   153,   406,     0,     0,
      92,    34,   307,   311,   308,   321,   153,   309,   318,   317,
     319,   320,     0,   310,   309,     0,    66,   182,     0,     0,
     197,   198,   192,   199,     0,   202,   188,     0,    20,    24,
      28,    26,    29,     0,    49,     0,   343,   344,   337,   153,
     363,   364,   361,   373,     0,   688,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   684,
       0,     0,     0,     0,   637,   152,   590,   589,   633,     0,
       0,     0,   149,    14,    14,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    14,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    14,    14,    14,    14,    14,     0,
      14,   155,   154,     0,    90,    93,    95,    39,   312,   316,
     313,   330,     0,   326,   329,   314,     0,     0,   208,     0,
       0,   195,   190,   193,   216,    16,    36,    14,     0,   350,
      54,   346,   338,   373,   366,     0,   377,   689,     0,     0,
       0,     0,   654,   655,   656,   657,   652,   653,   676,   677,
     641,     0,     0,     0,   643,   645,   680,     0,     0,   150,
     151,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   405,   434,     0,    49,     0,   323,     0,   315,
     325,    69,   212,     0,   184,     0,   216,   194,   217,     0,
      14,    57,     0,    48,   110,    54,    51,    78,     0,   348,
      53,     0,   360,   367,   371,     0,   369,   376,   345,   345,
     374,     0,   375,     0,     0,     0,     0,   632,     0,   684,
     685,     0,   149,   598,   147,   148,   146,   679,   678,   648,
     649,   650,   651,   646,   647,   664,   665,   666,   667,   662,
     663,   668,   669,   658,   659,   660,   661,   670,   671,   672,
     673,   674,   675,     0,     0,     0,     0,    96,     0,   327,
     328,    14,   206,   211,     0,   183,   208,     0,     0,   215,
      14,   227,     0,    37,    40,    47,    56,     0,     0,   112,
       0,   113,   123,   153,    14,     0,    14,   349,   347,   336,
     153,     0,   368,   380,   153,   378,   681,   639,   640,   682,
       0,     0,     0,    54,   597,   599,   601,   683,     0,   437,
     422,   426,     0,   160,   474,     0,    68,    73,    72,    71,
      70,   205,   210,   207,     0,   186,   227,   110,    54,   220,
       0,    14,    43,    45,    14,     0,     0,    58,    60,    64,
     114,   115,   116,   123,   122,   121,     0,     0,    52,    50,
     153,    76,     0,   107,   110,    77,    87,    79,    80,    82,
      83,    85,    81,    84,    86,   372,   370,   381,   362,     0,
     644,   153,   588,    53,     0,   630,     0,     0,   435,   438,
       0,     0,    91,    14,     0,    67,   209,   185,   208,    14,
     153,    14,   218,   153,   225,     0,   189,     0,   110,   528,
      14,   531,   532,   530,   533,     0,   529,     0,   226,     0,
     309,   309,    41,    38,    55,    56,   125,   120,   132,   128,
     127,   126,   130,   136,   135,   138,   119,   134,   137,    62,
       0,     0,   332,   480,   106,     0,   452,   459,   453,   450,
     451,     0,     0,   153,   457,   454,   379,   642,   600,   638,
       0,   437,   433,    14,   427,   619,   474,   621,     0,     0,
     561,   562,   563,   230,   267,     0,   604,     0,   159,   110,
     176,   173,   156,   178,   161,   162,   179,   167,   163,   164,
     166,     0,   171,   172,     0,   168,   169,   165,   170,   174,
       0,   177,     0,   157,   158,   473,     0,   191,   222,   221,
       0,   398,   475,   100,   101,   102,     0,   539,   541,     0,
       0,     0,     0,   560,   558,   559,   536,     0,   153,   591,
       0,   534,   479,   479,   479,   479,   535,     0,     0,     0,
      61,   119,   124,   131,   133,   129,   117,   118,   111,    56,
       0,   153,   331,     0,     0,   400,     0,    14,   388,   390,
     385,    14,   466,     0,   436,   444,     0,   441,   442,   596,
      35,   474,     0,   612,     0,     0,     0,   230,     0,   305,
       0,   254,   267,   256,   257,     0,   258,     0,   259,     0,
       0,     0,     0,   263,     0,    14,     0,   412,   416,   417,
     107,   353,     0,   351,   384,     0,   382,     0,     0,     0,
       0,     0,   187,     0,   219,     0,    98,   596,   474,     0,
     544,     0,     0,     0,   593,   596,   509,   510,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     107,   107,   107,   478,   477,     0,     0,     0,   498,     0,
       0,    44,    46,   109,    63,     0,   333,     0,   481,     0,
     399,     0,   460,   392,   392,   107,   458,     0,   455,   439,
       0,   449,     0,   445,   423,    14,   598,     0,   622,     0,
       0,   245,     0,   228,   229,   245,   153,     0,   253,   255,
       0,     0,     0,   268,     0,     0,   302,     0,     0,   260,
       0,   175,   110,   606,   602,   605,   603,   180,   434,   414,
       0,   354,     0,   355,     0,     0,     0,     0,     0,   223,
       0,   103,     0,     0,   542,     0,   110,     0,     0,   592,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     334,   489,   490,   491,   483,    54,   485,   488,     0,     0,
     401,   402,     0,     0,     0,     0,   465,     0,    14,   440,
     448,   443,    54,   620,   604,   615,   608,     0,     0,     0,
     243,   244,     0,     0,     0,   306,     0,   303,   276,   277,
       0,     0,   292,   293,     0,     0,     0,     0,   299,     0,
     298,     0,   261,   264,   265,   607,   160,     0,   431,   352,
     383,     0,     0,     0,     0,   617,     0,     0,   540,   568,
     552,     0,   153,     0,   548,   550,   594,   538,   511,   508,
     512,     0,     0,     0,     0,     0,     0,     0,     0,   555,
      53,     0,   487,   482,     0,   389,   391,   386,   394,   396,
     463,   464,     0,     0,     0,     0,   467,   472,   456,     0,
       0,    14,   624,   609,     0,     0,   238,   235,     0,   266,
       0,     0,   292,     0,   290,   291,     0,   292,   284,     0,
     269,   272,   270,   296,   297,     0,     0,     0,     0,    14,
     422,     0,   418,   420,   421,   430,     0,   428,     0,     0,
       0,     0,     0,     0,     0,     0,   578,     0,   104,     0,
      14,    14,     0,     0,     0,    14,    14,     0,     0,     0,
       0,     0,     0,   497,     0,   566,   486,   484,   393,     0,
       0,     0,   470,   471,   462,     0,     0,   461,   447,     0,
     595,   474,   626,   628,    14,     0,   611,   613,     0,     0,
       0,     0,     0,     0,   284,     0,   286,     0,   285,     0,
       0,   303,     0,   273,   300,   301,   295,   262,   181,   424,
       0,   413,   431,   415,    14,     0,     0,     0,     0,     0,
       0,     0,   579,     0,    99,   474,   567,   553,   525,   526,
     545,   549,   551,     0,   492,     0,   493,     0,   499,   496,
     573,   395,   387,   397,   468,   469,   446,   623,   624,   616,
     625,   610,     0,   237,   245,     0,     0,   239,     0,     0,
       0,     0,   288,   294,   287,     0,     0,     0,   274,     0,
     419,   429,     0,     0,   501,     0,   502,     0,   506,   505,
     618,   577,     0,   105,   543,   571,     0,     0,   494,   495,
     500,   564,   565,   574,   627,    14,     0,     0,     0,   304,
       0,     0,     0,   281,     0,   271,     0,   275,    14,   432,
     503,   504,   507,   585,   583,   580,     0,   586,   569,   554,
     527,    14,   556,   572,     0,     0,     0,   238,     0,     0,
       0,     0,   292,   292,   289,   278,     0,     0,   624,     0,
     582,    14,     0,   575,   624,     0,     0,     0,     0,     0,
       0,   246,   251,     0,     0,     0,     0,   304,   425,   581,
     587,   570,   546,    14,   614,     0,   242,   241,   240,     0,
     251,   231,     0,     0,     0,     0,     0,    14,   576,   234,
       0,     0,     0,     0,     0,     0,     0,   547,     0,     0,
       0,     0,     0,   283,     0,   280,     0,   233,     0,     0,
     247,     0,   252,   282,   279,   232,     0,   252,     0,   248,
       0,     0,     0,     0,     0,     0,   249,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   250
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1008, -1008, -1008,   855,    54, -1008, -1008,    97, -1008, -1008,
    1111, -1008,  1120,   -19,    47, -1008, -1008, -1008,   988, -1008,
   -1008, -1008,   739, -1008, -1008,   901, -1008,  -345,  -472,   804,
   -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008,
   -1008, -1008, -1008, -1008,  -442, -1008, -1008, -1008, -1008, -1008,
   -1008,   -94,  -821,  -455,  -354, -1008, -1008,   358, -1008,  -275,
   -1008,   547,   738, -1008,   664,   154,    51, -1008,  -109,  -124,
      13,  -408,   293,  -537, -1008, -1008,  -418, -1008, -1008, -1008,
   -1008, -1008, -1008, -1008,  1081,  1080,   764,  -348, -1008,  1197,
     906, -1008, -1008, -1008,   699, -1008, -1008,   765, -1008,   532,
   -1008, -1008, -1008,    33, -1008,  -807, -1008,    80, -1008, -1008,
     529,  -485, -1008,   522,   416, -1008, -1008, -1008,   330,  -977,
   -1008, -1008, -1008,   336, -1008,    67,  -973,  -867,  -736, -1008,
    -279, -1008,   327,  -697,  -542, -1008,   196, -1008, -1008, -1008,
   -1008, -1008, -1008,   -46,     0, -1008,    18, -1008,  1114,  -288,
   -1008,   830, -1008,   569,  1271, -1008, -1008,   -27,   -20,   -67,
   -1008,   919, -1008, -1008,   418, -1008, -1008,  1274, -1008,   955,
     756, -1008, -1008, -1008,  1008, -1008,   840, -1008, -1008, -1008,
   -1008, -1008, -1008, -1008, -1008,   427,  -441, -1008, -1008, -1008,
   -1008,   478, -1008,   224,  -464,   881, -1008,   519,  1253,    75,
   -1008, -1008, -1008, -1008, -1008, -1008, -1008,  -892,  -352, -1008,
   -1008, -1008, -1008, -1008,   221, -1008,   476, -1008,   725,  -986,
   -1008,   517, -1008, -1008,   903, -1008, -1008, -1008, -1008, -1008,
   -1008,  -324,  -574,  -520,    32, -1008, -1008, -1008, -1008, -1008,
     363,   446, -1008, -1008, -1008, -1007, -1008, -1008,  -510, -1008,
   -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008, -1008,
   -1008, -1008,   782, -1008, -1008, -1008, -1008, -1008, -1008, -1008,
   -1008, -1008, -1008, -1008, -1008,   122, -1008,  -454,  -552,   479,
    -365,   521, -1008,   819,   434,   273,   441, -1008,  -518, -1008,
   -1008, -1008, -1008, -1008,  -534, -1008, -1008,  -980, -1008, -1008,
     -76,   992, -1008,   472,   -47
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,     8,   558,    10,    51,   559,    20,    94,
      62,    63,    64,   131,   145,    12,    85,   247,   174,   350,
     495,   433,   434,   570,   571,   268,   355,   361,   497,   356,
     436,   437,   575,   699,    13,    88,   257,   421,   476,    14,
      21,    99,   446,   515,    15,    43,   138,   333,    83,   140,
     245,    84,   765,   560,   595,   439,   440,   441,   442,   603,
     503,   698,   506,   691,   586,   587,   102,    37,    77,   241,
     242,   243,   543,   853,   633,   946,    16,   258,   426,   548,
     264,   346,   164,   165,    71,    74,   423,   343,   424,    91,
     349,   430,   660,   488,   489,   763,   490,   491,   635,   726,
     727,  1289,   728,  1089,  1156,   922,  1250,  1251,   636,   732,
     733,   637,   741,   742,   743,   735,   736,   737,  1020,  1103,
     930,   841,   842,   931,  1017,  1161,  1018,   932,  1162,   738,
     938,   939,   845,   940,  1163,   836,   146,   147,   148,   249,
     149,   150,   151,   152,   561,    86,   562,    87,   252,   253,
     254,   640,   591,   592,   641,    67,   103,   153,   154,   178,
     270,   271,   359,   752,   753,   642,   643,   644,    75,    40,
     108,   109,   182,   273,   274,   365,   366,   450,   275,   276,
     370,   371,   528,   372,   755,   756,   563,   815,  1070,   813,
     814,   902,   987,   988,   989,   646,   704,   705,    81,   564,
      41,    42,   648,   858,   948,   750,  1031,  1035,  1033,   540,
    1034,  1169,   472,  1036,  1037,  1038,   416,   537,   538,   716,
     717,   718,   604,   605,   649,   712,   908,   711,   707,   818,
     995,   996,   545,   565,   795,   524,   703,   899,   808,   895,
     896,   897,   898,   566,   651,   567,   792,   963,   568,   775,
     767,   768,   959,   876,  1187,  1277,  1055,  1056,  1051,  1185,
    1065,   569,   652,  1140,  1050,  1219,  1241,  1193,  1223,  1224,
    1263,  1122,  1181,  1182,  1238,  1215,  1216,   132,   680,   773,
     827,   463,   464,   465,   745,   854,   918,   919,   855,   830,
    1152,  1002,  1046,   719,  1082,   721,   914,  1083,  1084,  1149,
    1252,   134,   298,   200,   135
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     133,    65,    17,   477,   516,   520,   632,   206,   532,   654,
     445,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      18,   171,   205,   650,    82,   653,   554,   205,   924,    18,
      18,    18,    18,    18,    18,    18,    18,    18,   179,  1094,
     104,   155,   720,   706,  1098,   246,   527,   105,   419,   956,
     681,   198,   199,    35,    78,  1032,     9,    36,   594,    61,
     729,    96,   435,  1012,   471,     9,     9,     9,     9,     9,
       9,     9,     9,     9,    65,   157,    65,    19,   484,   443,
     251,    96,   739,   744,   208,  -224,    19,    19,    19,    19,
      19,    19,    19,    19,    19,   891,   299,   300,    96,    11,
     474,   631,   645,   690,   679,    69,    72,   351,    11,    11,
      11,    11,    11,    11,    11,    11,    11,   916,   534,    96,
      82,   176,   793,  1166,  -584,   634,     3,   297,  1172,   892,
     893,  -584,   300,   301,   302,   303,   700,   180,   162,   734,
     926,   679,   163,   552,   207,   661,   339,   828,    61,  1096,
     663,   664,   665,   944,   347,   351,  1075,   724,   142,   248,
      66,   209,   210,    76,     6,  1239,    70,    73,  1194,   793,
     187,   188,  1240,   190,   191,   192,   193,   194,   195,   196,
     197,    68,   177,   201,   202,   204,   905,    98,  1226,   614,
     739,  1207,   272,   203,   874,   794,   917,   812,   181,   744,
     656,   816,   373,   374,   375,   376,   435,    98,  -537,   725,
    -537,   856,   550,   203,  1242,   378,   379,   379,  1170,   144,
     740,   677,  1237,   111,    98,   650,  1123,   804,   158,   113,
    1164,   114,   -42,   211,   159,   212,   -42,  1021,  1021,   -14,
     417,   -53,   794,   377,    97,    98,    89,   734,  1076,   368,
      96,   894,  1077,  1025,   413,   414,   369,   706,  1259,  1254,
    1256,   352,   420,   353,  1264,   492,   493,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   696,   331,   594,   209,   210,   933,   869,
      90,   453,   454,   631,   645,   666,   744,   466,   729,   352,
     798,   -53,  -236,   729,   906,    82,    79,   729,    28,    93,
     292,   354,  1100,   367,   907,    33,    80,   634,   -13,  1026,
     293,   555,    95,  1027,   482,   594,   594,   594,   483,  -476,
    -476,  -476,  -476,   250,   336,   205,     4,  1196,   555,   337,
     255,     4,  1253,   106,   697,   679,  -476,  -476,  -476,  -476,
     594,     5,   107,     4,   555,   730,   928,   929,   211,   730,
     382,   137,  -476,  -476,  -476,  -476,    98,   -14,   336,     4,
    1228,  1229,   203,   340,   529,  1255,   731,   625,   933,   139,
     838,   625,   535,   539,  1023,  1024,   859,   556,   998,   891,
     801,   802,   873,   290,   432,  1168,   291,   206,  1014,  1015,
     881,  1125,   657,   141,    45,    46,   555,  1202,     6,   156,
     574,   478,   205,     6,  -476,  -476,  -476,  -476,   925,  1204,
     166,     4,   173,   892,   893,     6,   882,   883,   884,   479,
     451,  1014,  1015,   531,   205,   452,   517,   290,    48,   290,
    1167,     6,  1230,   168,     7,   611,   507,   466,    49,   612,
      50,   904,   170,   525,   518,  1233,  1234,   856,   172,  1014,
    1015,   510,   504,   505,   933,   475,   511,   512,  1016,  1093,
    1268,   650,   541,   460,   487,   557,    44,   542,    45,    46,
     513,    47,   632,   111,   290,   654,   480,  1281,   354,   113,
     514,   114,   557,     6,  1014,  1015,   184,  1147,   870,   650,
     701,   653,   871,  1016,   175,   702,   238,   239,   557,  1014,
    1015,   522,    48,   590,   688,   689,   809,   183,  1097,   920,
     921,   810,    49,   848,    50,   539,   185,     6,   849,   678,
    1126,  1127,   860,   638,   207,  1131,  1132,   861,   432,   186,
     981,  1184,   189,   585,   206,   933,  1273,   588,  1275,   631,
     645,   639,  1047,   658,   650,   244,  1048,  1000,     7,   205,
     557,   531,   251,   862,   259,   848,   531,  1284,   863,  1286,
     942,   984,   260,   634,   984,   262,   985,   631,   645,   986,
     766,  1110,   110,    61,   111,   112,  1111,   629,   265,  1112,
     113,   774,   114,   266,  1113,   487,   100,   101,    26,    45,
      46,   634,   267,  1202,   269,  1299,   710,  1203,   647,  1300,
    -108,  -108,  -108,   585,  1308,   585,   585,   588,  1309,   588,
     588,   596,   597,   598,   599,   600,   115,   820,   277,   823,
     630,  1315,   631,   645,   294,  1316,   829,   682,   683,   684,
     685,   936,   937,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   846,   278,   634,   715,   279,   601,
     602,    29,    30,    31,    32,  -108,  -108,  -108,   116,   117,
      22,    23,   500,   501,   502,   868,   235,   236,   237,   238,
     239,   207,   280,   875,   281,   877,   878,   118,   757,   758,
     759,   760,   578,   330,   620,   621,   622,   579,   580,   581,
     582,   583,    26,   332,   590,   796,   797,   799,   119,   120,
     121,   122,   123,   124,   889,  1191,  1192,   205,   334,   890,
     338,  1261,   694,   695,   342,   901,   125,   126,   233,   234,
     235,   236,   237,   238,   239,   638,  1104,  1105,   127,   584,
     466,  1144,  1145,  1278,   341,   128,   923,    22,    23,   129,
     130,   927,   344,   639,   380,   381,   345,  1287,   927,   357,
     348,   679,   358,   360,   927,    29,    30,    31,    32,   362,
     364,   383,   415,   384,   385,    22,    23,    24,    25,    26,
     531,    22,    23,   386,   766,   422,   957,   425,   427,   852,
     431,   429,   -59,   438,   774,   444,   968,   969,   970,   972,
     974,   976,   978,    22,    23,   160,   161,    26,   449,   456,
     647,   100,   101,    26,   142,    34,   460,   457,   458,   459,
     292,   997,   461,   462,   239,   468,   467,    27,   469,   470,
     481,   473,   630,   100,   101,    26,  1006,   485,  1008,    28,
     486,  -224,    29,    30,    31,    32,    33,   494,   927,   927,
     496,   143,   498,   499,   509,   846,    52,    53,    54,    55,
      56,    57,    58,    59,    60,  1040,  1042,  1044,  1045,   715,
      29,    30,    31,    32,   530,   144,    29,    30,    31,    32,
     533,   544,   547,   551,   553,  1057,   573,  1059,   577,  1061,
     589,   593,    34,   557,   607,   609,   610,   613,    29,    30,
      31,    32,   655,   662,   686,   708,  1072,  1073,   709,   713,
     722,  1109,   723,  1079,   746,   751,   754,   761,  1086,  1087,
      34,   762,   764,   769,  1091,   817,    34,   770,   771,   772,
     800,   805,   807,  1101,   811,   824,   825,   826,   831,   927,
     927,   832,   833,   729,   835,   837,   840,   864,    34,   850,
     865,   843,   844,  1115,   866,  1117,   857,  1119,   880,   867,
     872,   766,   885,  1124,   886,  1053,  1128,   879,  1130,   887,
     888,   910,   909,   934,   913,   915,   935,   941,   110,    61,
     111,   112,   951,   952,   961,  1143,   113,   953,   114,   997,
     997,   638,   955,   954,   747,   980,   958,   748,   960,  1151,
     964,   965,  1153,   967,  1157,   891,   979,   916,   983,   639,
     990,   999,   821,  1004,  1005,  1007,   927,    45,    46,   638,
    1009,  1010,   115,  1013,  1030,  1049,  1052,  1058,  -108,  -108,
    -108,  1054,  1060,  1062,  1068,  1069,  1063,   639,  1064,   596,
     597,   598,   599,   600,  1067,   852,  1071,   617,  1074,  1088,
    1080,    48,  1085,  1090,   749,  1092,  1095,  1099,  1102,  1107,
    1106,    49,  1114,    50,   116,   117,   647,  1116,  1118,  1197,
    1129,  1148,  1199,   629,   638,  1120,  1121,   601,   602,  1133,
    1135,  1206,  1134,   118,  1136,  1137,  1154,  1138,   630,  1139,
    1142,  1146,   639,  1159,   647,  1158,  1217,  1160,  1165,  1174,
    1220,  1173,  1175,  1177,   119,   120,   121,   122,   123,   124,
    1227,  1176,  1180,  1178,  1179,  1186,   630,   110,    61,   111,
     112,  1183,   125,   126,  1188,   113,  1189,   114,   852,  1190,
    1195,  1198,  1200,   822,   127,  1201,  1218,  1205,  1217,  1209,
    1208,   128,  1246,  1247,  1248,   129,   130,  1210,  1211,   647,
    1257,   945,  1212,  1260,  1222,  1221,  1231,  1235,   715,  1236,
    1244,   115,  1258,  1270,  1262,  1265,  1266,   927,  1267,   927,
    1272,   630,   282,   283,   284,   285,   286,   287,   288,   289,
      22,    23,  1271,   295,   296,  1274,  1282,  1276,   927,  1280,
     927,  1283,  1285,  1288,   167,  1291,   531,  1292,  1293,  1294,
    1295,  1296,  1298,   116,   117,   169,  1302,  1303,  1301,  1304,
     693,   583,    26,  1305,  1311,  1307,  1313,  1318,  1320,  1322,
    1324,  1326,   118,   572,   962,   335,   418,  1328,   803,  1029,
     692,   576,    22,    23,   261,   263,   546,    92,   508,  1225,
     659,   549,   428,   119,   120,   121,   122,   123,   124,   834,
    1245,   839,   715,   847,   943,  1022,  1011,  1232,  1028,   256,
     806,   125,   126,   583,    26,  1225,   519,    38,   949,   448,
      39,   363,   536,   127,   606,    29,    30,    31,    32,   950,
     128,   526,   903,  1141,   129,   130,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   110,    61,   111,   112,   455,   521,   900,  1269,
     113,   136,   114,  1171,   947,    34,   714,    29,    30,    31,
      32,   991,   911,  1066,   982,  1279,  1243,   912,  1001,   523,
     447,   687,   608,   110,    61,   111,   112,  1150,  1003,   966,
    1290,   113,     0,   114,     0,     0,   115,     0,  1297,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1306,
       0,   992,   993,     0,     0,     0,     0,    34,  1310,     0,
       0,  1312,     0,  1314,     0,  1317,     0,   115,  1319,     0,
    1321,     0,  1323,     0,  1325,     0,  1327,     0,   116,   117,
       0,     0,   992,   993,     0,     0,     0,     0,     0,     0,
     110,    61,   111,   112,     0,  1213,     0,   118,   113,     0,
     114,     0,     0,     0,     0,     0,     0,     0,     0,   116,
     117,     0,     0,     0,     0,     0,     0,     0,   119,   120,
     121,   122,   123,   124,     0,     0,     0,     0,   118,     0,
       0,     0,     0,     0,   115,     0,   125,   126,   994,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   127,   119,
     120,   121,   122,   123,   124,   128,     0,  1214,     0,   129,
     130,   110,    61,   111,   112,     0,     0,   125,   126,   113,
       0,   114,     0,     0,     0,     0,   116,   117,     0,   127,
       0,     0,     0,     0,     0,     0,   128,     0,     0,     0,
     129,   130,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   115,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   119,   120,   121,   122,
     123,   124,     0,     0,     0,     0,     0,     0,   110,    61,
     111,   112,     0,     0,   125,   126,   113,     0,   114,     0,
       0,     0,     0,     0,     0,     0,   127,   116,   117,     0,
       0,     0,     0,   128,     0,     0,     0,   129,   130,     0,
     776,   777,     0,     0,     0,     0,   118,     0,     0,     0,
       0,     0,   115,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,     0,     0,   119,   120,   121,
     122,   123,   124,   110,    61,   111,   112,     0,     0,   790,
       0,   113,     0,   114,     0,   125,   126,     0,     0,     0,
       0,     0,     0,     0,   116,   117,   791,   127,   819,     0,
       0,     0,     0,     0,   128,   971,     0,     0,   129,   130,
       0,     0,     0,   118,     0,     0,     0,   115,     0,   110,
      61,   111,   112,     0,     0,     0,     0,   113,     0,   114,
       0,     0,     0,     0,   119,   120,   121,   122,   123,   124,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   125,   126,     0,     0,     0,     0,     0,   116,
     117,     0,     0,   115,   127,     0,     0,     0,     0,     0,
     973,   128,     0,     0,     0,   129,   130,     0,   118,   110,
      61,   111,   112,     0,     0,     0,     0,   113,     0,   114,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   119,
     120,   121,   122,   123,   124,   116,   117,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,   125,   126,     0,
       0,     0,     0,   115,   118,   110,    61,   111,   112,   127,
       0,     0,     0,   113,     0,   114,   128,     0,     0,     0,
     129,   130,     0,     0,     0,   119,   120,   121,   122,   123,
     124,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   125,   126,   116,   117,     0,     0,   115,
       0,   110,    61,   111,   112,   127,     0,     0,     0,   113,
       0,   114,   128,     0,   118,     0,   129,   130,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,     0,     0,   119,   120,   121,   122,   123,
     124,   116,   117,     0,     0,   115,     0,   110,    61,   111,
     112,     0,  1039,   125,   126,   113,     0,   114,     0,     0,
     118,     0,     0,     0,     0,   127,   977,     0,     0,     0,
       0,     0,   128,     0,     0,     0,   129,   130,     0,     0,
       0,   119,   120,   121,   122,   123,   124,   116,   117,     0,
       0,   115,     0,   110,    61,   111,   112,     0,  1041,   125,
     126,   113,     0,   114,     0,     0,   118,     0,     0,     0,
       0,   127,     0,     0,     0,     0,     0,     0,   128,     0,
       0,     0,   129,   130,     0,     0,     0,   119,   120,   121,
     122,   123,   124,   116,   117,     0,     0,   115,     0,   110,
      61,   111,   112,     0,  1043,   125,   126,   113,     0,   114,
       0,     0,   118,     0,     0,     0,     0,   127,     0,     0,
       0,     0,     0,     0,   128,     0,     0,     0,   129,   130,
       0,     0,     0,   119,   120,   121,   122,   123,   124,   116,
     117,     0,     0,   115,     0,   110,    61,   111,   112,     0,
       0,   125,   126,   113,     0,   114,     0,     0,   118,     0,
       0,     0,     0,   127,     0,     0,     0,     0,     0,     0,
     128,     0,     0,     0,   129,   130,     0,     0,     0,   119,
     120,   121,   122,   123,   124,   116,   117,     0,     0,   115,
       0,   110,    61,   111,   112,     0,     0,   125,   126,   113,
       0,   114,     0,     0,   118,     0,     0,     0,     0,   127,
    1078,     0,     0,     0,     0,     0,   128,     0,     0,     0,
     129,   130,     0,     0,     0,   119,   120,   121,   122,   123,
     124,   116,   117,     0,     0,   115,     0,   110,    61,   111,
     112,     0,     0,   125,   126,   113,     0,   114,     0,     0,
     118,     0,     0,     0,     0,   127,     0,     0,     0,     0,
       0,     0,   128,     0,     0,     0,   129,   130,     0,     0,
       0,   119,   120,   121,   122,   123,   124,   116,   117,     0,
       0,   115,     0,     0,     0,     0,     0,     0,     0,   125,
     126,     0,     0,     0,     0,     0,   118,     0,     0,     0,
       0,  1019,     0,     0,     0,     0,     0,     0,   128,     0,
       0,     0,   129,   130,     0,     0,     0,   119,   120,   121,
     122,   123,   124,   116,   117,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   125,   126,     0,     0,     0,
       0,     0,   118,     0,     0,     0,     0,  1155,     0,     0,
       0,     0,     0,     0,   128,     0,    61,     0,   129,   130,
       0,     0,   667,   119,   120,   121,   122,   123,   124,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,   125,   126,     0,     0,     0,     0,     0,     0,     0,
    -108,  -108,  -108,  1249,     0,     0,     0,     0,     0,     0,
     128,     0,     0,     0,   129,   130,   668,     0,   669,     0,
     670,   671,   672,     0,   555,     0,   615,     0,  -557,  -557,
    -557,     0,  -476,  -476,  -476,  -476,     0,     0,     0,     4,
       0,     0,   616,     0,     0,   510,     0,     0,     0,   601,
     602,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   513,   673,   674,   675,     0,     0,
     617,     0,   618,     0,   619,     0,     0,     0,     0,     0,
       0,     0,   620,   621,   622,     0,     0,     0,     0,     0,
       0,   623,   624,     0,   625,     0,     0,   626,   555,     0,
     615,     0,     0,     0,     0,     0,  -476,  -476,  -476,  -476,
      27,     6,     0,     4,   627,     0,     0,     0,     0,   510,
       0,     0,    28,   676,     0,     0,     0,     0,   677,    33,
       0,     0,     0,     0,     0,     0,     0,     0,   513,     0,
       0,     0,     7,     0,   617,     0,   618,     0,   619,     0,
       0,     0,   555,     0,   615,     0,   620,   621,   622,     0,
    -476,  -476,  -476,  -476,     0,   623,   624,     4,   625,     0,
       0,   626,     0,   510,     0,     0,     0,   628,     0,     0,
       0,     0,     0,     0,    27,     6,     0,     0,   627,  1108,
       0,     0,   513,     0,     0,     0,    28,     0,   617,     0,
     618,     0,   619,    33,     0,     0,     0,     0,     0,     0,
     620,   621,   622,     0,     0,     0,     7,     0,     0,   623,
     624,     0,   625,     0,     0,   626,   851,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    27,     6,
       0,     0,   627,     0,   555,     0,   615,     0,     0,     0,
      28,   628,  -476,  -476,  -476,  -476,     0,    33,     0,     4,
       0,     0,     0,     0,     0,   510,     0,     0,     0,     0,
       7,     0,     0,     0,     0,     0,     0,     0,   555,     0,
     615,     0,     0,     0,   513,     0,  -476,  -476,  -476,  -476,
     617,  1081,   618,     4,   619,     0,     0,     0,     0,   510,
       0,     0,   620,   621,   622,     0,     0,     0,     0,     0,
       0,   623,   624,     0,   625,     0,     0,   626,   513,     0,
       0,     0,     0,     0,     0,     0,   618,     0,   619,     0,
      27,     6,     0,     0,   627,     0,   620,   621,   622,     0,
       0,     0,    28,     0,     0,   623,   624,     0,   625,    33,
       0,   626,     0,     0,   747,     0,     0,   748,     0,     0,
       0,     0,     7,     0,    27,     6,     0,     0,   627,     0,
       0,     0,     0,     0,     0,     0,    28,    45,    46,     0,
       0,     0,     0,    33,     0,     0,     0,     0,  -108,  -108,
    -108,     0,     0,     0,     0,     0,     7,     0,     0,   596,
     597,   598,   599,   600,     0,     0,     0,     0,     0,     0,
       0,    48,     0,     0,   749,     0,     0,     0,     0,     0,
       0,    49,     0,    50,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   601,   602,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   240,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239
};

static const yytype_int16 yycheck[] =
{
      76,    20,     2,   421,   446,   446,   543,   131,   462,   543,
     355,    11,    12,    13,    14,    15,    16,    17,    18,    19,
       2,    97,   131,   543,    43,   543,   490,   136,   835,    11,
      12,    13,    14,    15,    16,    17,    18,    19,   105,  1012,
      67,    87,   616,   595,  1017,   139,   454,    67,   336,   870,
     560,   127,   128,     6,    41,   947,     2,     6,   513,     4,
       4,    32,   350,   930,   416,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    93,     4,    95,     2,   426,   354,
       4,    32,   624,   625,   131,     4,    11,    12,    13,    14,
      15,    16,    17,    18,    19,     4,   205,   206,    32,     2,
      31,   543,   543,   575,   558,    47,    47,     4,    11,    12,
      13,    14,    15,    16,    17,    18,    19,     4,   463,    32,
     139,    47,    20,  1100,   156,   543,     0,   203,  1114,    38,
      39,   163,   241,   209,   210,   211,   590,    47,    91,   624,
     837,   595,    91,   488,   131,   553,   255,   721,     4,  1016,
       4,     5,     6,   850,   263,     4,    64,     4,    47,   146,
       4,    91,    92,   164,    95,   156,   108,   108,  1148,    20,
     116,   117,   163,   119,   120,   121,   122,   123,   124,   125,
     126,    14,   108,   129,   130,   131,    21,   158,  1195,   541,
     732,  1168,   179,   164,   768,    93,    83,   707,   108,   741,
     548,   711,   278,   279,   280,   281,   494,   158,   159,    56,
     161,   745,   487,   164,  1221,   291,   292,   293,  1110,   108,
     164,   166,  1208,     5,   158,   745,  1047,   699,   157,    11,
    1097,    13,   156,   163,   163,   165,   160,   934,   935,    21,
     334,   160,    93,   290,   157,   158,     4,   732,   156,   276,
      32,   160,   160,    80,   330,   331,   276,   809,  1238,  1232,
    1233,   158,   338,   160,  1244,    27,    28,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,    47,   240,   750,    91,    92,   840,   763,
      65,   368,   369,   745,   745,   159,   848,   383,     4,   158,
     161,   160,   159,     4,   149,   334,     4,     4,   106,    21,
     156,   267,  1019,   276,   159,   113,    14,   745,     0,   156,
     166,     8,   156,   160,   156,   790,   791,   792,   160,    16,
      17,    18,    19,   147,   156,   454,    23,  1154,     8,   161,
     154,    23,    91,   160,   108,   809,    16,    17,    18,    19,
     815,    33,   107,    23,     8,    56,    62,    63,   163,    56,
     165,   161,    16,    17,    18,    19,   158,   159,   156,    23,
      91,    92,   164,   161,   460,    91,    77,    78,   930,   163,
      77,    78,   468,   469,   936,   937,   750,    74,   908,     4,
     688,   689,   767,   160,   350,  1102,   163,   531,   147,   148,
     775,    55,    72,     4,    27,    28,     8,   156,    95,     4,
     496,   421,   531,    95,    16,    17,    18,    19,   836,  1165,
       4,    23,   162,    38,    39,    95,   790,   791,   792,   421,
     156,   147,   148,   462,   553,   161,   446,   160,    61,   160,
     163,    95,   163,    24,   126,   156,   443,   533,    71,   160,
      73,   815,     4,   450,   446,  1201,  1202,  1001,     4,   147,
     148,    29,    96,    97,  1016,   421,    34,    35,   156,   157,
     160,  1001,   156,   163,   430,   162,    25,   161,    27,    28,
      48,    30,  1029,     5,   160,  1029,   421,   163,   444,    11,
     446,    13,   162,    95,   147,   148,    11,  1081,   156,  1029,
     156,  1029,   160,   156,   166,   161,   152,   153,   162,   147,
     148,   446,    61,   510,   570,   571,   156,   166,   156,    62,
      63,   161,    71,   156,    73,   611,    12,    95,   161,   558,
    1050,  1051,   156,   543,   531,  1055,  1056,   161,   494,   153,
     895,  1125,   153,   506,   678,  1097,  1253,   506,  1255,  1001,
    1001,   543,   156,   550,  1084,     4,   160,   912,   126,   678,
     162,   590,     4,   156,     4,   156,   595,  1274,   161,  1276,
     161,   156,     4,  1001,   156,     4,   161,  1029,  1029,   161,
     666,   156,     3,     4,     5,     6,   161,   543,    22,   156,
      11,   677,    13,   159,   161,   551,    44,    45,    46,    27,
      28,  1029,   159,   156,     4,   156,   603,   160,   543,   160,
      38,    39,    40,   576,   156,   578,   579,   576,   160,   578,
     579,    49,    50,    51,    52,    53,    47,   713,    12,   715,
     543,   156,  1084,  1084,   167,   160,   722,    16,    17,    18,
      19,    62,    63,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   740,   159,  1084,   613,   159,    87,
      88,   109,   110,   111,   112,    38,    39,    40,    89,    90,
      14,    15,    38,    39,    40,   761,   149,   150,   151,   152,
     153,   678,   159,   769,   159,   771,   772,   108,    16,    17,
      18,    19,    36,   159,    66,    67,    68,    41,    42,    43,
      44,    45,    46,   161,   701,   683,   684,   685,   129,   130,
     131,   132,   133,   134,   800,    85,    86,   836,   156,   805,
     157,  1241,   578,   579,   159,   811,   147,   148,   147,   148,
     149,   150,   151,   152,   153,   745,  1025,  1026,   159,    83,
     826,  1075,  1076,  1263,   161,   166,   832,    14,    15,   170,
     171,   837,     4,   745,   292,   293,   157,  1277,   844,   161,
     159,  1225,   157,   156,   850,   109,   110,   111,   112,   167,
       4,   159,   162,   165,   165,    14,    15,    44,    45,    46,
     809,    14,    15,   165,   870,     4,   872,   161,     4,   745,
     161,   160,     4,   158,   880,   156,   882,   883,   884,   885,
     886,   887,   888,    14,    15,    44,    45,    46,   167,   160,
     745,    44,    45,    46,    47,   159,   163,   160,   160,   160,
     156,   907,   167,   158,   153,   163,   160,    94,   159,     4,
       4,   161,   745,    44,    45,    46,   922,     4,   924,   106,
     161,     4,   109,   110,   111,   112,   113,   156,   934,   935,
     157,    84,     4,   158,   160,   941,    11,    12,    13,    14,
      15,    16,    17,    18,    19,   951,   952,   953,   954,   825,
     109,   110,   111,   112,   167,   108,   109,   110,   111,   112,
     156,   163,   161,   156,     4,   971,   160,   973,    97,   975,
       4,     4,   159,   162,   160,   160,     4,   159,   109,   110,
     111,   112,     4,   163,   161,     4,   992,   993,     4,   159,
     159,  1030,   159,   999,     4,     4,     4,   159,  1004,  1005,
     159,   161,   160,   159,  1010,   168,   159,   159,   159,   159,
     159,   157,   159,  1019,   157,   160,   156,   159,   159,  1025,
    1026,   159,    77,     4,   159,   159,   159,    93,   159,   157,
      93,   161,   159,  1039,    93,  1041,   161,  1043,   156,    93,
     163,  1047,   159,  1049,   159,   962,  1052,   167,  1054,   159,
     159,     4,   160,   157,   161,   160,   157,   163,     3,     4,
       5,     6,   159,   159,     4,  1071,    11,   159,    13,  1075,
    1076,  1001,   160,   159,     4,   156,   161,     7,   160,  1085,
     160,   160,  1088,   161,  1090,     4,   160,     4,   161,  1001,
     160,   159,    37,   157,   161,   160,  1102,    27,    28,  1029,
     160,   163,    47,   149,     4,   163,   157,   160,    38,    39,
      40,   161,   160,   160,     4,   156,   161,  1029,   160,    49,
      50,    51,    52,    53,   160,  1001,   157,    54,   160,    79,
     160,    61,   157,     9,    64,   149,   142,   157,   156,   165,
     161,    71,   159,    73,    89,    90,  1001,   160,   160,  1155,
       4,    57,  1158,  1029,  1084,   160,   160,    87,    88,   160,
     160,  1167,   161,   108,   161,   160,   156,   161,  1001,   161,
     161,   160,  1084,   142,  1029,   163,  1182,   142,   142,   161,
    1186,   160,   160,   160,   129,   130,   131,   132,   133,   134,
    1196,   161,    69,   161,   161,   157,  1029,     3,     4,     5,
       6,   160,   147,   148,   161,    11,   161,    13,  1084,   161,
     161,   160,   159,   158,   159,   159,    57,   160,  1224,   160,
     159,   166,  1228,  1229,  1230,   170,   171,   161,   161,  1084,
    1236,   161,   161,  1239,    69,   161,   157,   160,  1114,   163,
     160,    47,   160,  1249,   160,   156,   160,  1253,   160,  1255,
     163,  1084,   190,   191,   192,   193,   194,   195,   196,   197,
      14,    15,   161,   201,   202,   163,  1272,   163,  1274,   156,
    1276,   160,   160,   156,    93,  1281,  1225,   163,   160,   160,
     160,   160,   160,    89,    90,    95,  1292,   160,   163,   160,
      44,    45,    46,   161,   156,  1301,   156,   156,   156,   156,
     156,   156,   108,   494,   876,   247,   335,   160,   691,   946,
     576,   503,    14,    15,   163,   165,   482,    50,   444,  1195,
     551,   486,   346,   129,   130,   131,   132,   133,   134,   727,
    1227,   732,  1208,   741,   848,   935,   930,  1200,   941,   155,
     701,   147,   148,    45,    46,  1221,   446,     6,   860,   360,
       6,   273,   158,   159,   528,   109,   110,   111,   112,   862,
     166,   451,   814,  1069,   170,   171,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,     3,     4,     5,     6,   371,   446,   809,  1249,
      11,    78,    13,  1112,   858,   159,   611,   109,   110,   111,
     112,    22,   825,   980,   898,  1265,  1224,   826,   914,   446,
     358,   569,   533,     3,     4,     5,     6,  1084,   917,   880,
    1280,    11,    -1,    13,    -1,    -1,    47,    -1,  1288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1299,
      -1,    62,    63,    -1,    -1,    -1,    -1,   159,  1308,    -1,
      -1,  1311,    -1,  1313,    -1,  1315,    -1,    47,  1318,    -1,
    1320,    -1,  1322,    -1,  1324,    -1,  1326,    -1,    89,    90,
      -1,    -1,    62,    63,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,    -1,     8,    -1,   108,    11,    -1,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,   130,
     131,   132,   133,   134,    -1,    -1,    -1,    -1,   108,    -1,
      -1,    -1,    -1,    -1,    47,    -1,   147,   148,   149,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,   129,
     130,   131,   132,   133,   134,   166,    -1,    70,    -1,   170,
     171,     3,     4,     5,     6,    -1,    -1,   147,   148,    11,
      -1,    13,    -1,    -1,    -1,    -1,    89,    90,    -1,   159,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,   171,    -1,    -1,    -1,   108,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   129,   130,   131,   132,
     133,   134,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,    -1,    -1,   147,   148,    11,    -1,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   159,    89,    90,    -1,
      -1,    -1,    -1,   166,    -1,    -1,    -1,   170,   171,    -1,
     101,   102,    -1,    -1,    -1,    -1,   108,    -1,    -1,    -1,
      -1,    -1,    47,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,    -1,    -1,   129,   130,   131,
     132,   133,   134,     3,     4,     5,     6,    -1,    -1,   140,
      -1,    11,    -1,    13,    -1,   147,   148,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    90,   157,   159,   160,    -1,
      -1,    -1,    -1,    -1,   166,   100,    -1,    -1,   170,   171,
      -1,    -1,    -1,   108,    -1,    -1,    -1,    47,    -1,     3,
       4,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,    13,
      -1,    -1,    -1,    -1,   129,   130,   131,   132,   133,   134,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   147,   148,    -1,    -1,    -1,    -1,    -1,    89,
      90,    -1,    -1,    47,   159,    -1,    -1,    -1,    -1,    -1,
     100,   166,    -1,    -1,    -1,   170,   171,    -1,   108,     3,
       4,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,
     130,   131,   132,   133,   134,    89,    90,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   147,   148,    -1,
      -1,    -1,    -1,    47,   108,     3,     4,     5,     6,   159,
      -1,    -1,    -1,    11,    -1,    13,   166,    -1,    -1,    -1,
     170,   171,    -1,    -1,    -1,   129,   130,   131,   132,   133,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   147,   148,    89,    90,    -1,    -1,    47,
      -1,     3,     4,     5,     6,   159,    -1,    -1,    -1,    11,
      -1,    13,   166,    -1,   108,    -1,   170,   171,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,    -1,   129,   130,   131,   132,   133,
     134,    89,    90,    -1,    -1,    47,    -1,     3,     4,     5,
       6,    -1,   100,   147,   148,    11,    -1,    13,    -1,    -1,
     108,    -1,    -1,    -1,    -1,   159,   160,    -1,    -1,    -1,
      -1,    -1,   166,    -1,    -1,    -1,   170,   171,    -1,    -1,
      -1,   129,   130,   131,   132,   133,   134,    89,    90,    -1,
      -1,    47,    -1,     3,     4,     5,     6,    -1,   100,   147,
     148,    11,    -1,    13,    -1,    -1,   108,    -1,    -1,    -1,
      -1,   159,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,   170,   171,    -1,    -1,    -1,   129,   130,   131,
     132,   133,   134,    89,    90,    -1,    -1,    47,    -1,     3,
       4,     5,     6,    -1,   100,   147,   148,    11,    -1,    13,
      -1,    -1,   108,    -1,    -1,    -1,    -1,   159,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,   171,
      -1,    -1,    -1,   129,   130,   131,   132,   133,   134,    89,
      90,    -1,    -1,    47,    -1,     3,     4,     5,     6,    -1,
      -1,   147,   148,    11,    -1,    13,    -1,    -1,   108,    -1,
      -1,    -1,    -1,   159,    -1,    -1,    -1,    -1,    -1,    -1,
     166,    -1,    -1,    -1,   170,   171,    -1,    -1,    -1,   129,
     130,   131,   132,   133,   134,    89,    90,    -1,    -1,    47,
      -1,     3,     4,     5,     6,    -1,    -1,   147,   148,    11,
      -1,    13,    -1,    -1,   108,    -1,    -1,    -1,    -1,   159,
     160,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,   171,    -1,    -1,    -1,   129,   130,   131,   132,   133,
     134,    89,    90,    -1,    -1,    47,    -1,     3,     4,     5,
       6,    -1,    -1,   147,   148,    11,    -1,    13,    -1,    -1,
     108,    -1,    -1,    -1,    -1,   159,    -1,    -1,    -1,    -1,
      -1,    -1,   166,    -1,    -1,    -1,   170,   171,    -1,    -1,
      -1,   129,   130,   131,   132,   133,   134,    89,    90,    -1,
      -1,    47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   147,
     148,    -1,    -1,    -1,    -1,    -1,   108,    -1,    -1,    -1,
      -1,   159,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,   170,   171,    -1,    -1,    -1,   129,   130,   131,
     132,   133,   134,    89,    90,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   147,   148,    -1,    -1,    -1,
      -1,    -1,   108,    -1,    -1,    -1,    -1,   159,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,     4,    -1,   170,   171,
      -1,    -1,    10,   129,   130,   131,   132,   133,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,
      28,   147,   148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      38,    39,    40,   159,    -1,    -1,    -1,    -1,    -1,    -1,
     166,    -1,    -1,    -1,   170,   171,    54,    -1,    56,    -1,
      58,    59,    60,    -1,     8,    -1,    10,    -1,    66,    67,
      68,    -1,    16,    17,    18,    19,    -1,    -1,    -1,    23,
      -1,    -1,    26,    -1,    -1,    29,    -1,    -1,    -1,    87,
      88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,   103,   104,   105,    -1,    -1,
      54,    -1,    56,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    76,    -1,    78,    -1,    -1,    81,     8,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,
      94,    95,    -1,    23,    98,    -1,    -1,    -1,    -1,    29,
      -1,    -1,   106,   161,    -1,    -1,    -1,    -1,   166,   113,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,
      -1,    -1,   126,    -1,    54,    -1,    56,    -1,    58,    -1,
      -1,    -1,     8,    -1,    10,    -1,    66,    67,    68,    -1,
      16,    17,    18,    19,    -1,    75,    76,    23,    78,    -1,
      -1,    81,    -1,    29,    -1,    -1,    -1,   161,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    -1,    -1,    98,    99,
      -1,    -1,    48,    -1,    -1,    -1,   106,    -1,    54,    -1,
      56,    -1,    58,   113,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    67,    68,    -1,    -1,    -1,   126,    -1,    -1,    75,
      76,    -1,    78,    -1,    -1,    81,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      -1,    -1,    98,    -1,     8,    -1,    10,    -1,    -1,    -1,
     106,   161,    16,    17,    18,    19,    -1,   113,    -1,    23,
      -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,
     126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      10,    -1,    -1,    -1,    48,    -1,    16,    17,    18,    19,
      54,    55,    56,    23,    58,    -1,    -1,    -1,    -1,    29,
      -1,    -1,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    76,    -1,    78,    -1,    -1,    81,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    58,    -1,
      94,    95,    -1,    -1,    98,    -1,    66,    67,    68,    -1,
      -1,    -1,   106,    -1,    -1,    75,    76,    -1,    78,   113,
      -1,    81,    -1,    -1,     4,    -1,    -1,     7,    -1,    -1,
      -1,    -1,   126,    -1,    94,    95,    -1,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   106,    27,    28,    -1,
      -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,    38,    39,
      40,    -1,    -1,    -1,    -1,    -1,   126,    -1,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    71,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   169,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   173,   174,     0,    23,    33,    95,   126,   175,   176,
     177,   179,   187,   206,   211,   216,   248,   316,   318,   371,
     180,   212,    14,    15,    44,    45,    46,    94,   106,   109,
     110,   111,   112,   113,   159,   186,   238,   239,   326,   339,
     341,   372,   373,   217,    25,    27,    28,    30,    61,    71,
      73,   178,   175,   175,   175,   175,   175,   175,   175,   175,
     175,     4,   182,   183,   184,   185,     4,   327,    14,    47,
     108,   256,    47,   108,   257,   340,   164,   240,   242,     4,
      14,   370,   185,   220,   223,   188,   317,   319,   207,     4,
      65,   261,   261,    21,   181,   156,    32,   157,   158,   213,
      44,    45,   238,   328,   329,   330,   160,   107,   342,   343,
       3,     5,     6,    11,    13,    47,    89,    90,   108,   129,
     130,   131,   132,   133,   134,   147,   148,   159,   166,   170,
     171,   185,   449,   472,   473,   476,   370,   161,   218,   163,
     221,     4,    47,    84,   108,   186,   308,   309,   310,   312,
     313,   314,   315,   329,   330,   315,     4,     4,   157,   163,
      44,    45,   186,   238,   254,   255,     4,   182,    24,   184,
       4,   472,     4,   162,   190,   166,    47,   108,   331,   331,
      47,   108,   344,   166,    11,    12,   153,   176,   176,   153,
     176,   176,   176,   176,   176,   176,   176,   176,   472,   472,
     475,   176,   176,   164,   176,   240,   241,   242,   476,    91,
      92,   163,   165,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     169,   241,   242,   243,     4,   222,   223,   189,   242,   311,
     308,     4,   320,   321,   322,   308,   320,   208,   249,     4,
       4,   256,     4,   257,   252,    22,   159,   159,   197,     4,
     332,   333,   242,   345,   346,   350,   351,    12,   159,   159,
     159,   159,   473,   473,   473,   473,   473,   473,   473,   473,
     160,   163,   156,   166,   167,   473,   473,   472,   474,   240,
     240,   472,   472,   472,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     159,   176,   161,   219,   156,   190,   156,   161,   157,   240,
     161,   161,   159,   259,     4,   157,   253,   240,   159,   262,
     191,     4,   158,   160,   176,   198,   201,   161,   157,   334,
     156,   199,   167,   346,     4,   347,   348,   186,   329,   330,
     352,   353,   355,   472,   472,   472,   472,   476,   472,   472,
     475,   475,   165,   159,   165,   165,   165,   473,   473,   473,
     473,   473,   473,   473,   473,   473,   473,   473,   473,   473,
     473,   473,   473,   473,   473,   473,   473,   473,   473,   473,
     473,   473,   473,   472,   472,   162,   388,   223,   197,   321,
     472,   209,     4,   258,   260,   161,   250,     4,   262,   160,
     263,   161,   176,   193,   194,   321,   202,   203,   158,   227,
     228,   229,   230,   231,   156,   199,   214,   473,   333,   167,
     349,   156,   161,   331,   331,   341,   160,   160,   160,   160,
     163,   167,   158,   453,   454,   455,   472,   160,   163,   159,
       4,   380,   384,   161,    31,   176,   210,   248,   316,   318,
     371,     4,   156,   160,   259,     4,   161,   176,   265,   266,
     268,   269,    27,    28,   156,   192,   157,   200,     4,   158,
      38,    39,    40,   232,    96,    97,   234,   242,   201,   160,
      29,    34,    35,    48,   176,   215,   216,   316,   318,   323,
     358,   367,   371,   396,   407,   242,   348,   243,   354,   472,
     167,   185,   449,   156,   199,   472,   158,   389,   390,   472,
     381,   156,   161,   244,   163,   404,   258,   161,   251,   269,
     231,   156,   199,     4,   366,     8,    74,   162,   176,   179,
     225,   316,   318,   358,   371,   405,   415,   417,   420,   433,
     195,   196,   194,   160,   472,   204,   234,    97,    36,    41,
      42,    43,    44,    45,    83,   186,   236,   237,   238,     4,
     242,   324,   325,     4,   225,   226,    49,    50,    51,    52,
      53,    87,    88,   231,   394,   395,   342,   160,   455,   160,
       4,   156,   160,   159,   380,    10,    26,    54,    56,    58,
      66,    67,    68,    75,    76,    78,    81,    98,   161,   176,
     179,   216,   245,   246,   248,   270,   280,   283,   316,   318,
     323,   326,   337,   338,   339,   358,   367,   371,   374,   396,
     405,   416,   434,   460,   466,     4,   259,    72,   242,   266,
     264,   243,   163,     4,     5,     6,   159,    10,    54,    56,
      58,    59,    60,   103,   104,   105,   161,   166,   185,   449,
     450,   420,    16,    17,    18,    19,   161,   434,   315,   315,
     200,   235,   236,    44,   237,   237,    47,   108,   233,   205,
     449,   156,   161,   408,   368,   369,   450,   400,     4,     4,
     242,   399,   397,   159,   390,   176,   391,   392,   393,   465,
     404,   467,   159,   159,     4,    56,   271,   272,   274,     4,
      56,    77,   281,   282,   283,   287,   288,   289,   301,   306,
     164,   284,   285,   286,   306,   456,     4,     4,     7,    64,
     377,     4,   335,   336,     4,   356,   357,    16,    17,    18,
      19,   159,   161,   267,   160,   224,   472,   422,   423,   159,
     159,   159,   159,   451,   472,   421,   101,   102,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     140,   157,   418,    20,    93,   406,   406,   406,   161,   406,
     159,   321,   321,   233,   200,   157,   325,   159,   410,   156,
     161,   157,   420,   361,   362,   359,   420,   168,   401,   160,
     472,    37,   158,   472,   160,   156,   159,   452,   404,   472,
     461,   159,   159,    77,   271,   159,   307,   159,    77,   282,
     159,   293,   294,   161,   159,   304,   472,   285,   156,   161,
     157,    82,   176,   245,   457,   460,   466,   161,   375,   226,
     156,   161,   156,   161,    93,    93,    93,    93,   472,   366,
     156,   160,   163,   452,   404,   472,   425,   472,   472,   167,
     156,   452,   226,   226,   226,   159,   159,   159,   159,   472,
     472,     4,    38,    39,   160,   411,   412,   413,   414,   409,
     369,   472,   363,   363,   226,    21,   149,   159,   398,   160,
       4,   393,   453,   161,   468,   160,     4,    83,   458,   459,
      62,    63,   277,   472,   277,   243,   305,   472,    62,    63,
     292,   295,   299,   306,   157,   157,    62,    63,   302,   303,
     305,   163,   161,   286,   305,   161,   247,   388,   376,   336,
     357,   159,   159,   159,   159,   160,   224,   472,   161,   424,
     160,     4,   229,   419,   160,   160,   451,   161,   472,   472,
     472,   100,   472,   100,   472,   100,   472,   160,   472,   160,
     156,   199,   413,   161,   156,   161,   161,   364,   365,   366,
     160,    22,    62,    63,   149,   402,   403,   472,   420,   159,
     199,   456,   463,   458,   157,   161,   472,   160,   472,   160,
     163,   295,   299,   149,   147,   148,   156,   296,   298,   159,
     290,   305,   290,   306,   306,    80,   156,   160,   304,   244,
       4,   378,   379,   380,   382,   379,   385,   386,   387,   100,
     472,   100,   472,   100,   472,   472,   464,   156,   160,   163,
     436,   430,   157,   242,   161,   428,   429,   472,   160,   472,
     160,   472,   160,   161,   160,   432,   412,   160,     4,   156,
     360,   157,   472,   472,   160,    64,   156,   160,   160,   472,
     160,    55,   466,   469,   470,   157,   472,   472,    79,   275,
       9,   472,   149,   157,   298,   142,   299,   156,   298,   157,
     305,   472,   156,   291,   302,   302,   161,   165,    99,   240,
     156,   161,   156,   161,   159,   472,   160,   472,   160,   472,
     160,   160,   443,   224,   472,    55,   420,   420,   472,     4,
     472,   420,   420,   160,   161,   160,   161,   160,   161,   161,
     435,   365,   161,   472,   403,   403,   160,   404,    57,   471,
     457,   472,   462,   472,   156,   159,   276,   472,   163,   142,
     142,   297,   300,   306,   299,   142,   291,   163,   305,   383,
     379,   386,   391,   160,   161,   160,   161,   160,   161,   161,
      69,   444,   445,   160,   404,   431,   157,   426,   161,   161,
     161,    85,    86,   439,   469,   161,   277,   472,   160,   472,
     159,   159,   156,   160,   300,   160,   472,   291,   159,   160,
     161,   161,   161,     8,    70,   447,   448,   472,    57,   437,
     472,   161,    69,   440,   441,   176,   417,   472,    91,    92,
     163,   157,   297,   300,   300,   160,   163,   391,   446,   156,
     163,   438,   417,   447,   160,   275,   472,   472,   472,   159,
     278,   279,   472,    91,   298,    91,   298,   472,   160,   469,
     472,   420,   160,   442,   469,   156,   160,   160,   160,   279,
     472,   161,   163,   305,   163,   305,   163,   427,   420,   279,
     156,   163,   472,   160,   305,   160,   305,   420,   156,   273,
     279,   472,   163,   160,   160,   160,   160,   279,   160,   156,
     160,   163,   472,   160,   160,   161,   279,   472,   156,   160,
     279,   156,   279,   156,   279,   156,   160,   279,   156,   279,
     156,   279,   156,   279,   156,   279,   156,   279,   160
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   172,   174,   173,   175,   175,   175,   175,   175,   175,
     175,   175,   175,   175,   177,   176,   178,   178,   180,   181,
     179,   182,   182,   183,   183,   184,   184,   185,   185,   185,
     186,   186,   186,   188,   189,   187,   191,   192,   190,   190,
     193,   193,   194,   195,   194,   196,   194,   194,   197,   197,
     197,   198,   198,   199,   199,   200,   200,   202,   201,   203,
     204,   201,   205,   201,   201,   207,   208,   206,   209,   209,
     210,   210,   210,   210,   212,   213,   211,   214,   214,   215,
     215,   215,   215,   215,   215,   215,   215,   215,   217,   218,
     219,   216,   220,   221,   221,   222,   222,   223,   224,   224,
     225,   225,   225,   225,   225,   225,   226,   226,   228,   227,
     230,   229,   231,   231,   232,   232,   232,   233,   233,   233,
     234,   234,   234,   234,   235,   235,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,   237,   237,   237,   238,
     238,   238,   238,   238,   239,   239,   240,   240,   240,   240,
     241,   241,   242,   242,   243,   243,   244,   244,   244,   244,
     244,   245,   245,   245,   245,   245,   245,   245,   245,   245,
     245,   245,   245,   245,   245,   245,   245,   245,   245,   245,
     247,   246,   249,   248,   250,   248,   251,   248,   252,   248,
     253,   248,   254,   254,   254,   254,   255,   255,   255,   256,
     256,   256,   257,   257,   257,   258,   258,   259,   259,   260,
     260,   260,   260,   261,   261,   262,   262,   263,   264,   262,
     265,   265,   267,   266,   268,   266,   269,   269,   270,   271,
     271,   272,   272,   273,   273,   274,   274,   275,   275,   276,
     276,   276,   276,   277,   277,   277,   278,   278,   278,   278,
     278,   279,   279,   280,   280,   281,   281,   282,   282,   282,
     283,   283,   284,   285,   285,   286,   287,   287,   288,   289,
     289,   290,   290,   290,   291,   291,   292,   292,   293,   293,
     293,   294,   294,   294,   295,   295,   296,   296,   297,   297,
     298,   298,   298,   299,   300,   301,   302,   302,   302,   303,
     303,   303,   304,   305,   305,   307,   306,   308,   308,   308,
     309,   310,   311,   312,   313,   313,   314,   315,   315,   315,
     315,   315,   317,   316,   319,   318,   320,   320,   321,   321,
     322,   323,   324,   324,   325,   327,   326,   328,   328,   328,
     329,   330,   330,   331,   331,   331,   332,   332,   333,   334,
     334,   335,   335,   336,   337,   338,   340,   339,   341,   341,
     342,   343,   343,   344,   344,   344,   345,   345,   346,   347,
     347,   349,   348,   351,   350,   352,   352,   353,   354,   352,
     355,   355,   356,   356,   357,   359,   360,   358,   361,   358,
     362,   358,   363,   363,   364,   364,   365,   365,   366,   367,
     368,   368,   369,   370,   370,   371,   371,   372,   372,   372,
     373,   373,   375,   374,   376,   374,   377,   377,   378,   378,
     379,   379,   381,   380,   383,   382,   384,   384,   385,   385,
     386,   387,   386,   388,   388,   389,   389,   390,   390,   390,
     390,   391,   392,   392,   393,   393,   393,   393,   393,   393,
     394,   394,   395,   395,   397,   398,   396,   399,   396,   400,
     396,   401,   401,   401,   401,   401,   401,   402,   402,   402,
     403,   403,   403,   404,   404,   405,   405,   406,   406,   406,
     408,   409,   407,   410,   410,   411,   411,   412,   412,   413,
     414,   414,   415,   415,   415,   415,   415,   415,   415,   415,
     415,   416,   416,   416,   416,   416,   416,   416,   417,   417,
     417,   417,   417,   418,   418,   418,   418,   418,   418,   418,
     418,   418,   418,   418,   418,   419,   419,   419,   420,   420,
     420,   420,   420,   420,   420,   420,   420,   421,   420,   422,
     420,   423,   424,   420,   425,   426,   427,   420,   428,   420,
     429,   420,   430,   431,   420,   432,   420,   433,   433,   433,
     433,   434,   434,   434,   435,   435,   435,   436,   436,   438,
     437,   437,   439,   439,   441,   442,   440,   443,   443,   445,
     446,   444,   447,   447,   448,   448,   448,   448,   449,   449,
     449,   450,   450,   451,   451,   452,   452,   453,   453,   454,
     454,   455,   456,   456,   456,   457,   457,   457,   458,   459,
     459,   459,   461,   462,   460,   463,   460,   464,   460,   465,
     460,   467,   468,   466,   470,   469,   469,   471,   471,   472,
     472,   473,   473,   473,   473,   473,   473,   474,   473,   473,
     473,   473,   473,   473,   473,   473,   473,   473,   473,   473,
     473,   473,   473,   473,   473,   473,   473,   473,   473,   473,
     473,   473,   473,   473,   473,   473,   473,   473,   473,   473,
     473,   473,   473,   473,   473,   473,   473,   473,   473,   473,
     473,   473,   473,   473,   475,   475,   476,   476,   476,   476
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     0,     0,     2,     4,     0,     0,     0,
       5,     1,     0,     1,     3,     1,     3,     1,     3,     3,
       1,     1,     3,     0,     0,    11,     0,     0,     6,     0,
       1,     3,     0,     0,     5,     0,     5,     1,     2,     0,
       4,     1,     3,     1,     0,     2,     0,     0,     3,     0,
       0,     5,     0,     6,     3,     0,     0,     9,     2,     0,
       1,     1,     1,     1,     0,     0,     9,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     0,
       0,     9,     2,     2,     0,     1,     3,     1,     1,     5,
       2,     2,     2,     4,     6,     8,     1,     0,     0,     5,
       0,     4,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     1,     1,     0,     1,     0,     1,     1,     1,     2,
       1,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     5,     5,     5,     3,
       2,     2,     1,     0,     1,     1,     2,     2,     2,     2,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       0,     6,     0,     7,     0,     9,     0,    11,     0,     9,
       0,    10,     1,     2,     3,     2,     0,     1,     1,     0,
       1,     1,     0,     1,     1,     2,     1,     3,     0,     3,
       2,     1,     0,     1,     0,     2,     0,     0,     0,     6,
       1,     3,     0,     5,     0,     2,     2,     0,     3,     2,
       0,    10,    14,     2,     0,     4,     0,     2,     0,     1,
       5,     5,     5,     1,     1,     0,     1,     5,     7,    13,
      25,     1,     5,     3,     2,     2,     1,     1,     1,     1,
       3,     4,     5,     1,     3,     3,     4,     0,     2,     4,
       4,     4,     1,     2,     2,     3,     1,     1,     7,    12,
      11,     6,    12,    11,     2,     3,     2,     3,     1,     3,
       1,     1,     0,     1,     1,     5,     2,     2,     1,     1,
       3,     3,     1,     1,     5,     0,     3,     1,     1,     0,
       1,     1,     1,     2,     2,     3,     2,     1,     1,     1,
       1,     1,     0,     6,     0,     6,     1,     3,     3,     1,
       1,     3,     1,     3,     4,     0,     7,     2,     3,     0,
       1,     1,     1,     1,     1,     0,     1,     3,     2,     2,
       0,     1,     3,     1,     3,     3,     0,     3,     1,     1,
       4,     2,     0,     1,     1,     0,     1,     2,     3,     1,
       3,     0,     3,     0,     2,     1,     1,     0,     0,     4,
       2,     3,     1,     3,     1,     0,     0,     8,     0,     6,
       0,     6,     0,     3,     1,     3,     1,     3,     2,     4,
       1,     3,     3,     1,     1,     6,     4,     1,     2,     2,
       1,     1,     0,     6,     0,     6,     1,     1,     1,     3,
       1,     1,     0,     5,     0,     6,     1,     3,     1,     3,
       1,     0,     4,     4,     0,     1,     3,     0,     1,     4,
       5,     1,     1,     3,     1,     2,     6,     5,     3,     2,
       1,     1,     1,     1,     0,     0,     6,     0,     4,     0,
       4,     4,     4,     3,     3,     2,     0,     1,     3,     3,
       2,     2,     1,     2,     0,     2,     0,     1,     1,     0,
       0,     0,     6,     2,     4,     1,     3,     2,     1,     1,
       1,     1,     7,     7,     8,     8,     7,     6,     3,     7,
       8,     7,     7,     8,     8,     7,     7,     8,     5,     3,
       3,     5,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     5,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     0,     5,     0,
       5,     0,     0,     8,     0,     0,     0,    13,     0,     7,
       0,     7,     0,     0,     9,     0,     9,     1,     2,     2,
       2,     1,     1,     1,     2,     2,     0,     2,     0,     0,
       3,     0,     2,     0,     0,     0,     4,     2,     0,     0,
       0,     4,     2,     1,     1,     1,     1,     3,     6,     2,
       2,     1,     3,     1,     3,     4,     0,     1,     0,     1,
       3,     1,     2,     2,     0,     1,     1,     2,     1,     2,
       4,     3,     0,     0,    11,     0,     7,     0,     7,     0,
       4,     0,     0,     7,     0,     2,     1,     2,     0,     1,
       6,     1,     4,     2,     1,     1,     1,     0,     7,     5,
       5,     3,     7,     3,     6,     3,     4,     4,     4,     4,
       4,     4,     3,     3,     3,     3,     3,     3,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     3,     3,     4,     4,
       3,     5,     5,     5,     1,     3,     1,     1,     2,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = FRONTEND_VERILOG_YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == FRONTEND_VERILOG_YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        YY_LAC_DISCARD ("YYBACKUP");                              \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use FRONTEND_VERILOG_YYerror or FRONTEND_VERILOG_YYUNDEF. */
#define YYERRCODE FRONTEND_VERILOG_YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if FRONTEND_VERILOG_YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !FRONTEND_VERILOG_YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !FRONTEND_VERILOG_YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return YYENOMEM if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYPTRDIFF_T *yycapacity, YYPTRDIFF_T yyadd,
#if FRONTEND_VERILOG_YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yy_state_t **yybottom,
                      yy_state_t *yybottom_no_free,
                      yy_state_t **yytop, yy_state_t *yytop_empty)
{
  YYPTRDIFF_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYPTRDIFF_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYPTRDIFF_T yyalloc = 2 * yysize_new;
      yy_state_t *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        YY_CAST (yy_state_t *,
                 YYSTACK_ALLOC (YY_CAST (YYSIZE_T,
                                         yyalloc * YYSIZEOF (*yybottom_new))));
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                                \
do {                                                                    \
  if (!yy_lac_established)                                              \
    {                                                                   \
      YYDPRINTF ((stderr,                                               \
                  "LAC: initial context established for %s\n",          \
                  yysymbol_name (yytoken)));                            \
      yy_lac_established = 1;                                           \
      switch (yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken))    \
        {                                                               \
        case YYENOMEM:                                                  \
          goto yyexhaustedlab;                                          \
        case 1:                                                         \
          goto yyerrlab;                                                \
        }                                                               \
    }                                                                   \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if FRONTEND_VERILOG_YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      YYDPRINTF ((stderr, "LAC: initial context discarded due to "       \
                  Event "\n"));                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return YYENOMEM if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yy_state_t *yyesa, yy_state_t **yyes,
        YYPTRDIFF_T *yyes_capacity, yy_state_t *yyssp, yysymbol_kind_t yytoken)
{
  yy_state_t *yyes_prev = yyssp;
  yy_state_t *yyesp = yyes_prev;
  /* Reduce until we encounter a shift and thereby accept the token.  */
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yysymbol_name (yytoken)));
  if (yytoken == YYSYMBOL_YYUNDEF)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[+*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          /* Use the default action.  */
          yyrule = yydefact[+*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          /* Use the action from yytable.  */
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      /* By now we know we have to simulate a reduce.  */
      YYDPRINTF ((stderr, " R%d", yyrule - 1));
      {
        /* Pop the corresponding number of values from the stack.  */
        YYPTRDIFF_T yylen = yyr2[yyrule];
        /* First pop from the LAC stack as many tokens as possible.  */
        if (yyesp != yyes_prev)
          {
            YYPTRDIFF_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yyesp = yyes_prev;
                yylen -= yysize;
              }
          }
        /* Only afterwards look at the main stack.  */
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      /* Push the resulting state of the reduction.  */
      {
        yy_state_fast_t yystate;
        {
          const int yylhs = yyr1[yyrule] - YYNTOKENS;
          const int yyi = yypgoto[yylhs] + *yyesp;
          yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyesp
                     ? yytable[yyi]
                     : yydefgoto[yylhs]);
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            YY_IGNORE_USELESS_CAST_BEGIN
            *yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if FRONTEND_VERILOG_YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return YYENOMEM;
              }
            YY_IGNORE_USELESS_CAST_BEGIN
            *++yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}

/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yy_state_t *yyesa;
  yy_state_t **yyes;
  YYPTRDIFF_T *yyes_capacity;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;

  int yyx;
  for (yyx = 0; yyx < YYNTOKENS; ++yyx)
    {
      yysymbol_kind_t yysym = YY_CAST (yysymbol_kind_t, yyx);
      if (yysym != YYSYMBOL_YYerror && yysym != YYSYMBOL_YYUNDEF)
        switch (yy_lac (yyctx->yyesa, yyctx->yyes, yyctx->yyes_capacity, yyctx->yyssp, yysym))
          {
          case YYENOMEM:
            return YYENOMEM;
          case 1:
            continue;
          default:
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = yysym;
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else if (yyn == 0)
        YYDPRINTF ((stderr, "No expected tokens.\n"));
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store or if
   yy_lac returned YYENOMEM.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

    yy_state_t yyesa[20];
    yy_state_t *yyes = yyesa;
    YYPTRDIFF_T yyes_capacity = 20 < YYMAXDEPTH ? 20 : YYMAXDEPTH;

  /* Whether LAC context is established.  A Boolean.  */
  int yy_lac_established = 0;
  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = FRONTEND_VERILOG_YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == FRONTEND_VERILOG_YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc);
    }

  if (yychar <= FRONTEND_VERILOG_YYEOF)
    {
      yychar = FRONTEND_VERILOG_YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == FRONTEND_VERILOG_YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = FRONTEND_VERILOG_YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      YY_LAC_ESTABLISH;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = FRONTEND_VERILOG_YYEMPTY;
  YY_LAC_DISCARD ("shift");
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
  case 2: /* $@1: %empty  */
#line 417 "frontends/verilog/verilog_parser.y"
       {
	ast_stack.clear();
	ast_stack.push_back(current_ast);
}
#line 3809 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 3: /* input: $@1 design  */
#line 420 "frontends/verilog/verilog_parser.y"
         {
	ast_stack.pop_back();
	log_assert(GetSize(ast_stack) == 0);
	for (auto &it : default_attr_list)
		delete it.second;
	default_attr_list.clear();
}
#line 3821 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 14: /* $@2: %empty  */
#line 441 "frontends/verilog/verilog_parser.y"
        {
		if (attr_list != nullptr)
			attr_list_stack.push(attr_list);
		attr_list = new dict<IdString, AstNode*>;
		for (auto &it : default_attr_list)
			(*attr_list)[it.first] = it.second->clone();
	}
#line 3833 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 15: /* attr: $@2 attr_opt  */
#line 447 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.al) = attr_list;
		if (!attr_list_stack.empty()) {
			attr_list = attr_list_stack.top();
			attr_list_stack.pop();
		} else
			attr_list = nullptr;
	}
#line 3846 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 16: /* attr_opt: attr_opt ATTR_BEGIN opt_attr_list ATTR_END  */
#line 457 "frontends/verilog/verilog_parser.y"
                                                   {
		SET_RULE_LOC((yyloc), (yylsp[-2]), (yyloc));
	}
#line 3854 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 18: /* $@3: %empty  */
#line 463 "frontends/verilog/verilog_parser.y"
                      {
		if (attr_list != nullptr)
			attr_list_stack.push(attr_list);
		attr_list = new dict<IdString, AstNode*>;
		for (auto &it : default_attr_list)
			delete it.second;
		default_attr_list.clear();
	}
#line 3867 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 19: /* $@4: %empty  */
#line 470 "frontends/verilog/verilog_parser.y"
                        {
		attr_list->swap(default_attr_list);
		delete attr_list;
		if (!attr_list_stack.empty()) {
			attr_list = attr_list_stack.top();
			attr_list_stack.pop();
		} else
			attr_list = nullptr;
	}
#line 3881 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 25: /* attr_assign: hierarchical_id  */
#line 488 "frontends/verilog/verilog_parser.y"
                        {
		if (attr_list->count(*(yyvsp[0].string)) != 0)
			delete (*attr_list)[*(yyvsp[0].string)];
		(*attr_list)[*(yyvsp[0].string)] = AstNode::mkconst_int(1, false);
		delete (yyvsp[0].string);
	}
#line 3892 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 26: /* attr_assign: hierarchical_id '=' expr  */
#line 494 "frontends/verilog/verilog_parser.y"
                                 {
		if (attr_list->count(*(yyvsp[-2].string)) != 0)
			delete (*attr_list)[*(yyvsp[-2].string)];
		(*attr_list)[*(yyvsp[-2].string)] = (yyvsp[0].ast);
		delete (yyvsp[-2].string);
	}
#line 3903 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 27: /* hierarchical_id: TOK_ID  */
#line 502 "frontends/verilog/verilog_parser.y"
               {
		(yyval.string) = (yyvsp[0].string);
	}
#line 3911 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 28: /* hierarchical_id: hierarchical_id TOK_PACKAGESEP TOK_ID  */
#line 505 "frontends/verilog/verilog_parser.y"
                                              {
		if ((yyvsp[0].string)->compare(0, 1, "\\") == 0)
			*(yyvsp[-2].string) += "::" + (yyvsp[0].string)->substr(1);
		else
			*(yyvsp[-2].string) += "::" + *(yyvsp[0].string);
		delete (yyvsp[0].string);
		(yyval.string) = (yyvsp[-2].string);
	}
#line 3924 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 29: /* hierarchical_id: hierarchical_id '.' TOK_ID  */
#line 513 "frontends/verilog/verilog_parser.y"
                                   {
		if ((yyvsp[0].string)->compare(0, 1, "\\") == 0)
			*(yyvsp[-2].string) += "." + (yyvsp[0].string)->substr(1);
		else
			*(yyvsp[-2].string) += "." + *(yyvsp[0].string);
		delete (yyvsp[0].string);
		(yyval.string) = (yyvsp[-2].string);
	}
#line 3937 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 32: /* hierarchical_type_id: '(' TOK_USER_TYPE ')'  */
#line 525 "frontends/verilog/verilog_parser.y"
                                { (yyval.string) = (yyvsp[-1].string); }
#line 3943 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 33: /* $@5: %empty  */
#line 529 "frontends/verilog/verilog_parser.y"
                        {
		enterTypeScope();
	}
#line 3951 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 34: /* $@6: %empty  */
#line 531 "frontends/verilog/verilog_parser.y"
                 {
		do_not_require_port_stubs = false;
		AstNode *mod = new AstNode(AST_MODULE);
		ast_stack.back()->children.push_back(mod);
		ast_stack.push_back(mod);
		current_ast_mod = mod;
		port_stubs.clear();
		port_counter = 0;
		mod->str = *(yyvsp[0].string);
		append_attr(mod, (yyvsp[-3].al));
	}
#line 3967 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 35: /* module: attr TOK_MODULE $@5 TOK_ID $@6 module_para_opt module_args_opt ';' module_body TOK_ENDMODULE opt_label  */
#line 541 "frontends/verilog/verilog_parser.y"
                                                                                  {
		if (port_stubs.size() != 0)
			frontend_verilog_yyerror("Missing details for module port `%s'.",
					port_stubs.begin()->first.c_str());
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-9]), (yyloc));
		ast_stack.pop_back();
		log_assert(ast_stack.size() == 1);
		checkLabelsMatch("Module name", (yyvsp[-7].string), (yyvsp[0].string));
		current_ast_mod = NULL;
		delete (yyvsp[-7].string);
		delete (yyvsp[0].string);
		exitTypeScope();
	}
#line 3985 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 36: /* $@7: %empty  */
#line 556 "frontends/verilog/verilog_parser.y"
                { astbuf1 = nullptr; }
#line 3991 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 37: /* $@8: %empty  */
#line 556 "frontends/verilog/verilog_parser.y"
                                                        { if (astbuf1) delete astbuf1; }
#line 3997 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 43: /* $@9: %empty  */
#line 563 "frontends/verilog/verilog_parser.y"
                           {
		if (astbuf1) delete astbuf1;
		astbuf1 = new AstNode(AST_PARAMETER);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 4008 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 45: /* $@10: %empty  */
#line 569 "frontends/verilog/verilog_parser.y"
                            {
		if (astbuf1) delete astbuf1;
		astbuf1 = new AstNode(AST_LOCALPARAM);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 4019 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 55: /* module_arg_opt_assignment: '=' expr  */
#line 587 "frontends/verilog/verilog_parser.y"
                 {
		if (ast_stack.back()->children.size() > 0 && ast_stack.back()->children.back()->type == AST_WIRE) {
			if (ast_stack.back()->children.back()->is_input) {
				AstNode *n = ast_stack.back()->children.back();
				if (n->attributes.count(ID::defaultvalue))
					delete n->attributes.at(ID::defaultvalue);
				n->attributes[ID::defaultvalue] = (yyvsp[0].ast);
			} else {
				AstNode *wire = new AstNode(AST_IDENTIFIER);
				wire->str = ast_stack.back()->children.back()->str;
				if (ast_stack.back()->children.back()->is_reg || ast_stack.back()->children.back()->is_logic)
					ast_stack.back()->children.push_back(new AstNode(AST_INITIAL, new AstNode(AST_BLOCK, new AstNode(AST_ASSIGN_LE, wire, (yyvsp[0].ast)))));
				else
					ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, wire, (yyvsp[0].ast)));
			}
		} else
			frontend_verilog_yyerror("SystemVerilog interface in module port list cannot have a default value.");
	}
#line 4042 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 57: /* $@11: %empty  */
#line 608 "frontends/verilog/verilog_parser.y"
               {
		if (ast_stack.back()->children.size() > 0 && ast_stack.back()->children.back()->type == AST_WIRE) {
			AstNode *node = ast_stack.back()->children.back()->clone();
			node->str = *(yyvsp[0].string);
			node->port_id = ++port_counter;
			ast_stack.back()->children.push_back(node);
			SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		} else {
			if (port_stubs.count(*(yyvsp[0].string)) != 0)
				frontend_verilog_yyerror("Duplicate module port `%s'.", (yyvsp[0].string)->c_str());
			port_stubs[*(yyvsp[0].string)] = ++port_counter;
		}
		delete (yyvsp[0].string);
	}
#line 4061 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 59: /* $@12: %empty  */
#line 622 "frontends/verilog/verilog_parser.y"
               {
		astbuf1 = new AstNode(AST_INTERFACEPORT);
		astbuf1->children.push_back(new AstNode(AST_INTERFACEPORTTYPE));
		astbuf1->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 4072 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 60: /* $@13: %empty  */
#line 627 "frontends/verilog/verilog_parser.y"
                 {  /* SV interfaces */
		if (!sv_mode)
			frontend_verilog_yyerror("Interface found in port list (%s). This is not supported unless read_verilog is called with -sv!", (yyvsp[0].string)->c_str());
		astbuf2 = astbuf1->clone(); // really only needed if multiple instances of same type.
		astbuf2->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		astbuf2->port_id = ++port_counter;
		ast_stack.back()->children.push_back(astbuf2);
		delete astbuf1; // really only needed if multiple instances of same type.
	}
#line 4087 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 62: /* $@14: %empty  */
#line 637 "frontends/verilog/verilog_parser.y"
                                    {
		AstNode *node = (yyvsp[-2].ast);
		node->str = *(yyvsp[0].string);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		node->port_id = ++port_counter;
		AstNode *range = checkRange(node, (yyvsp[-1].ast));
		if (range != NULL)
			node->children.push_back(range);
		if (!node->is_input && !node->is_output)
			frontend_verilog_yyerror("Module port `%s' is neither input nor output.", (yyvsp[0].string)->c_str());
		if (node->is_reg && node->is_input && !node->is_output && !sv_mode)
			frontend_verilog_yyerror("Input port `%s' is declared as register.", (yyvsp[0].string)->c_str());
		ast_stack.back()->children.push_back(node);
		append_attr(node, (yyvsp[-3].al));
		delete (yyvsp[0].string);
	}
#line 4108 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 64: /* module_arg: '.' '.' '.'  */
#line 653 "frontends/verilog/verilog_parser.y"
                    {
		do_not_require_port_stubs = true;
	}
#line 4116 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 65: /* $@15: %empty  */
#line 658 "frontends/verilog/verilog_parser.y"
                         {
		enterTypeScope();
	}
#line 4124 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 66: /* $@16: %empty  */
#line 660 "frontends/verilog/verilog_parser.y"
                 {
		AstNode *mod = new AstNode(AST_PACKAGE);
		ast_stack.back()->children.push_back(mod);
		ast_stack.push_back(mod);
		current_ast_mod = mod;
		mod->str = *(yyvsp[0].string);
		append_attr(mod, (yyvsp[-3].al));
	}
#line 4137 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 67: /* package: attr TOK_PACKAGE $@15 TOK_ID $@16 ';' package_body TOK_ENDPACKAGE opt_label  */
#line 667 "frontends/verilog/verilog_parser.y"
                                                    {
		ast_stack.pop_back();
		checkLabelsMatch("Package name", (yyvsp[-5].string), (yyvsp[0].string));
		current_ast_mod = NULL;
		delete (yyvsp[-5].string);
		delete (yyvsp[0].string);
		exitTypeScope();
	}
#line 4150 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 74: /* $@17: %empty  */
#line 683 "frontends/verilog/verilog_parser.y"
                      {
		enterTypeScope();
	}
#line 4158 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 75: /* $@18: %empty  */
#line 685 "frontends/verilog/verilog_parser.y"
                 {
		do_not_require_port_stubs = false;
		AstNode *intf = new AstNode(AST_INTERFACE);
		ast_stack.back()->children.push_back(intf);
		ast_stack.push_back(intf);
		current_ast_mod = intf;
		port_stubs.clear();
		port_counter = 0;
		intf->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 4174 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 76: /* interface: TOK_INTERFACE $@17 TOK_ID $@18 module_para_opt module_args_opt ';' interface_body TOK_ENDINTERFACE  */
#line 695 "frontends/verilog/verilog_parser.y"
                                                                              {
		if (port_stubs.size() != 0)
			frontend_verilog_yyerror("Missing details for module port `%s'.",
				port_stubs.begin()->first.c_str());
		ast_stack.pop_back();
		log_assert(ast_stack.size() == 1);
		current_ast_mod = NULL;
		exitTypeScope();
	}
#line 4188 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 88: /* $@19: %empty  */
#line 713 "frontends/verilog/verilog_parser.y"
                 {
		AstNode *bnode = new AstNode(AST_BIND);
		ast_stack.back()->children.push_back(bnode);
		ast_stack.push_back(bnode);
	}
#line 4198 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 89: /* $@20: %empty  */
#line 718 "frontends/verilog/verilog_parser.y"
                    {
		// bind_target should have added at least one child
		log_assert(ast_stack.back()->children.size() >= 1);
	}
#line 4207 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 90: /* $@21: %empty  */
#line 722 "frontends/verilog/verilog_parser.y"
               {
		// The single_cell parser in cell_list_no_array uses astbuf1 as
		// a sort of template for constructing cells.
		astbuf1 = new AstNode(AST_CELL);
		astbuf1->children.push_back(new AstNode(AST_CELLTYPE));
		astbuf1->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 4220 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 91: /* bind_directive: TOK_BIND $@19 bind_target $@20 TOK_ID $@21 cell_parameter_list_opt cell_list_no_array ';'  */
#line 730 "frontends/verilog/verilog_parser.y"
                                                       {
		// cell_list should have added at least one more child
		log_assert(ast_stack.back()->children.size() >= 2);
		delete astbuf1;
		ast_stack.pop_back();
	}
#line 4231 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 97: /* bind_target_instance: hierarchical_id  */
#line 765 "frontends/verilog/verilog_parser.y"
                        {
		auto *node = new AstNode(AST_IDENTIFIER);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
	}
#line 4242 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 98: /* mintypmax_expr: expr  */
#line 773 "frontends/verilog/verilog_parser.y"
             { delete (yyvsp[0].ast); }
#line 4248 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 99: /* mintypmax_expr: expr ':' expr ':' expr  */
#line 774 "frontends/verilog/verilog_parser.y"
                               { delete (yyvsp[-4].ast); delete (yyvsp[-2].ast); delete (yyvsp[0].ast); }
#line 4254 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 100: /* non_opt_delay: '#' TOK_ID  */
#line 777 "frontends/verilog/verilog_parser.y"
                   { delete (yyvsp[0].string); }
#line 4260 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 101: /* non_opt_delay: '#' TOK_CONSTVAL  */
#line 778 "frontends/verilog/verilog_parser.y"
                         { delete (yyvsp[0].string); }
#line 4266 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 102: /* non_opt_delay: '#' TOK_REALVAL  */
#line 779 "frontends/verilog/verilog_parser.y"
                        { delete (yyvsp[0].string); }
#line 4272 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 108: /* $@22: %empty  */
#line 788 "frontends/verilog/verilog_parser.y"
        { astbuf3 = new AstNode(AST_WIRE); current_wire_rand = false; current_wire_const = false; }
#line 4278 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 109: /* io_wire_type: $@22 wire_type_token_io wire_type_const_rand opt_wire_type_token wire_type_signedness  */
#line 790 "frontends/verilog/verilog_parser.y"
        { (yyval.ast) = astbuf3; SET_RULE_LOC((yyloc), (yylsp[-3]), (yyloc)); }
#line 4284 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 110: /* $@23: %empty  */
#line 793 "frontends/verilog/verilog_parser.y"
        { astbuf3 = new AstNode(AST_WIRE); current_wire_rand = false; current_wire_const = false; }
#line 4290 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 111: /* non_io_wire_type: $@23 wire_type_const_rand wire_type_token wire_type_signedness  */
#line 795 "frontends/verilog/verilog_parser.y"
        { (yyval.ast) = astbuf3; SET_RULE_LOC((yyloc), (yylsp[-2]), (yyloc)); }
#line 4296 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 114: /* wire_type_token_io: TOK_INPUT  */
#line 802 "frontends/verilog/verilog_parser.y"
                  {
		astbuf3->is_input = true;
	}
#line 4304 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 115: /* wire_type_token_io: TOK_OUTPUT  */
#line 805 "frontends/verilog/verilog_parser.y"
                   {
		astbuf3->is_output = true;
	}
#line 4312 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 116: /* wire_type_token_io: TOK_INOUT  */
#line 808 "frontends/verilog/verilog_parser.y"
                  {
		astbuf3->is_input = true;
		astbuf3->is_output = true;
	}
#line 4321 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 117: /* wire_type_signedness: TOK_SIGNED  */
#line 814 "frontends/verilog/verilog_parser.y"
                     { astbuf3->is_signed = true;  }
#line 4327 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 118: /* wire_type_signedness: TOK_UNSIGNED  */
#line 815 "frontends/verilog/verilog_parser.y"
                     { astbuf3->is_signed = false; }
#line 4333 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 120: /* wire_type_const_rand: TOK_RAND TOK_CONST  */
#line 819 "frontends/verilog/verilog_parser.y"
                           {
	    current_wire_rand = true;
	    current_wire_const = true;
	}
#line 4342 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 121: /* wire_type_const_rand: TOK_CONST  */
#line 823 "frontends/verilog/verilog_parser.y"
                  {
	    current_wire_const = true;
	}
#line 4350 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 122: /* wire_type_const_rand: TOK_RAND  */
#line 826 "frontends/verilog/verilog_parser.y"
                 {
	    current_wire_rand = true;
	}
#line 4358 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 126: /* wire_type_token: TOK_WOR  */
#line 835 "frontends/verilog/verilog_parser.y"
                {
		astbuf3->is_wor = true;
	}
#line 4366 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 127: /* wire_type_token: TOK_WAND  */
#line 838 "frontends/verilog/verilog_parser.y"
                 {
		astbuf3->is_wand = true;
	}
#line 4374 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 128: /* wire_type_token: TOK_WIRE  */
#line 842 "frontends/verilog/verilog_parser.y"
                 {
	}
#line 4381 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 129: /* wire_type_token: TOK_WIRE logic_type  */
#line 844 "frontends/verilog/verilog_parser.y"
                            {
	}
#line 4388 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 130: /* wire_type_token: TOK_REG  */
#line 847 "frontends/verilog/verilog_parser.y"
                {
		astbuf3->is_reg = true;
	}
#line 4396 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 131: /* wire_type_token: TOK_VAR TOK_REG  */
#line 850 "frontends/verilog/verilog_parser.y"
                        {
		astbuf3->is_reg = true;
	}
#line 4404 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 132: /* wire_type_token: TOK_VAR  */
#line 854 "frontends/verilog/verilog_parser.y"
                {
		astbuf3->is_logic = true;
	}
#line 4412 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 133: /* wire_type_token: TOK_VAR logic_type  */
#line 857 "frontends/verilog/verilog_parser.y"
                           {
		astbuf3->is_logic = true;
	}
#line 4420 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 134: /* wire_type_token: logic_type  */
#line 860 "frontends/verilog/verilog_parser.y"
                   {
		astbuf3->is_logic = true;
	}
#line 4428 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 135: /* wire_type_token: TOK_GENVAR  */
#line 863 "frontends/verilog/verilog_parser.y"
                   {
		astbuf3->type = AST_GENVAR;
		astbuf3->is_reg = true;
		astbuf3->is_signed = true;
		astbuf3->range_left = 31;
		astbuf3->range_right = 0;
	}
#line 4440 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 136: /* logic_type: TOK_LOGIC  */
#line 872 "frontends/verilog/verilog_parser.y"
                  {
	}
#line 4447 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 137: /* logic_type: integer_atom_type  */
#line 874 "frontends/verilog/verilog_parser.y"
                          {
		astbuf3->range_left = (yyvsp[0].integer) - 1;
		astbuf3->range_right = 0;
		astbuf3->is_signed = true;
	}
#line 4457 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 138: /* logic_type: hierarchical_type_id  */
#line 879 "frontends/verilog/verilog_parser.y"
                             {
		addWiretypeNode((yyvsp[0].string), astbuf3);
	}
#line 4465 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 139: /* integer_atom_type: TOK_INTEGER  */
#line 884 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) = 32; }
#line 4471 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 140: /* integer_atom_type: TOK_INT  */
#line 885 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) = 32; }
#line 4477 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 141: /* integer_atom_type: TOK_SHORTINT  */
#line 886 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) = 16; }
#line 4483 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 142: /* integer_atom_type: TOK_LONGINT  */
#line 887 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) = 64; }
#line 4489 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 143: /* integer_atom_type: TOK_BYTE  */
#line 888 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) =  8; }
#line 4495 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 144: /* integer_vector_type: TOK_LOGIC  */
#line 891 "frontends/verilog/verilog_parser.y"
                  { (yyval.integer) = TOK_LOGIC; }
#line 4501 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 145: /* integer_vector_type: TOK_REG  */
#line 892 "frontends/verilog/verilog_parser.y"
                  { (yyval.integer) = TOK_REG; }
#line 4507 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 146: /* non_opt_range: '[' expr ':' expr ']'  */
#line 895 "frontends/verilog/verilog_parser.y"
                              {
		(yyval.ast) = new AstNode(AST_RANGE);
		(yyval.ast)->children.push_back((yyvsp[-3].ast));
		(yyval.ast)->children.push_back((yyvsp[-1].ast));
	}
#line 4517 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 147: /* non_opt_range: '[' expr TOK_POS_INDEXED expr ']'  */
#line 900 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_RANGE);
		AstNode *expr = new AstNode(AST_SELFSZ, (yyvsp[-3].ast));
		(yyval.ast)->children.push_back(new AstNode(AST_SUB, new AstNode(AST_ADD, expr->clone(), (yyvsp[-1].ast)), AstNode::mkconst_int(1, true)));
		(yyval.ast)->children.push_back(new AstNode(AST_ADD, expr, AstNode::mkconst_int(0, true)));
	}
#line 4528 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 148: /* non_opt_range: '[' expr TOK_NEG_INDEXED expr ']'  */
#line 906 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_RANGE);
		AstNode *expr = new AstNode(AST_SELFSZ, (yyvsp[-3].ast));
		(yyval.ast)->children.push_back(new AstNode(AST_ADD, expr, AstNode::mkconst_int(0, true)));
		(yyval.ast)->children.push_back(new AstNode(AST_SUB, new AstNode(AST_ADD, expr->clone(), AstNode::mkconst_int(1, true)), (yyvsp[-1].ast)));
	}
#line 4539 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 149: /* non_opt_range: '[' expr ']'  */
#line 912 "frontends/verilog/verilog_parser.y"
                     {
		(yyval.ast) = new AstNode(AST_RANGE);
		(yyval.ast)->children.push_back((yyvsp[-1].ast));
	}
#line 4548 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 150: /* non_opt_multirange: non_opt_range non_opt_range  */
#line 918 "frontends/verilog/verilog_parser.y"
                                    {
		(yyval.ast) = new AstNode(AST_MULTIRANGE, (yyvsp[-1].ast), (yyvsp[0].ast));
	}
#line 4556 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 151: /* non_opt_multirange: non_opt_multirange non_opt_range  */
#line 921 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = (yyvsp[-1].ast);
		(yyval.ast)->children.push_back((yyvsp[0].ast));
	}
#line 4565 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 152: /* range: non_opt_range  */
#line 927 "frontends/verilog/verilog_parser.y"
                      {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 4573 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 153: /* range: %empty  */
#line 930 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = NULL;
	}
#line 4581 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 154: /* range_or_multirange: range  */
#line 935 "frontends/verilog/verilog_parser.y"
              { (yyval.ast) = (yyvsp[0].ast); }
#line 4587 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 155: /* range_or_multirange: non_opt_multirange  */
#line 936 "frontends/verilog/verilog_parser.y"
                           { (yyval.ast) = (yyvsp[0].ast); }
#line 4593 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 180: /* $@24: %empty  */
#line 952 "frontends/verilog/verilog_parser.y"
                               {
		AstNode *node = new AstNode(AST_GENBLOCK);
		node->str = *(yyvsp[-1].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 4604 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 181: /* checker_decl: TOK_CHECKER TOK_ID ';' $@24 module_body TOK_ENDCHECKER  */
#line 957 "frontends/verilog/verilog_parser.y"
                                     {
		delete (yyvsp[-4].string);
		ast_stack.pop_back();
	}
#line 4613 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 182: /* $@25: %empty  */
#line 963 "frontends/verilog/verilog_parser.y"
                                            {
		current_function_or_task = new AstNode(AST_DPI_FUNCTION, AstNode::mkconst_str(*(yyvsp[-1].string)), AstNode::mkconst_str(*(yyvsp[0].string)));
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-3].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4626 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 183: /* task_func_decl: attr TOK_DPI_FUNCTION TOK_ID TOK_ID $@25 opt_dpi_function_args ';'  */
#line 970 "frontends/verilog/verilog_parser.y"
                                    {
		current_function_or_task = NULL;
	}
#line 4634 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 184: /* $@26: %empty  */
#line 973 "frontends/verilog/verilog_parser.y"
                                                       {
		current_function_or_task = new AstNode(AST_DPI_FUNCTION, AstNode::mkconst_str(*(yyvsp[-1].string)), AstNode::mkconst_str(*(yyvsp[-3].string)));
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-5].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		delete (yyvsp[-3].string);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4648 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 185: /* task_func_decl: attr TOK_DPI_FUNCTION TOK_ID '=' TOK_ID TOK_ID $@26 opt_dpi_function_args ';'  */
#line 981 "frontends/verilog/verilog_parser.y"
                                    {
		current_function_or_task = NULL;
	}
#line 4656 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 186: /* $@27: %empty  */
#line 984 "frontends/verilog/verilog_parser.y"
                                                                  {
		current_function_or_task = new AstNode(AST_DPI_FUNCTION, AstNode::mkconst_str(*(yyvsp[-1].string)), AstNode::mkconst_str(*(yyvsp[-5].string) + ":" + RTLIL::unescape_id(*(yyvsp[-3].string))));
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-7].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		delete (yyvsp[-5].string);
		delete (yyvsp[-3].string);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4671 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 187: /* task_func_decl: attr TOK_DPI_FUNCTION TOK_ID ':' TOK_ID '=' TOK_ID TOK_ID $@27 opt_dpi_function_args ';'  */
#line 993 "frontends/verilog/verilog_parser.y"
                                    {
		current_function_or_task = NULL;
	}
#line 4679 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 188: /* $@28: %empty  */
#line 996 "frontends/verilog/verilog_parser.y"
                                           {
		current_function_or_task = new AstNode(AST_TASK);
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-3].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		ast_stack.push_back(current_function_or_task);
		current_function_or_task_port_id = 1;
		delete (yyvsp[0].string);
	}
#line 4693 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 189: /* task_func_decl: attr TOK_TASK opt_automatic TOK_ID $@28 task_func_args_opt ';' task_func_body TOK_ENDTASK  */
#line 1004 "frontends/verilog/verilog_parser.y"
                                                            {
		current_function_or_task = NULL;
		ast_stack.pop_back();
	}
#line 4702 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 190: /* $@29: %empty  */
#line 1008 "frontends/verilog/verilog_parser.y"
                                                                {
		current_function_or_task = new AstNode(AST_FUNCTION);
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-4].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		ast_stack.push_back(current_function_or_task);
		AstNode *outreg = new AstNode(AST_WIRE);
		outreg->str = *(yyvsp[0].string);
		outreg->is_signed = false;
		outreg->is_reg = true;
		if ((yyvsp[-1].ast) != NULL) {
			outreg->children.push_back((yyvsp[-1].ast));
			outreg->is_signed = (yyvsp[-1].ast)->is_signed;
			(yyvsp[-1].ast)->is_signed = false;
			outreg->is_custom_type = (yyvsp[-1].ast)->type == AST_WIRETYPE;
		}
		current_function_or_task->children.push_back(outreg);
		current_function_or_task_port_id = 1;
		delete (yyvsp[0].string);
	}
#line 4727 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 191: /* task_func_decl: attr TOK_FUNCTION opt_automatic func_return_type TOK_ID $@29 task_func_args_opt ';' task_func_body TOK_ENDFUNCTION  */
#line 1027 "frontends/verilog/verilog_parser.y"
                                                                {
		current_function_or_task = NULL;
		ast_stack.pop_back();
	}
#line 4736 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 192: /* func_return_type: hierarchical_type_id  */
#line 1033 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.ast) = new AstNode(AST_WIRETYPE);
		(yyval.ast)->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 4746 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 193: /* func_return_type: opt_type_vec opt_signedness_default_unsigned  */
#line 1038 "frontends/verilog/verilog_parser.y"
                                                     {
		(yyval.ast) = makeRange(0, 0, (yyvsp[0].boolean));
	}
#line 4754 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 194: /* func_return_type: opt_type_vec opt_signedness_default_unsigned non_opt_range  */
#line 1041 "frontends/verilog/verilog_parser.y"
                                                                   {
		(yyval.ast) = (yyvsp[0].ast);
		(yyval.ast)->is_signed = (yyvsp[-1].boolean);
	}
#line 4763 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 195: /* func_return_type: integer_atom_type opt_signedness_default_signed  */
#line 1045 "frontends/verilog/verilog_parser.y"
                                                        {
		(yyval.ast) = makeRange((yyvsp[-1].integer) - 1, 0, (yyvsp[0].boolean));
	}
#line 4771 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 199: /* opt_signedness_default_signed: %empty  */
#line 1056 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = true; }
#line 4777 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 200: /* opt_signedness_default_signed: TOK_SIGNED  */
#line 1057 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = true; }
#line 4783 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 201: /* opt_signedness_default_signed: TOK_UNSIGNED  */
#line 1058 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = false; }
#line 4789 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 202: /* opt_signedness_default_unsigned: %empty  */
#line 1061 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = false; }
#line 4795 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 203: /* opt_signedness_default_unsigned: TOK_SIGNED  */
#line 1062 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = true; }
#line 4801 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 204: /* opt_signedness_default_unsigned: TOK_UNSIGNED  */
#line 1063 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = false; }
#line 4807 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 205: /* dpi_function_arg: TOK_ID TOK_ID  */
#line 1067 "frontends/verilog/verilog_parser.y"
                      {
		current_function_or_task->children.push_back(AstNode::mkconst_str(*(yyvsp[-1].string)));
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4817 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 206: /* dpi_function_arg: TOK_ID  */
#line 1072 "frontends/verilog/verilog_parser.y"
               {
		current_function_or_task->children.push_back(AstNode::mkconst_str(*(yyvsp[0].string)));
		delete (yyvsp[0].string);
	}
#line 4826 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 217: /* $@30: %empty  */
#line 1092 "frontends/verilog/verilog_parser.y"
                               {
		albuf = nullptr;
		astbuf1 = nullptr;
		astbuf2 = nullptr;
	}
#line 4836 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 218: /* $@31: %empty  */
#line 1096 "frontends/verilog/verilog_parser.y"
                                        {
		delete astbuf1;
		if (astbuf2 != NULL)
			delete astbuf2;
		free_attr(albuf);
	}
#line 4847 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 222: /* $@32: %empty  */
#line 1107 "frontends/verilog/verilog_parser.y"
                             {
		bool prev_was_input = true;
		bool prev_was_output = false;
		if (albuf) {
			prev_was_input = astbuf1->is_input;
			prev_was_output = astbuf1->is_output;
			delete astbuf1;
			if (astbuf2 != NULL)
				delete astbuf2;
			free_attr(albuf);
		}
		albuf = (yyvsp[-2].al);
		astbuf1 = (yyvsp[-1].ast);
		astbuf2 = checkRange(astbuf1, (yyvsp[0].ast));
		if (!astbuf1->is_input && !astbuf1->is_output) {
			if (!sv_mode)
				frontend_verilog_yyerror("task/function argument direction missing");
			astbuf1->is_input = prev_was_input;
			astbuf1->is_output = prev_was_output;
		}
	}
#line 4873 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 224: /* $@33: %empty  */
#line 1128 "frontends/verilog/verilog_parser.y"
        {
		if (!astbuf1) {
			if (!sv_mode)
				frontend_verilog_yyerror("task/function argument direction missing");
			albuf = new dict<IdString, AstNode*>;
			astbuf1 = new AstNode(AST_WIRE);
			current_wire_rand = false;
			current_wire_const = false;
			astbuf1->is_input = true;
			astbuf2 = NULL;
		}
	}
#line 4890 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 231: /* specify_item: specify_if '(' specify_edge expr TOK_SPECIFY_OPER specify_target ')' '=' specify_rise_fall ';'  */
#line 1155 "frontends/verilog/verilog_parser.y"
                                                                                                       {
		AstNode *en_expr = (yyvsp[-9].ast);
		char specify_edge = (yyvsp[-7].ch);
		AstNode *src_expr = (yyvsp[-6].ast);
		string *oper = (yyvsp[-5].string);
		specify_target *target = (yyvsp[-4].specify_target_ptr);
		specify_rise_fall *timing = (yyvsp[-1].specify_rise_fall_ptr);

		if (specify_edge != 0 && target->dat == nullptr)
			frontend_verilog_yyerror("Found specify edge but no data spec.\n");

		AstNode *cell = new AstNode(AST_CELL);
		ast_stack.back()->children.push_back(cell);
		cell->str = stringf("$specify$%d", autoidx++);
		cell->children.push_back(new AstNode(AST_CELLTYPE));
		cell->children.back()->str = target->dat ? "$specify3" : "$specify2";
		SET_AST_NODE_LOC(cell, en_expr ? (yylsp[-9]) : (yylsp[-8]), (yylsp[0]));

		char oper_polarity = 0;
		char oper_type = oper->at(0);

		if (oper->size() == 3) {
			oper_polarity = oper->at(0);
			oper_type = oper->at(1);
		}

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(oper_type == '*', false, 1)));
		cell->children.back()->str = "\\FULL";

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(oper_polarity != 0, false, 1)));
		cell->children.back()->str = "\\SRC_DST_PEN";

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(oper_polarity == '+', false, 1)));
		cell->children.back()->str = "\\SRC_DST_POL";

		cell->children.push_back(new AstNode(AST_PARASET, timing->rise.t_min));
		cell->children.back()->str = "\\T_RISE_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, timing->rise.t_avg));
		cell->children.back()->str = "\\T_RISE_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, timing->rise.t_max));
		cell->children.back()->str = "\\T_RISE_MAX";

		cell->children.push_back(new AstNode(AST_PARASET, timing->fall.t_min));
		cell->children.back()->str = "\\T_FALL_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, timing->fall.t_avg));
		cell->children.back()->str = "\\T_FALL_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, timing->fall.t_max));
		cell->children.back()->str = "\\T_FALL_MAX";

		cell->children.push_back(new AstNode(AST_ARGUMENT, en_expr ? en_expr : AstNode::mkconst_int(1, false, 1)));
		cell->children.back()->str = "\\EN";

		cell->children.push_back(new AstNode(AST_ARGUMENT, src_expr));
		cell->children.back()->str = "\\SRC";

		cell->children.push_back(new AstNode(AST_ARGUMENT, target->dst));
		cell->children.back()->str = "\\DST";

		if (target->dat)
		{
			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(specify_edge != 0, false, 1)));
			cell->children.back()->str = "\\EDGE_EN";

			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(specify_edge == 'p', false, 1)));
			cell->children.back()->str = "\\EDGE_POL";

			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(target->polarity_op != 0, false, 1)));
			cell->children.back()->str = "\\DAT_DST_PEN";

			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(target->polarity_op == '+', false, 1)));
			cell->children.back()->str = "\\DAT_DST_POL";

			cell->children.push_back(new AstNode(AST_ARGUMENT, target->dat));
			cell->children.back()->str = "\\DAT";
		}

		delete oper;
		delete target;
		delete timing;
	}
#line 4979 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 232: /* specify_item: TOK_ID '(' specify_edge expr specify_condition ',' specify_edge expr specify_condition ',' specify_triple specify_opt_triple ')' ';'  */
#line 1239 "frontends/verilog/verilog_parser.y"
                                                                                                                                             {
		if (*(yyvsp[-13].string) != "$setup" && *(yyvsp[-13].string) != "$hold" && *(yyvsp[-13].string) != "$setuphold" && *(yyvsp[-13].string) != "$removal" && *(yyvsp[-13].string) != "$recovery" &&
				*(yyvsp[-13].string) != "$recrem" && *(yyvsp[-13].string) != "$skew" && *(yyvsp[-13].string) != "$timeskew" && *(yyvsp[-13].string) != "$fullskew" && *(yyvsp[-13].string) != "$nochange")
			frontend_verilog_yyerror("Unsupported specify rule type: %s\n", (yyvsp[-13].string)->c_str());

		AstNode *src_pen = AstNode::mkconst_int((yyvsp[-11].ch) != 0, false, 1);
		AstNode *src_pol = AstNode::mkconst_int((yyvsp[-11].ch) == 'p', false, 1);
		AstNode *src_expr = (yyvsp[-10].ast), *src_en = (yyvsp[-9].ast) ? (yyvsp[-9].ast) : AstNode::mkconst_int(1, false, 1);

		AstNode *dst_pen = AstNode::mkconst_int((yyvsp[-7].ch) != 0, false, 1);
		AstNode *dst_pol = AstNode::mkconst_int((yyvsp[-7].ch) == 'p', false, 1);
		AstNode *dst_expr = (yyvsp[-6].ast), *dst_en = (yyvsp[-5].ast) ? (yyvsp[-5].ast) : AstNode::mkconst_int(1, false, 1);

		specify_triple *limit = (yyvsp[-3].specify_triple_ptr);
		specify_triple *limit2 = (yyvsp[-2].specify_triple_ptr);

		AstNode *cell = new AstNode(AST_CELL);
		ast_stack.back()->children.push_back(cell);
		cell->str = stringf("$specify$%d", autoidx++);
		cell->children.push_back(new AstNode(AST_CELLTYPE));
		cell->children.back()->str = "$specrule";
		SET_AST_NODE_LOC(cell, (yylsp[-13]), (yylsp[0]));

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_str(*(yyvsp[-13].string))));
		cell->children.back()->str = "\\TYPE";

		cell->children.push_back(new AstNode(AST_PARASET, limit->t_min));
		cell->children.back()->str = "\\T_LIMIT_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, limit->t_avg));
		cell->children.back()->str = "\\T_LIMIT_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, limit->t_max));
		cell->children.back()->str = "\\T_LIMIT_MAX";

		cell->children.push_back(new AstNode(AST_PARASET, limit2 ? limit2->t_min : AstNode::mkconst_int(0, true)));
		cell->children.back()->str = "\\T_LIMIT2_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, limit2 ? limit2->t_avg : AstNode::mkconst_int(0, true)));
		cell->children.back()->str = "\\T_LIMIT2_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, limit2 ? limit2->t_max : AstNode::mkconst_int(0, true)));
		cell->children.back()->str = "\\T_LIMIT2_MAX";

		cell->children.push_back(new AstNode(AST_PARASET, src_pen));
		cell->children.back()->str = "\\SRC_PEN";

		cell->children.push_back(new AstNode(AST_PARASET, src_pol));
		cell->children.back()->str = "\\SRC_POL";

		cell->children.push_back(new AstNode(AST_PARASET, dst_pen));
		cell->children.back()->str = "\\DST_PEN";

		cell->children.push_back(new AstNode(AST_PARASET, dst_pol));
		cell->children.back()->str = "\\DST_POL";

		cell->children.push_back(new AstNode(AST_ARGUMENT, src_en));
		cell->children.back()->str = "\\SRC_EN";

		cell->children.push_back(new AstNode(AST_ARGUMENT, src_expr));
		cell->children.back()->str = "\\SRC";

		cell->children.push_back(new AstNode(AST_ARGUMENT, dst_en));
		cell->children.back()->str = "\\DST_EN";

		cell->children.push_back(new AstNode(AST_ARGUMENT, dst_expr));
		cell->children.back()->str = "\\DST";

		delete (yyvsp[-13].string);
		delete limit;
		delete limit2;
	}
#line 5056 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 233: /* specify_opt_triple: ',' specify_triple  */
#line 1313 "frontends/verilog/verilog_parser.y"
                           {
		(yyval.specify_triple_ptr) = (yyvsp[0].specify_triple_ptr);
	}
#line 5064 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 234: /* specify_opt_triple: %empty  */
#line 1316 "frontends/verilog/verilog_parser.y"
               {
		(yyval.specify_triple_ptr) = nullptr;
	}
#line 5072 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 235: /* specify_if: TOK_IF '(' expr ')'  */
#line 1321 "frontends/verilog/verilog_parser.y"
                            {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 5080 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 236: /* specify_if: %empty  */
#line 1324 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = nullptr;
	}
#line 5088 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 237: /* specify_condition: TOK_SPECIFY_AND expr  */
#line 1329 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 5096 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 238: /* specify_condition: %empty  */
#line 1332 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = nullptr;
	}
#line 5104 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 239: /* specify_target: expr  */
#line 1337 "frontends/verilog/verilog_parser.y"
             {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = 0;
		(yyval.specify_target_ptr)->dst = (yyvsp[0].ast);
		(yyval.specify_target_ptr)->dat = nullptr;
	}
#line 5115 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 240: /* specify_target: '(' expr ':' expr ')'  */
#line 1343 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = 0;
		(yyval.specify_target_ptr)->dst = (yyvsp[-3].ast);
		(yyval.specify_target_ptr)->dat = (yyvsp[-1].ast);
	}
#line 5126 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 241: /* specify_target: '(' expr TOK_NEG_INDEXED expr ')'  */
#line 1349 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = '-';
		(yyval.specify_target_ptr)->dst = (yyvsp[-3].ast);
		(yyval.specify_target_ptr)->dat = (yyvsp[-1].ast);
	}
#line 5137 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 242: /* specify_target: '(' expr TOK_POS_INDEXED expr ')'  */
#line 1355 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = '+';
		(yyval.specify_target_ptr)->dst = (yyvsp[-3].ast);
		(yyval.specify_target_ptr)->dat = (yyvsp[-1].ast);
	}
#line 5148 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 243: /* specify_edge: TOK_POSEDGE  */
#line 1363 "frontends/verilog/verilog_parser.y"
                    { (yyval.ch) = 'p'; }
#line 5154 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 244: /* specify_edge: TOK_NEGEDGE  */
#line 1364 "frontends/verilog/verilog_parser.y"
                    { (yyval.ch) = 'n'; }
#line 5160 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 245: /* specify_edge: %empty  */
#line 1365 "frontends/verilog/verilog_parser.y"
               { (yyval.ch) = 0; }
#line 5166 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 246: /* specify_rise_fall: specify_triple  */
#line 1368 "frontends/verilog/verilog_parser.y"
                       {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[0].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall.t_min = (yyvsp[0].specify_triple_ptr)->t_min->clone();
		(yyval.specify_rise_fall_ptr)->fall.t_avg = (yyvsp[0].specify_triple_ptr)->t_avg->clone();
		(yyval.specify_rise_fall_ptr)->fall.t_max = (yyvsp[0].specify_triple_ptr)->t_max->clone();
		delete (yyvsp[0].specify_triple_ptr);
	}
#line 5179 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 247: /* specify_rise_fall: '(' specify_triple ',' specify_triple ')'  */
#line 1376 "frontends/verilog/verilog_parser.y"
                                                  {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-3].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-1].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
	}
#line 5191 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 248: /* specify_rise_fall: '(' specify_triple ',' specify_triple ',' specify_triple ')'  */
#line 1383 "frontends/verilog/verilog_parser.y"
                                                                     {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-5].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-5].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
		log_file_warning(current_filename, get_line_num(), "Path delay expressions beyond rise/fall not currently supported. Ignoring.\n");
	}
#line 5205 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 249: /* specify_rise_fall: '(' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ')'  */
#line 1392 "frontends/verilog/verilog_parser.y"
                                                                                                                              {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-11].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-9].specify_triple_ptr);
		delete (yyvsp[-11].specify_triple_ptr);
		delete (yyvsp[-9].specify_triple_ptr);
		delete (yyvsp[-7].specify_triple_ptr);
		delete (yyvsp[-5].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
		log_file_warning(current_filename, get_line_num(), "Path delay expressions beyond rise/fall not currently supported. Ignoring.\n");
	}
#line 5222 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 250: /* specify_rise_fall: '(' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ')'  */
#line 1404 "frontends/verilog/verilog_parser.y"
                                                                                                                                                                                                                                                {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-23].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-21].specify_triple_ptr);
		delete (yyvsp[-23].specify_triple_ptr);
		delete (yyvsp[-21].specify_triple_ptr);
		delete (yyvsp[-19].specify_triple_ptr);
		delete (yyvsp[-17].specify_triple_ptr);
		delete (yyvsp[-15].specify_triple_ptr);
		delete (yyvsp[-13].specify_triple_ptr);
		delete (yyvsp[-11].specify_triple_ptr);
		delete (yyvsp[-9].specify_triple_ptr);
		delete (yyvsp[-7].specify_triple_ptr);
		delete (yyvsp[-5].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
		log_file_warning(current_filename, get_line_num(), "Path delay expressions beyond rise/fall not currently supported. Ignoring.\n");
	}
#line 5245 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 251: /* specify_triple: expr  */
#line 1424 "frontends/verilog/verilog_parser.y"
             {
		(yyval.specify_triple_ptr) = new specify_triple;
		(yyval.specify_triple_ptr)->t_min = (yyvsp[0].ast);
		(yyval.specify_triple_ptr)->t_avg = (yyvsp[0].ast)->clone();
		(yyval.specify_triple_ptr)->t_max = (yyvsp[0].ast)->clone();
	}
#line 5256 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 252: /* specify_triple: expr ':' expr ':' expr  */
#line 1430 "frontends/verilog/verilog_parser.y"
                               {
		(yyval.specify_triple_ptr) = new specify_triple;
		(yyval.specify_triple_ptr)->t_min = (yyvsp[-4].ast);
		(yyval.specify_triple_ptr)->t_avg = (yyvsp[-2].ast);
		(yyval.specify_triple_ptr)->t_max = (yyvsp[0].ast);
	}
#line 5267 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 302: /* ignspec_constant_expression: expr  */
#line 1551 "frontends/verilog/verilog_parser.y"
             { delete (yyvsp[0].ast); }
#line 5273 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 303: /* ignspec_expr: expr  */
#line 1554 "frontends/verilog/verilog_parser.y"
             { delete (yyvsp[0].ast); }
#line 5279 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 304: /* ignspec_expr: expr ':' expr ':' expr  */
#line 1555 "frontends/verilog/verilog_parser.y"
                               {
		delete (yyvsp[-4].ast);
		delete (yyvsp[-2].ast);
		delete (yyvsp[0].ast);
	}
#line 5289 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 305: /* $@34: %empty  */
#line 1562 "frontends/verilog/verilog_parser.y"
               { delete (yyvsp[0].string); }
#line 5295 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 306: /* ignspec_id: TOK_ID $@34 range_or_multirange  */
#line 1563 "frontends/verilog/verilog_parser.y"
                            { delete (yyvsp[0].ast); }
#line 5301 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 307: /* param_signed: TOK_SIGNED  */
#line 1568 "frontends/verilog/verilog_parser.y"
                   {
		astbuf1->is_signed = true;
	}
#line 5309 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 308: /* param_signed: TOK_UNSIGNED  */
#line 1570 "frontends/verilog/verilog_parser.y"
                         {
		astbuf1->is_signed = false;
	}
#line 5317 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 310: /* param_integer: type_atom  */
#line 1575 "frontends/verilog/verilog_parser.y"
                  {
		astbuf1->is_reg = false;
	}
#line 5325 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 311: /* param_real: TOK_REAL  */
#line 1580 "frontends/verilog/verilog_parser.y"
                 {
		astbuf1->children.push_back(new AstNode(AST_REALVALUE));
	}
#line 5333 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 312: /* param_range: range  */
#line 1585 "frontends/verilog/verilog_parser.y"
              {
		if ((yyvsp[0].ast) != NULL) {
			astbuf1->children.push_back((yyvsp[0].ast));
		}
	}
#line 5343 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 314: /* param_range_type: type_vec param_signed  */
#line 1593 "frontends/verilog/verilog_parser.y"
                              {
		addRange(astbuf1, 0, 0);
	}
#line 5351 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 315: /* param_range_type: type_vec param_signed non_opt_range  */
#line 1596 "frontends/verilog/verilog_parser.y"
                                            {
		astbuf1->children.push_back((yyvsp[0].ast));
	}
#line 5359 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 321: /* param_type: hierarchical_type_id  */
#line 1603 "frontends/verilog/verilog_parser.y"
                             {
		astbuf1->is_custom_type = true;
		astbuf1->children.push_back(new AstNode(AST_WIRETYPE));
		astbuf1->children.back()->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 5370 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 322: /* $@35: %empty  */
#line 1611 "frontends/verilog/verilog_parser.y"
                           {
		astbuf1 = new AstNode(AST_PARAMETER);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 5380 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 323: /* param_decl: attr TOK_PARAMETER $@35 param_type param_decl_list ';'  */
#line 1615 "frontends/verilog/verilog_parser.y"
                                         {
		delete astbuf1;
	}
#line 5388 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 324: /* $@36: %empty  */
#line 1620 "frontends/verilog/verilog_parser.y"
                            {
		astbuf1 = new AstNode(AST_LOCALPARAM);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 5398 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 325: /* localparam_decl: attr TOK_LOCALPARAM $@36 param_type param_decl_list ';'  */
#line 1624 "frontends/verilog/verilog_parser.y"
                                         {
		delete astbuf1;
	}
#line 5406 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 328: /* single_param_decl: single_param_decl_ident '=' expr  */
#line 1632 "frontends/verilog/verilog_parser.y"
                                         {
		AstNode *decl = ast_stack.back()->children.back();
		log_assert(decl->type == AST_PARAMETER || decl->type == AST_LOCALPARAM);
		delete decl->children[0];
		decl->children[0] = (yyvsp[0].ast);
	}
#line 5417 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 329: /* single_param_decl: single_param_decl_ident  */
#line 1638 "frontends/verilog/verilog_parser.y"
                                {
		AstNode *decl = ast_stack.back()->children.back();
		if (decl->type != AST_PARAMETER) {
			log_assert(decl->type == AST_LOCALPARAM);
			frontend_verilog_yyerror("localparam initialization is missing!");
		}
		if (!sv_mode)
			frontend_verilog_yyerror("Parameter defaults can only be omitted in SystemVerilog mode!");
		delete decl->children[0];
		decl->children.erase(decl->children.begin());
	}
#line 5433 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 330: /* single_param_decl_ident: TOK_ID  */
#line 1651 "frontends/verilog/verilog_parser.y"
               {
		AstNode *node;
		if (astbuf1 == nullptr) {
			if (!sv_mode)
				frontend_verilog_yyerror("In pure Verilog (not SystemVerilog), parameter/localparam with an initializer must use the parameter/localparam keyword");
			node = new AstNode(AST_PARAMETER);
			node->children.push_back(AstNode::mkconst_int(0, true));
		} else {
			node = astbuf1->clone();
		}
		node->str = *(yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		delete (yyvsp[0].string);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
	}
#line 5453 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 334: /* single_defparam_decl: range rvalue '=' expr  */
#line 1674 "frontends/verilog/verilog_parser.y"
                              {
		AstNode *node = new AstNode(AST_DEFPARAM);
		node->children.push_back((yyvsp[-2].ast));
		node->children.push_back((yyvsp[0].ast));
		if ((yyvsp[-3].ast) != NULL)
			node->children.push_back((yyvsp[-3].ast));
		ast_stack.back()->children.push_back(node);
	}
#line 5466 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 335: /* $@37: %empty  */
#line 1687 "frontends/verilog/verilog_parser.y"
                    {
		static int enum_count;
		// create parent node for the enum
		astbuf2 = new AstNode(AST_ENUM);
		ast_stack.back()->children.push_back(astbuf2);
		astbuf2->str = std::string("$enum");
		astbuf2->str += std::to_string(enum_count++);
		// create the template for the names
		astbuf1 = new AstNode(AST_ENUM_ITEM);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
	}
#line 5482 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 336: /* enum_type: TOK_ENUM $@37 enum_base_type '{' enum_name_list optional_comma '}'  */
#line 1697 "frontends/verilog/verilog_parser.y"
                                                               {
		// create template for the enum vars
		auto tnode = astbuf1->clone();
		delete astbuf1;
		astbuf1 = tnode;
		tnode->type = AST_WIRE;
		tnode->attributes[ID::enum_type] = AstNode::mkconst_str(astbuf2->str);
		// drop constant but keep any range
		delete tnode->children[0];
		tnode->children.erase(tnode->children.begin());
		(yyval.ast) = astbuf1;
	}
#line 5499 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 338: /* enum_base_type: type_vec type_signing range  */
#line 1711 "frontends/verilog/verilog_parser.y"
                                        { if ((yyvsp[0].ast)) astbuf1->children.push_back((yyvsp[0].ast)); }
#line 5505 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 339: /* enum_base_type: %empty  */
#line 1712 "frontends/verilog/verilog_parser.y"
                                        { astbuf1->is_reg = true; addRange(astbuf1); }
#line 5511 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 340: /* type_atom: integer_atom_type  */
#line 1716 "frontends/verilog/verilog_parser.y"
                          {
		astbuf1->is_reg = true;
		astbuf1->is_signed = true;
		addRange(astbuf1, (yyvsp[0].integer) - 1, 0);
	}
#line 5521 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 341: /* type_vec: TOK_REG  */
#line 1722 "frontends/verilog/verilog_parser.y"
                                { astbuf1->is_reg   = true; }
#line 5527 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 342: /* type_vec: TOK_LOGIC  */
#line 1723 "frontends/verilog/verilog_parser.y"
                                { astbuf1->is_logic = true; }
#line 5533 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 343: /* type_signing: TOK_SIGNED  */
#line 1727 "frontends/verilog/verilog_parser.y"
                                { astbuf1->is_signed = true; }
#line 5539 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 344: /* type_signing: TOK_UNSIGNED  */
#line 1728 "frontends/verilog/verilog_parser.y"
                                { astbuf1->is_signed = false; }
#line 5545 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 348: /* enum_name_decl: TOK_ID opt_enum_init  */
#line 1737 "frontends/verilog/verilog_parser.y"
                             {
		// put in fn
		log_assert(astbuf1);
		log_assert(astbuf2);
		auto node = astbuf1->clone();
		node->str = *(yyvsp[-1].string);
		delete (yyvsp[-1].string);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		delete node->children[0];
		node->children[0] = (yyvsp[0].ast) ? (yyvsp[0].ast) : new AstNode(AST_NONE);
		astbuf2->children.push_back(node);
	}
#line 5562 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 349: /* opt_enum_init: '=' basic_expr  */
#line 1752 "frontends/verilog/verilog_parser.y"
                                { (yyval.ast) = (yyvsp[0].ast); }
#line 5568 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 350: /* opt_enum_init: %empty  */
#line 1753 "frontends/verilog/verilog_parser.y"
                                { (yyval.ast) = NULL; }
#line 5574 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 353: /* enum_var: TOK_ID  */
#line 1761 "frontends/verilog/verilog_parser.y"
                 {
		log_assert(astbuf1);
		log_assert(astbuf2);
		auto node = astbuf1->clone();
		ast_stack.back()->children.push_back(node);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		node->is_enum = true;
	}
#line 5589 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 354: /* enum_decl: enum_type enum_var_list ';'  */
#line 1773 "frontends/verilog/verilog_parser.y"
                                                { delete (yyvsp[-2].ast); }
#line 5595 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 355: /* struct_decl: struct_type struct_var_list ';'  */
#line 1780 "frontends/verilog/verilog_parser.y"
                                                { delete astbuf2; }
#line 5601 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 356: /* $@38: %empty  */
#line 1783 "frontends/verilog/verilog_parser.y"
                          { astbuf2 = (yyvsp[0].ast); }
#line 5607 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 357: /* struct_type: struct_union $@38 struct_body  */
#line 1783 "frontends/verilog/verilog_parser.y"
                                                        { (yyval.ast) = astbuf2; }
#line 5613 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 358: /* struct_union: TOK_STRUCT  */
#line 1787 "frontends/verilog/verilog_parser.y"
                                { (yyval.ast) = new AstNode(AST_STRUCT); }
#line 5619 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 359: /* struct_union: TOK_UNION  */
#line 1788 "frontends/verilog/verilog_parser.y"
                                { (yyval.ast) = new AstNode(AST_UNION); }
#line 5625 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 362: /* opt_packed: %empty  */
#line 1796 "frontends/verilog/verilog_parser.y"
               { frontend_verilog_yyerror("Only PACKED supported at this time"); }
#line 5631 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 363: /* opt_signed_struct: TOK_SIGNED  */
#line 1799 "frontends/verilog/verilog_parser.y"
                                { astbuf2->is_signed = true; }
#line 5637 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 364: /* opt_signed_struct: TOK_UNSIGNED  */
#line 1800 "frontends/verilog/verilog_parser.y"
                                { astbuf2->is_signed = false; }
#line 5643 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 368: /* struct_member: struct_member_type member_name_list ';'  */
#line 1808 "frontends/verilog/verilog_parser.y"
                                                                { delete astbuf1; }
#line 5649 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 371: /* $@39: %empty  */
#line 1816 "frontends/verilog/verilog_parser.y"
                    {
			astbuf1->str = (yyvsp[0].string)->substr(1);
			delete (yyvsp[0].string);
			astbuf3 = astbuf1->clone();
			SET_AST_NODE_LOC(astbuf3, (yylsp[0]), (yylsp[0]));
			astbuf2->children.push_back(astbuf3);
		}
#line 5661 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 372: /* member_name: TOK_ID $@39 range  */
#line 1822 "frontends/verilog/verilog_parser.y"
                        { if ((yyvsp[0].ast)) astbuf3->children.push_back((yyvsp[0].ast)); }
#line 5667 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 373: /* $@40: %empty  */
#line 1825 "frontends/verilog/verilog_parser.y"
                    { astbuf1 = new AstNode(AST_STRUCT_ITEM); }
#line 5673 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 376: /* member_type_token: hierarchical_type_id  */
#line 1830 "frontends/verilog/verilog_parser.y"
                               {
			// use a clone of the typedef definition nodes
			auto template_node = copyTypeDefinition(*(yyvsp[0].string));
			delete (yyvsp[0].string);
			switch (template_node->type) {
			case AST_WIRE:
				template_node->type = AST_STRUCT_ITEM;
				break;
			case AST_STRUCT:
			case AST_UNION:
				break;
			default:
				frontend_verilog_yyerror("Invalid type for struct member: %s", type2str(template_node->type).c_str());
			}
			delete astbuf1;
			astbuf1 = template_node;
		}
#line 5695 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 377: /* $@41: %empty  */
#line 1847 "frontends/verilog/verilog_parser.y"
          {
		delete astbuf1;
	}
#line 5703 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 378: /* $@42: %empty  */
#line 1849 "frontends/verilog/verilog_parser.y"
                       {
			// stash state on ast_stack
			ast_stack.push_back(astbuf2);
			astbuf2 = (yyvsp[0].ast);
		}
#line 5713 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 379: /* member_type_token: $@41 struct_union $@42 struct_body  */
#line 1853 "frontends/verilog/verilog_parser.y"
                               {
		        astbuf1 = astbuf2;
			// recover state
			astbuf2 = ast_stack.back();
			ast_stack.pop_back();
		}
#line 5724 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 381: /* member_type: type_vec type_signing range_or_multirange  */
#line 1862 "frontends/verilog/verilog_parser.y"
                                                        { if ((yyvsp[0].ast)) astbuf1->children.push_back((yyvsp[0].ast)); }
#line 5730 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 384: /* struct_var: TOK_ID  */
#line 1869 "frontends/verilog/verilog_parser.y"
                        {	auto *var_node = astbuf2->clone();
				var_node->str = *(yyvsp[0].string);
				delete (yyvsp[0].string);
				SET_AST_NODE_LOC(var_node, (yylsp[0]), (yylsp[0]));
				ast_stack.back()->children.push_back(var_node);
			}
#line 5741 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 385: /* $@43: %empty  */
#line 1882 "frontends/verilog/verilog_parser.y"
                             {
		albuf = (yyvsp[-2].al);
		astbuf1 = (yyvsp[-1].ast);
		astbuf2 = checkRange(astbuf1, (yyvsp[0].ast));
	}
#line 5751 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 386: /* $@44: %empty  */
#line 1886 "frontends/verilog/verilog_parser.y"
                               {
		delete astbuf1;
		if (astbuf2 != NULL)
			delete astbuf2;
		free_attr(albuf);
	}
#line 5762 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 388: /* $@45: %empty  */
#line 1892 "frontends/verilog/verilog_parser.y"
                                {
		ast_stack.back()->children.push_back(new AstNode(AST_WIRE));
		ast_stack.back()->children.back()->str = *(yyvsp[0].string);
		append_attr(ast_stack.back()->children.back(), (yyvsp[-2].al));
		ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, new AstNode(AST_IDENTIFIER), AstNode::mkconst_int(0, false, 1)));
		ast_stack.back()->children.back()->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 5775 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 390: /* $@46: %empty  */
#line 1900 "frontends/verilog/verilog_parser.y"
                                {
		ast_stack.back()->children.push_back(new AstNode(AST_WIRE));
		ast_stack.back()->children.back()->str = *(yyvsp[0].string);
		append_attr(ast_stack.back()->children.back(), (yyvsp[-2].al));
		ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, new AstNode(AST_IDENTIFIER), AstNode::mkconst_int(1, false, 1)));
		ast_stack.back()->children.back()->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 5788 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 393: /* opt_supply_wires: opt_supply_wires ',' TOK_ID  */
#line 1911 "frontends/verilog/verilog_parser.y"
                                    {
		AstNode *wire_node = ast_stack.back()->children.at(GetSize(ast_stack.back()->children)-2)->clone();
		AstNode *assign_node = ast_stack.back()->children.at(GetSize(ast_stack.back()->children)-1)->clone();
		wire_node->str = *(yyvsp[0].string);
		assign_node->children[0]->str = *(yyvsp[0].string);
		ast_stack.back()->children.push_back(wire_node);
		ast_stack.back()->children.push_back(assign_node);
		delete (yyvsp[0].string);
	}
#line 5802 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 396: /* wire_name_and_opt_assign: wire_name  */
#line 1925 "frontends/verilog/verilog_parser.y"
                  {
		bool attr_anyconst = false;
		bool attr_anyseq = false;
		bool attr_allconst = false;
		bool attr_allseq = false;
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::anyconst)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::anyconst);
			ast_stack.back()->children.back()->attributes.erase(ID::anyconst);
			attr_anyconst = true;
		}
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::anyseq)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::anyseq);
			ast_stack.back()->children.back()->attributes.erase(ID::anyseq);
			attr_anyseq = true;
		}
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::allconst)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::allconst);
			ast_stack.back()->children.back()->attributes.erase(ID::allconst);
			attr_allconst = true;
		}
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::allseq)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::allseq);
			ast_stack.back()->children.back()->attributes.erase(ID::allseq);
			attr_allseq = true;
		}
		if (current_wire_rand || attr_anyconst || attr_anyseq || attr_allconst || attr_allseq) {
			AstNode *wire = new AstNode(AST_IDENTIFIER);
			AstNode *fcall = new AstNode(AST_FCALL);
			wire->str = ast_stack.back()->children.back()->str;
			fcall->str = current_wire_const ? "\\$anyconst" : "\\$anyseq";
			if (attr_anyconst)
				fcall->str = "\\$anyconst";
			if (attr_anyseq)
				fcall->str = "\\$anyseq";
			if (attr_allconst)
				fcall->str = "\\$allconst";
			if (attr_allseq)
				fcall->str = "\\$allseq";
			fcall->attributes[ID::reg] = AstNode::mkconst_str(RTLIL::unescape_id(wire->str));
			ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, wire, fcall));
		}
	}
#line 5849 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 397: /* wire_name_and_opt_assign: wire_name '=' expr  */
#line 1967 "frontends/verilog/verilog_parser.y"
                           {
		AstNode *wire = new AstNode(AST_IDENTIFIER);
		wire->str = ast_stack.back()->children.back()->str;
		if (astbuf1->is_input) {
			if (astbuf1->attributes.count(ID::defaultvalue))
				delete astbuf1->attributes.at(ID::defaultvalue);
			astbuf1->attributes[ID::defaultvalue] = (yyvsp[0].ast);
		}
		else if (astbuf1->is_reg || astbuf1->is_logic){
			AstNode *assign = new AstNode(AST_ASSIGN_LE, wire, (yyvsp[0].ast));
			AstNode *block = new AstNode(AST_BLOCK, assign);
			AstNode *init = new AstNode(AST_INITIAL, block);

			SET_AST_NODE_LOC(assign, (yylsp[-2]), (yylsp[0]));
			SET_AST_NODE_LOC(block, (yylsp[-2]), (yylsp[0]));
			SET_AST_NODE_LOC(init, (yylsp[-2]), (yylsp[0]));

			ast_stack.back()->children.push_back(init);
		}
		else {
			AstNode *assign = new AstNode(AST_ASSIGN, wire, (yyvsp[0].ast));
			SET_AST_NODE_LOC(assign, (yylsp[-2]), (yylsp[0]));
			ast_stack.back()->children.push_back(assign);
		}

	}
#line 5880 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 398: /* wire_name: TOK_ID range_or_multirange  */
#line 1995 "frontends/verilog/verilog_parser.y"
                                   {
		if (astbuf1 == nullptr)
			frontend_verilog_yyerror("Internal error - should not happen - no AST_WIRE node.");
		AstNode *node = astbuf1->clone();
		node->str = *(yyvsp[-1].string);
		append_attr_clone(node, albuf);
		if (astbuf2 != NULL)
			node->children.push_back(astbuf2->clone());
		if ((yyvsp[0].ast) != NULL) {
			if (node->is_input || node->is_output)
				frontend_verilog_yyerror("input/output/inout ports cannot have unpacked dimensions.");
			if (!astbuf2 && !node->is_custom_type) {
				addRange(node, 0, 0, false);
			}
			rewriteAsMemoryNode(node, (yyvsp[0].ast));
		}
		if (current_function_or_task) {
			if (node->is_input || node->is_output)
				node->port_id = current_function_or_task_port_id++;
		} else if (ast_stack.back()->type == AST_GENBLOCK) {
			if (node->is_input || node->is_output)
				frontend_verilog_yyerror("Cannot declare module port `%s' within a generate block.", (yyvsp[-1].string)->c_str());
		} else {
			if (do_not_require_port_stubs && (node->is_input || node->is_output) && port_stubs.count(*(yyvsp[-1].string)) == 0) {
				port_stubs[*(yyvsp[-1].string)] = ++port_counter;
			}
			if (port_stubs.count(*(yyvsp[-1].string)) != 0) {
				if (!node->is_input && !node->is_output)
					frontend_verilog_yyerror("Module port `%s' is neither input nor output.", (yyvsp[-1].string)->c_str());
				if (node->is_reg && node->is_input && !node->is_output && !sv_mode)
					frontend_verilog_yyerror("Input port `%s' is declared as register.", (yyvsp[-1].string)->c_str());
				node->port_id = port_stubs[*(yyvsp[-1].string)];
				port_stubs.erase(*(yyvsp[-1].string));
			} else {
				if (node->is_input || node->is_output)
					frontend_verilog_yyerror("Module port `%s' is not declared in module header.", (yyvsp[-1].string)->c_str());
			}
		}
		//FIXME: for some reason, TOK_ID has a location which always points to one column *after* the real last column...
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);

		delete (yyvsp[-1].string);
	}
#line 5929 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 402: /* assign_expr: lvalue '=' expr  */
#line 2047 "frontends/verilog/verilog_parser.y"
                        {
		AstNode *node = new AstNode(AST_ASSIGN, (yyvsp[-2].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC(node, (yyloc), (yyloc));
		ast_stack.back()->children.push_back(node);
	}
#line 5939 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 404: /* type_name: TOK_USER_TYPE  */
#line 2054 "frontends/verilog/verilog_parser.y"
                                { if (isInLocalScope((yyvsp[0].string))) frontend_verilog_yyerror("Duplicate declaration of TYPEDEF '%s'", (yyvsp[0].string)->c_str()+1); }
#line 5945 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 405: /* typedef_decl: TOK_TYPEDEF typedef_base_type range type_name range_or_multirange ';'  */
#line 2058 "frontends/verilog/verilog_parser.y"
                                                                              {
		astbuf1 = (yyvsp[-4].ast);
		astbuf2 = checkRange(astbuf1, (yyvsp[-3].ast));
		if (astbuf2)
			astbuf1->children.push_back(astbuf2);

		if ((yyvsp[-1].ast) != NULL) {
			if (!astbuf2) {
				addRange(astbuf1, 0, 0, false);
			}
			rewriteAsMemoryNode(astbuf1, (yyvsp[-1].ast));
		}
		addTypedefNode((yyvsp[-2].string), astbuf1); }
#line 5963 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 406: /* typedef_decl: TOK_TYPEDEF enum_struct_type type_name ';'  */
#line 2071 "frontends/verilog/verilog_parser.y"
                                                       { addTypedefNode((yyvsp[-1].string), (yyvsp[-2].ast)); }
#line 5969 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 407: /* typedef_base_type: hierarchical_type_id  */
#line 2075 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.ast) = new AstNode(AST_WIRE);
		(yyval.ast)->is_logic = true;
		addWiretypeNode((yyvsp[0].string), (yyval.ast));
	}
#line 5979 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 408: /* typedef_base_type: integer_vector_type opt_signedness_default_unsigned  */
#line 2080 "frontends/verilog/verilog_parser.y"
                                                            {
		(yyval.ast) = new AstNode(AST_WIRE);
		if ((yyvsp[-1].integer) == TOK_REG) {
			(yyval.ast)->is_reg = true;
		} else {
			(yyval.ast)->is_logic = true;
		}
		(yyval.ast)->is_signed = (yyvsp[0].boolean);
	}
#line 5993 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 409: /* typedef_base_type: integer_atom_type opt_signedness_default_signed  */
#line 2089 "frontends/verilog/verilog_parser.y"
                                                        {
		(yyval.ast) = new AstNode(AST_WIRE);
		(yyval.ast)->is_logic = true;
		(yyval.ast)->is_signed = (yyvsp[0].boolean);
		(yyval.ast)->range_left = (yyvsp[-1].integer) - 1;
		(yyval.ast)->range_right = 0;
	}
#line 6005 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 412: /* $@47: %empty  */
#line 2103 "frontends/verilog/verilog_parser.y"
                    {
		astbuf1 = new AstNode(AST_CELL);
		append_attr(astbuf1, (yyvsp[-1].al));
		astbuf1->children.push_back(new AstNode(AST_CELLTYPE));
		astbuf1->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 6017 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 413: /* cell_stmt: attr TOK_ID $@47 cell_parameter_list_opt cell_list ';'  */
#line 2109 "frontends/verilog/verilog_parser.y"
                                                {
		delete astbuf1;
	}
#line 6025 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 414: /* $@48: %empty  */
#line 2112 "frontends/verilog/verilog_parser.y"
                                    {
		astbuf1 = new AstNode(AST_PRIMITIVE);
		astbuf1->str = *(yyvsp[-1].string);
		append_attr(astbuf1, (yyvsp[-2].al));
		delete (yyvsp[-1].string);
	}
#line 6036 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 415: /* cell_stmt: attr tok_prim_wrapper delay $@48 prim_list ';'  */
#line 2117 "frontends/verilog/verilog_parser.y"
                        {
		delete astbuf1;
	}
#line 6044 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 416: /* tok_prim_wrapper: TOK_PRIMITIVE  */
#line 2122 "frontends/verilog/verilog_parser.y"
                      {
		(yyval.string) = (yyvsp[0].string);
	}
#line 6052 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 417: /* tok_prim_wrapper: TOK_OR  */
#line 2125 "frontends/verilog/verilog_parser.y"
               {
		(yyval.string) = new std::string("or");
	}
#line 6060 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 422: /* $@49: %empty  */
#line 2137 "frontends/verilog/verilog_parser.y"
               {
		astbuf2 = astbuf1->clone();
		if (astbuf2->type != AST_PRIMITIVE)
			astbuf2->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(astbuf2);
	}
#line 6072 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 423: /* single_cell_no_array: TOK_ID $@49 '(' cell_port_list ')'  */
#line 2143 "frontends/verilog/verilog_parser.y"
                                 {
		SET_AST_NODE_LOC(astbuf2, (yylsp[-4]), (yyloc));
	}
#line 6080 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 424: /* $@50: %empty  */
#line 2148 "frontends/verilog/verilog_parser.y"
                             {
		astbuf2 = astbuf1->clone();
		if (astbuf2->type != AST_PRIMITIVE)
			astbuf2->str = *(yyvsp[-1].string);
		delete (yyvsp[-1].string);
		ast_stack.back()->children.push_back(new AstNode(AST_CELLARRAY, (yyvsp[0].ast), astbuf2));
	}
#line 6092 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 425: /* single_cell_arraylist: TOK_ID non_opt_range $@50 '(' cell_port_list ')'  */
#line 2154 "frontends/verilog/verilog_parser.y"
                                {
		SET_AST_NODE_LOC(astbuf2, (yylsp[-5]), (yyloc));
	}
#line 6100 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 431: /* $@51: %empty  */
#line 2168 "frontends/verilog/verilog_parser.y"
                      {
		astbuf2 = astbuf1->clone();
		ast_stack.back()->children.push_back(astbuf2);
	}
#line 6109 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 432: /* single_prim: $@51 '(' cell_port_list ')'  */
#line 2171 "frontends/verilog/verilog_parser.y"
                                 {
		SET_AST_NODE_LOC(astbuf2, (yylsp[-3]), (yyloc));
	}
#line 6117 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 438: /* cell_parameter: expr  */
#line 2183 "frontends/verilog/verilog_parser.y"
             {
		AstNode *node = new AstNode(AST_PARASET);
		astbuf1->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6127 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 439: /* cell_parameter: '.' TOK_ID '(' ')'  */
#line 2188 "frontends/verilog/verilog_parser.y"
                           {
		// just ignore empty parameters
	}
#line 6135 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 440: /* cell_parameter: '.' TOK_ID '(' expr ')'  */
#line 2191 "frontends/verilog/verilog_parser.y"
                                {
		AstNode *node = new AstNode(AST_PARASET);
		node->str = *(yyvsp[-3].string);
		astbuf1->children.push_back(node);
		node->children.push_back((yyvsp[-1].ast));
		delete (yyvsp[-3].string);
	}
#line 6147 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 441: /* cell_port_list: cell_port_list_rules  */
#line 2200 "frontends/verilog/verilog_parser.y"
                             {
		// remove empty args from end of list
		while (!astbuf2->children.empty()) {
			AstNode *node = astbuf2->children.back();
			if (node->type != AST_ARGUMENT) break;
			if (!node->children.empty()) break;
			if (!node->str.empty()) break;
			astbuf2->children.pop_back();
			delete node;
		}

		// check port types
		bool has_positional_args = false;
		bool has_named_args = false;
		for (auto node : astbuf2->children) {
			if (node->type != AST_ARGUMENT) continue;
			if (node->str.empty())
				has_positional_args = true;
			else
				has_named_args = true;
		}

		if (has_positional_args && has_named_args)
			frontend_verilog_yyerror("Mix of positional and named cell ports.");
	}
#line 6177 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 444: /* cell_port: attr  */
#line 2230 "frontends/verilog/verilog_parser.y"
             {
		AstNode *node = new AstNode(AST_ARGUMENT);
		astbuf2->children.push_back(node);
		free_attr((yyvsp[0].al));
	}
#line 6187 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 445: /* cell_port: attr expr  */
#line 2235 "frontends/verilog/verilog_parser.y"
                  {
		AstNode *node = new AstNode(AST_ARGUMENT);
		astbuf2->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
		free_attr((yyvsp[-1].al));
	}
#line 6198 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 446: /* cell_port: attr '.' TOK_ID '(' expr ')'  */
#line 2241 "frontends/verilog/verilog_parser.y"
                                     {
		AstNode *node = new AstNode(AST_ARGUMENT);
		node->str = *(yyvsp[-3].string);
		astbuf2->children.push_back(node);
		node->children.push_back((yyvsp[-1].ast));
		delete (yyvsp[-3].string);
		free_attr((yyvsp[-5].al));
	}
#line 6211 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 447: /* cell_port: attr '.' TOK_ID '(' ')'  */
#line 2249 "frontends/verilog/verilog_parser.y"
                                {
		AstNode *node = new AstNode(AST_ARGUMENT);
		node->str = *(yyvsp[-2].string);
		astbuf2->children.push_back(node);
		delete (yyvsp[-2].string);
		free_attr((yyvsp[-4].al));
	}
#line 6223 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 448: /* cell_port: attr '.' TOK_ID  */
#line 2256 "frontends/verilog/verilog_parser.y"
                        {
		AstNode *node = new AstNode(AST_ARGUMENT);
		node->str = *(yyvsp[0].string);
		astbuf2->children.push_back(node);
		node->children.push_back(new AstNode(AST_IDENTIFIER));
		node->children.back()->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		free_attr((yyvsp[-2].al));
	}
#line 6237 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 449: /* cell_port: attr TOK_WILDCARD_CONNECT  */
#line 2265 "frontends/verilog/verilog_parser.y"
                                  {
		if (!sv_mode)
			frontend_verilog_yyerror("Wildcard port connections are only supported in SystemVerilog mode.");
		astbuf2->attributes[ID::wildcard_port_conns] = AstNode::mkconst_int(1, false);
		free_attr((yyvsp[-1].al));
	}
#line 6248 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 450: /* always_comb_or_latch: TOK_ALWAYS_COMB  */
#line 2273 "frontends/verilog/verilog_parser.y"
                        {
		(yyval.boolean) = false;
	}
#line 6256 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 451: /* always_comb_or_latch: TOK_ALWAYS_LATCH  */
#line 2276 "frontends/verilog/verilog_parser.y"
                         {
		(yyval.boolean) = true;
	}
#line 6264 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 452: /* always_or_always_ff: TOK_ALWAYS  */
#line 2281 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.boolean) = false;
	}
#line 6272 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 453: /* always_or_always_ff: TOK_ALWAYS_FF  */
#line 2284 "frontends/verilog/verilog_parser.y"
                      {
		(yyval.boolean) = true;
	}
#line 6280 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 454: /* $@52: %empty  */
#line 2289 "frontends/verilog/verilog_parser.y"
                                 {
		AstNode *node = new AstNode(AST_ALWAYS);
		append_attr(node, (yyvsp[-1].al));
		if ((yyvsp[0].boolean))
			node->attributes[ID::always_ff] = AstNode::mkconst_int(1, false);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 6293 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 455: /* $@53: %empty  */
#line 2296 "frontends/verilog/verilog_parser.y"
                      {
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6303 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 456: /* always_stmt: attr always_or_always_ff $@52 always_cond $@53 behavioral_stmt  */
#line 2300 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();

		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-4]), (yyloc));
		ast_stack.pop_back();

		SET_RULE_LOC((yyloc), (yylsp[-4]), (yyloc));
	}
#line 6317 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 457: /* $@54: %empty  */
#line 2309 "frontends/verilog/verilog_parser.y"
                                  {
		AstNode *node = new AstNode(AST_ALWAYS);
		append_attr(node, (yyvsp[-1].al));
		if ((yyvsp[0].boolean))
			node->attributes[ID::always_latch] = AstNode::mkconst_int(1, false);
		else
			node->attributes[ID::always_comb] = AstNode::mkconst_int(1, false);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6335 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 458: /* always_stmt: attr always_comb_or_latch $@54 behavioral_stmt  */
#line 2321 "frontends/verilog/verilog_parser.y"
                          {
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6344 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 459: /* $@55: %empty  */
#line 2325 "frontends/verilog/verilog_parser.y"
                         {
		AstNode *node = new AstNode(AST_INITIAL);
		append_attr(node, (yyvsp[-1].al));
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6358 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 460: /* always_stmt: attr TOK_INITIAL $@55 behavioral_stmt  */
#line 2333 "frontends/verilog/verilog_parser.y"
                          {
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6367 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 470: /* always_event: TOK_POSEDGE expr  */
#line 2352 "frontends/verilog/verilog_parser.y"
                         {
		AstNode *node = new AstNode(AST_POSEDGE);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6378 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 471: /* always_event: TOK_NEGEDGE expr  */
#line 2358 "frontends/verilog/verilog_parser.y"
                         {
		AstNode *node = new AstNode(AST_NEGEDGE);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6389 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 472: /* always_event: expr  */
#line 2364 "frontends/verilog/verilog_parser.y"
             {
		AstNode *node = new AstNode(AST_EDGE);
		ast_stack.back()->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6399 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 473: /* opt_label: ':' TOK_ID  */
#line 2371 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.string) = (yyvsp[0].string);
	}
#line 6407 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 474: /* opt_label: %empty  */
#line 2374 "frontends/verilog/verilog_parser.y"
               {
		(yyval.string) = NULL;
	}
#line 6415 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 475: /* opt_sva_label: TOK_SVA_LABEL ':'  */
#line 2379 "frontends/verilog/verilog_parser.y"
                          {
		(yyval.string) = (yyvsp[-1].string);
	}
#line 6423 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 476: /* opt_sva_label: %empty  */
#line 2382 "frontends/verilog/verilog_parser.y"
               {
		(yyval.string) = NULL;
	}
#line 6431 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 477: /* opt_property: TOK_PROPERTY  */
#line 2387 "frontends/verilog/verilog_parser.y"
                     {
		(yyval.boolean) = true;
	}
#line 6439 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 478: /* opt_property: TOK_FINAL  */
#line 2390 "frontends/verilog/verilog_parser.y"
                  {
		(yyval.boolean) = false;
	}
#line 6447 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 479: /* opt_property: %empty  */
#line 2393 "frontends/verilog/verilog_parser.y"
               {
		(yyval.boolean) = false;
	}
#line 6455 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 480: /* $@56: %empty  */
#line 2398 "frontends/verilog/verilog_parser.y"
                       {
        AstNode *modport = new AstNode(AST_MODPORT);
        ast_stack.back()->children.push_back(modport);
        ast_stack.push_back(modport);
        modport->str = *(yyvsp[0].string);
        delete (yyvsp[0].string);
    }
#line 6467 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 481: /* $@57: %empty  */
#line 2404 "frontends/verilog/verilog_parser.y"
                        {
        ast_stack.pop_back();
        log_assert(ast_stack.size() == 2);
    }
#line 6476 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 489: /* modport_member: TOK_ID  */
#line 2420 "frontends/verilog/verilog_parser.y"
           {
        AstNode *modport_member = new AstNode(AST_MODPORTMEMBER);
        ast_stack.back()->children.push_back(modport_member);
        modport_member->str = *(yyvsp[0].string);
        modport_member->is_input = current_modport_input;
        modport_member->is_output = current_modport_output;
        delete (yyvsp[0].string);
    }
#line 6489 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 490: /* modport_type_token: TOK_INPUT  */
#line 2430 "frontends/verilog/verilog_parser.y"
              {current_modport_input = 1; current_modport_output = 0;}
#line 6495 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 491: /* modport_type_token: TOK_OUTPUT  */
#line 2430 "frontends/verilog/verilog_parser.y"
                                                                                    {current_modport_input = 0; current_modport_output = 1;}
#line 6501 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 492: /* assert: opt_sva_label TOK_ASSERT opt_property '(' expr ')' ';'  */
#line 2433 "frontends/verilog/verilog_parser.y"
                                                               {
		if (noassert_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assume_asserts_mode ? AST_ASSUME : AST_ASSERT, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			if ((yyvsp[-6].string) != nullptr)
				node->str = *(yyvsp[-6].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-6].string) != nullptr)
			delete (yyvsp[-6].string);
	}
#line 6519 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 493: /* assert: opt_sva_label TOK_ASSUME opt_property '(' expr ')' ';'  */
#line 2446 "frontends/verilog/verilog_parser.y"
                                                               {
		if (noassume_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assert_assumes_mode ? AST_ASSERT : AST_ASSUME, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			if ((yyvsp[-6].string) != nullptr)
				node->str = *(yyvsp[-6].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-6].string) != nullptr)
			delete (yyvsp[-6].string);
	}
#line 6537 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 494: /* assert: opt_sva_label TOK_ASSERT opt_property '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2459 "frontends/verilog/verilog_parser.y"
                                                                              {
		if (noassert_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assume_asserts_mode ? AST_FAIR : AST_LIVE, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			if ((yyvsp[-7].string) != nullptr)
				node->str = *(yyvsp[-7].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-7].string) != nullptr)
			delete (yyvsp[-7].string);
	}
#line 6555 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 495: /* assert: opt_sva_label TOK_ASSUME opt_property '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2472 "frontends/verilog/verilog_parser.y"
                                                                              {
		if (noassume_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assert_assumes_mode ? AST_LIVE : AST_FAIR, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			if ((yyvsp[-7].string) != nullptr)
				node->str = *(yyvsp[-7].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-7].string) != nullptr)
			delete (yyvsp[-7].string);
	}
#line 6573 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 496: /* assert: opt_sva_label TOK_COVER opt_property '(' expr ')' ';'  */
#line 2485 "frontends/verilog/verilog_parser.y"
                                                              {
		AstNode *node = new AstNode(AST_COVER, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		if ((yyvsp[-6].string) != nullptr) {
			node->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
		ast_stack.back()->children.push_back(node);
	}
#line 6587 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 497: /* assert: opt_sva_label TOK_COVER opt_property '(' ')' ';'  */
#line 2494 "frontends/verilog/verilog_parser.y"
                                                         {
		AstNode *node = new AstNode(AST_COVER, AstNode::mkconst_int(1, false));
		SET_AST_NODE_LOC(node, (yylsp[-5]), (yylsp[-1]));
		if ((yyvsp[-5].string) != nullptr) {
			node->str = *(yyvsp[-5].string);
			delete (yyvsp[-5].string);
		}
		ast_stack.back()->children.push_back(node);
	}
#line 6601 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 498: /* assert: opt_sva_label TOK_COVER ';'  */
#line 2503 "frontends/verilog/verilog_parser.y"
                                    {
		AstNode *node = new AstNode(AST_COVER, AstNode::mkconst_int(1, false));
		SET_AST_NODE_LOC(node, (yylsp[-2]), (yylsp[-1]));
		if ((yyvsp[-2].string) != nullptr) {
			node->str = *(yyvsp[-2].string);
			delete (yyvsp[-2].string);
		}
		ast_stack.back()->children.push_back(node);
	}
#line 6615 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 499: /* assert: opt_sva_label TOK_RESTRICT opt_property '(' expr ')' ';'  */
#line 2512 "frontends/verilog/verilog_parser.y"
                                                                 {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_ASSUME, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			if ((yyvsp[-6].string) != nullptr)
				node->str = *(yyvsp[-6].string);
			ast_stack.back()->children.push_back(node);
		}
		if (!(yyvsp[-4].boolean))
			log_file_warning(current_filename, get_line_num(), "SystemVerilog does not allow \"restrict\" without \"property\".\n");
		if ((yyvsp[-6].string) != nullptr)
			delete (yyvsp[-6].string);
	}
#line 6635 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 500: /* assert: opt_sva_label TOK_RESTRICT opt_property '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2527 "frontends/verilog/verilog_parser.y"
                                                                                {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_FAIR, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			if ((yyvsp[-7].string) != nullptr)
				node->str = *(yyvsp[-7].string);
			ast_stack.back()->children.push_back(node);
		}
		if (!(yyvsp[-5].boolean))
			log_file_warning(current_filename, get_line_num(), "SystemVerilog does not allow \"restrict\" without \"property\".\n");
		if ((yyvsp[-7].string) != nullptr)
			delete (yyvsp[-7].string);
	}
#line 6655 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 501: /* assert_property: opt_sva_label TOK_ASSERT TOK_PROPERTY '(' expr ')' ';'  */
#line 2544 "frontends/verilog/verilog_parser.y"
                                                               {
		AstNode *node = new AstNode(assume_asserts_mode ? AST_ASSUME : AST_ASSERT, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-6].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
	}
#line 6669 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 502: /* assert_property: opt_sva_label TOK_ASSUME TOK_PROPERTY '(' expr ')' ';'  */
#line 2553 "frontends/verilog/verilog_parser.y"
                                                               {
		AstNode *node = new AstNode(AST_ASSUME, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-6].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
	}
#line 6683 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 503: /* assert_property: opt_sva_label TOK_ASSERT TOK_PROPERTY '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2562 "frontends/verilog/verilog_parser.y"
                                                                              {
		AstNode *node = new AstNode(assume_asserts_mode ? AST_FAIR : AST_LIVE, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-7].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-7].string);
			delete (yyvsp[-7].string);
		}
	}
#line 6697 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 504: /* assert_property: opt_sva_label TOK_ASSUME TOK_PROPERTY '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2571 "frontends/verilog/verilog_parser.y"
                                                                              {
		AstNode *node = new AstNode(AST_FAIR, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-7].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-7].string);
			delete (yyvsp[-7].string);
		}
	}
#line 6711 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 505: /* assert_property: opt_sva_label TOK_COVER TOK_PROPERTY '(' expr ')' ';'  */
#line 2580 "frontends/verilog/verilog_parser.y"
                                                              {
		AstNode *node = new AstNode(AST_COVER, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-6].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
	}
#line 6725 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 506: /* assert_property: opt_sva_label TOK_RESTRICT TOK_PROPERTY '(' expr ')' ';'  */
#line 2589 "frontends/verilog/verilog_parser.y"
                                                                 {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_ASSUME, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			ast_stack.back()->children.push_back(node);
			if ((yyvsp[-6].string) != nullptr) {
				ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
				delete (yyvsp[-6].string);
			}
		}
	}
#line 6743 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 507: /* assert_property: opt_sva_label TOK_RESTRICT TOK_PROPERTY '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2602 "frontends/verilog/verilog_parser.y"
                                                                                {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_FAIR, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			ast_stack.back()->children.push_back(node);
			if ((yyvsp[-7].string) != nullptr) {
				ast_stack.back()->children.back()->str = *(yyvsp[-7].string);
				delete (yyvsp[-7].string);
			}
		}
	}
#line 6761 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 508: /* simple_behavioral_stmt: attr lvalue '=' delay expr  */
#line 2617 "frontends/verilog/verilog_parser.y"
                                   {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-3].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		append_attr(node, (yyvsp[-4].al));
	}
#line 6772 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 509: /* simple_behavioral_stmt: attr lvalue TOK_INCREMENT  */
#line 2623 "frontends/verilog/verilog_parser.y"
                                  {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-1].ast), new AstNode(AST_ADD, (yyvsp[-1].ast)->clone(), AstNode::mkconst_int(1, true)));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[0]));
		append_attr(node, (yyvsp[-2].al));
	}
#line 6783 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 510: /* simple_behavioral_stmt: attr lvalue TOK_DECREMENT  */
#line 2629 "frontends/verilog/verilog_parser.y"
                                  {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-1].ast), new AstNode(AST_SUB, (yyvsp[-1].ast)->clone(), AstNode::mkconst_int(1, true)));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[0]));
		append_attr(node, (yyvsp[-2].al));
	}
#line 6794 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 511: /* simple_behavioral_stmt: attr lvalue OP_LE delay expr  */
#line 2635 "frontends/verilog/verilog_parser.y"
                                     {
		AstNode *node = new AstNode(AST_ASSIGN_LE, (yyvsp[-3].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		append_attr(node, (yyvsp[-4].al));
	}
#line 6805 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 512: /* simple_behavioral_stmt: attr lvalue asgn_binop delay expr  */
#line 2641 "frontends/verilog/verilog_parser.y"
                                          {
		AstNode *expr_node = (yyvsp[0].ast);
		if ((yyvsp[-2].ast_node_type) == AST_SHIFT_LEFT || (yyvsp[-2].ast_node_type) == AST_SHIFT_RIGHT ||
			(yyvsp[-2].ast_node_type) == AST_SHIFT_SLEFT || (yyvsp[-2].ast_node_type) == AST_SHIFT_SRIGHT) {
			expr_node = new AstNode(AST_TO_UNSIGNED, expr_node);
			SET_AST_NODE_LOC(expr_node, (yylsp[0]), (yylsp[0]));
		}
		AstNode *op_node = new AstNode((yyvsp[-2].ast_node_type), (yyvsp[-3].ast)->clone(), expr_node);
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-3].ast), op_node);
		SET_AST_NODE_LOC(op_node, (yylsp[-3]), (yylsp[0]));
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
		append_attr(node, (yyvsp[-4].al));
	}
#line 6824 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 513: /* asgn_binop: TOK_BIT_OR_ASSIGN  */
#line 2657 "frontends/verilog/verilog_parser.y"
                          { (yyval.ast_node_type) = AST_BIT_OR; }
#line 6830 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 514: /* asgn_binop: TOK_BIT_AND_ASSIGN  */
#line 2658 "frontends/verilog/verilog_parser.y"
                           { (yyval.ast_node_type) = AST_BIT_AND; }
#line 6836 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 515: /* asgn_binop: TOK_BIT_XOR_ASSIGN  */
#line 2659 "frontends/verilog/verilog_parser.y"
                           { (yyval.ast_node_type) = AST_BIT_XOR; }
#line 6842 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 516: /* asgn_binop: TOK_ADD_ASSIGN  */
#line 2660 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_ADD; }
#line 6848 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 517: /* asgn_binop: TOK_SUB_ASSIGN  */
#line 2661 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_SUB; }
#line 6854 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 518: /* asgn_binop: TOK_DIV_ASSIGN  */
#line 2662 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_DIV; }
#line 6860 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 519: /* asgn_binop: TOK_MOD_ASSIGN  */
#line 2663 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_MOD; }
#line 6866 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 520: /* asgn_binop: TOK_MUL_ASSIGN  */
#line 2664 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_MUL; }
#line 6872 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 521: /* asgn_binop: TOK_SHL_ASSIGN  */
#line 2665 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_SHIFT_LEFT; }
#line 6878 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 522: /* asgn_binop: TOK_SHR_ASSIGN  */
#line 2666 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_SHIFT_RIGHT; }
#line 6884 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 523: /* asgn_binop: TOK_SSHL_ASSIGN  */
#line 2667 "frontends/verilog/verilog_parser.y"
                        { (yyval.ast_node_type) = AST_SHIFT_SLEFT; }
#line 6890 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 524: /* asgn_binop: TOK_SSHR_ASSIGN  */
#line 2668 "frontends/verilog/verilog_parser.y"
                        { (yyval.ast_node_type) = AST_SHIFT_SRIGHT; }
#line 6896 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 525: /* for_initialization: TOK_ID '=' expr  */
#line 2671 "frontends/verilog/verilog_parser.y"
                        {
		AstNode *ident = new AstNode(AST_IDENTIFIER);
		ident->str = *(yyvsp[-2].string);
		AstNode *node = new AstNode(AST_ASSIGN_EQ, ident, (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-2]), (yylsp[0]));
	}
#line 6908 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 526: /* for_initialization: non_io_wire_type range TOK_ID  */
#line 2678 "frontends/verilog/verilog_parser.y"
                                      {
		frontend_verilog_yyerror("For loop variable declaration is missing initialization!");
	}
#line 6916 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 527: /* for_initialization: non_io_wire_type range TOK_ID '=' expr  */
#line 2681 "frontends/verilog/verilog_parser.y"
                                               {
		if (!sv_mode)
			frontend_verilog_yyerror("For loop inline variable declaration is only supported in SystemVerilog mode!");

		// loop variable declaration
		AstNode *wire = (yyvsp[-4].ast);
		AstNode *range = checkRange(wire, (yyvsp[-3].ast));
		if (range != nullptr)
			wire->children.push_back(range);
		SET_AST_NODE_LOC(wire, (yylsp[-4]), (yylsp[-2]));
		SET_AST_NODE_LOC(range, (yylsp[-3]), (yylsp[-3]));

		AstNode *ident = new AstNode(AST_IDENTIFIER);
		ident->str = *(yyvsp[-2].string);
		wire->str = *(yyvsp[-2].string);
		delete (yyvsp[-2].string);

		AstNode *loop = ast_stack.back();
		AstNode *parent = ast_stack.at(ast_stack.size() - 2);
		log_assert(parent->children.back() == loop);

		// loop variable initialization
		AstNode *asgn = new AstNode(AST_ASSIGN_EQ, ident, (yyvsp[0].ast));
		loop->children.push_back(asgn);
		SET_AST_NODE_LOC(asgn, (yylsp[-2]), (yylsp[0]));
		SET_AST_NODE_LOC(ident, (yylsp[-2]), (yylsp[-2]));

		// inject a wrapping block to declare the loop variable and
		// contain the current loop
		AstNode *wrapper = new AstNode(AST_BLOCK);
		wrapper->str = "$fordecl_block$" + std::to_string(autoidx++);
		wrapper->children.push_back(wire);
		wrapper->children.push_back(loop);
		parent->children.back() = wrapper; // replaces `loop`
	}
#line 6956 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 536: /* behavioral_stmt: attr ';'  */
#line 2722 "frontends/verilog/verilog_parser.y"
                 {
		free_attr((yyvsp[-1].al));
	}
#line 6964 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 537: /* $@58: %empty  */
#line 2725 "frontends/verilog/verilog_parser.y"
                             {
		AstNode *node = new AstNode(AST_TCALL);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-1].al));
	}
#line 6977 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 538: /* behavioral_stmt: attr hierarchical_id $@58 opt_arg_list ';'  */
#line 2732 "frontends/verilog/verilog_parser.y"
                          {
		ast_stack.pop_back();
	}
#line 6985 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 539: /* $@59: %empty  */
#line 2735 "frontends/verilog/verilog_parser.y"
                           {
		AstNode *node = new AstNode(AST_TCALL);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-1].al));
	}
#line 6998 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 540: /* behavioral_stmt: attr TOK_MSG_TASKS $@59 opt_arg_list ';'  */
#line 2742 "frontends/verilog/verilog_parser.y"
                          {
		ast_stack.pop_back();
	}
#line 7006 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 541: /* $@60: %empty  */
#line 2745 "frontends/verilog/verilog_parser.y"
                       {
		enterTypeScope();
	}
#line 7014 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 542: /* $@61: %empty  */
#line 2747 "frontends/verilog/verilog_parser.y"
                    {
		AstNode *node = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-3].al));
		if ((yyvsp[0].string) != NULL)
			node->str = *(yyvsp[0].string);
	}
#line 7027 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 543: /* behavioral_stmt: attr TOK_BEGIN $@60 opt_label $@61 behavioral_stmt_list TOK_END opt_label  */
#line 2754 "frontends/verilog/verilog_parser.y"
                                                 {
		exitTypeScope();
		checkLabelsMatch("Begin label", (yyvsp[-4].string), (yyvsp[0].string));
		AstNode *node = ast_stack.back();
		// In SystemVerilog, unnamed blocks with block item declarations
		// create an implicit hierarchy scope
		if (sv_mode && node->str.empty())
		    for (const AstNode* child : node->children)
			if (child->type == AST_WIRE || child->type == AST_MEMORY || child->type == AST_PARAMETER
				|| child->type == AST_LOCALPARAM || child->type == AST_TYPEDEF) {
			    node->str = "$unnamed_block$" + std::to_string(autoidx++);
			    break;
			}
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		delete (yyvsp[-4].string);
		delete (yyvsp[0].string);
		ast_stack.pop_back();
	}
#line 7050 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 544: /* $@62: %empty  */
#line 2772 "frontends/verilog/verilog_parser.y"
                         {
		AstNode *node = new AstNode(AST_FOR);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-2].al));
	}
#line 7061 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 545: /* $@63: %empty  */
#line 2777 "frontends/verilog/verilog_parser.y"
                                      {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7069 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 546: /* $@64: %empty  */
#line 2779 "frontends/verilog/verilog_parser.y"
                                         {
		AstNode *block = new AstNode(AST_BLOCK);
		block->str = "$for_loop$" + std::to_string(autoidx++);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 7080 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 547: /* behavioral_stmt: attr TOK_FOR '(' $@62 for_initialization ';' expr $@63 ';' simple_behavioral_stmt ')' $@64 behavioral_stmt  */
#line 2784 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-11]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7091 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 548: /* $@65: %empty  */
#line 2790 "frontends/verilog/verilog_parser.y"
                                    {
		AstNode *node = new AstNode(AST_WHILE);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-4].al));
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back((yyvsp[-1].ast));
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 7106 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 549: /* behavioral_stmt: attr TOK_WHILE '(' expr ')' $@65 behavioral_stmt  */
#line 2799 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7116 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 550: /* $@66: %empty  */
#line 2804 "frontends/verilog/verilog_parser.y"
                                     {
		AstNode *node = new AstNode(AST_REPEAT);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-4].al));
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back((yyvsp[-1].ast));
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 7131 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 551: /* behavioral_stmt: attr TOK_REPEAT '(' expr ')' $@66 behavioral_stmt  */
#line 2813 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7141 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 552: /* $@67: %empty  */
#line 2818 "frontends/verilog/verilog_parser.y"
                                 {
		AstNode *node = new AstNode(AST_CASE);
		AstNode *block = new AstNode(AST_BLOCK);
		AstNode *cond = new AstNode(AST_COND, AstNode::mkconst_int(1, false, 1), block);
		SET_AST_NODE_LOC(cond, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		node->children.push_back(new AstNode(AST_REDUCE_BOOL, (yyvsp[-1].ast)));
		node->children.push_back(cond);
		ast_stack.push_back(node);
		ast_stack.push_back(block);
		append_attr(node, (yyvsp[-4].al));
	}
#line 7158 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 553: /* $@68: %empty  */
#line 2829 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
	}
#line 7166 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 554: /* behavioral_stmt: attr TOK_IF '(' expr ')' $@67 behavioral_stmt $@68 optional_else  */
#line 2831 "frontends/verilog/verilog_parser.y"
                        {
		ast_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-7]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7176 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 555: /* $@69: %empty  */
#line 2836 "frontends/verilog/verilog_parser.y"
                                         {
		AstNode *node = new AstNode(AST_CASE, (yyvsp[-1].ast));
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-4].al));
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-1]), (yylsp[-1]));
	}
#line 7188 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 556: /* behavioral_stmt: case_attr case_type '(' expr ')' $@69 opt_synopsys_attr case_body TOK_ENDCASE  */
#line 2842 "frontends/verilog/verilog_parser.y"
                                                  {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-7]), (yylsp[0]));
		case_type_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7198 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 557: /* case_attr: attr  */
#line 2849 "frontends/verilog/verilog_parser.y"
             {
		(yyval.al) = (yyvsp[0].al);
	}
#line 7206 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 558: /* case_attr: attr TOK_UNIQUE0  */
#line 2852 "frontends/verilog/verilog_parser.y"
                         {
		(*(yyvsp[-1].al))[ID::parallel_case] = AstNode::mkconst_int(1, false);
		(yyval.al) = (yyvsp[-1].al);
	}
#line 7215 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 559: /* case_attr: attr TOK_PRIORITY  */
#line 2856 "frontends/verilog/verilog_parser.y"
                          {
		(*(yyvsp[-1].al))[ID::full_case] = AstNode::mkconst_int(1, false);
		(yyval.al) = (yyvsp[-1].al);
	}
#line 7224 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 560: /* case_attr: attr TOK_UNIQUE  */
#line 2860 "frontends/verilog/verilog_parser.y"
                        {
		(*(yyvsp[-1].al))[ID::full_case] = AstNode::mkconst_int(1, false);
		(*(yyvsp[-1].al))[ID::parallel_case] = AstNode::mkconst_int(1, false);
		(yyval.al) = (yyvsp[-1].al);
	}
#line 7234 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 561: /* case_type: TOK_CASE  */
#line 2867 "frontends/verilog/verilog_parser.y"
                 {
		case_type_stack.push_back(0);
	}
#line 7242 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 562: /* case_type: TOK_CASEX  */
#line 2870 "frontends/verilog/verilog_parser.y"
                  {
		case_type_stack.push_back('x');
	}
#line 7250 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 563: /* case_type: TOK_CASEZ  */
#line 2873 "frontends/verilog/verilog_parser.y"
                  {
		case_type_stack.push_back('z');
	}
#line 7258 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 564: /* opt_synopsys_attr: opt_synopsys_attr TOK_SYNOPSYS_FULL_CASE  */
#line 2878 "frontends/verilog/verilog_parser.y"
                                                 {
		if (ast_stack.back()->attributes.count(ID::full_case) == 0)
			ast_stack.back()->attributes[ID::full_case] = AstNode::mkconst_int(1, false);
	}
#line 7267 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 565: /* opt_synopsys_attr: opt_synopsys_attr TOK_SYNOPSYS_PARALLEL_CASE  */
#line 2882 "frontends/verilog/verilog_parser.y"
                                                     {
		if (ast_stack.back()->attributes.count(ID::parallel_case) == 0)
			ast_stack.back()->attributes[ID::parallel_case] = AstNode::mkconst_int(1, false);
	}
#line 7276 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 569: /* $@70: %empty  */
#line 2893 "frontends/verilog/verilog_parser.y"
                 {
		AstNode *block = new AstNode(AST_BLOCK);
		AstNode *cond = new AstNode(AST_COND, new AstNode(AST_DEFAULT), block);
		SET_AST_NODE_LOC(cond, (yylsp[0]), (yylsp[0]));

		ast_stack.pop_back();
		ast_stack.back()->children.push_back(cond);
		ast_stack.push_back(block);
	}
#line 7290 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 570: /* optional_else: TOK_ELSE $@70 behavioral_stmt  */
#line 2901 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
	}
#line 7298 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 574: /* $@71: %empty  */
#line 2911 "frontends/verilog/verilog_parser.y"
        {
		AstNode *node = new AstNode(
				case_type_stack.size() && case_type_stack.back() == 'x' ? AST_CONDX :
				case_type_stack.size() && case_type_stack.back() == 'z' ? AST_CONDZ : AST_COND);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7310 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 575: /* $@72: %empty  */
#line 2917 "frontends/verilog/verilog_parser.y"
                      {
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
		case_type_stack.push_back(0);
	}
#line 7321 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 576: /* case_item: $@71 case_select $@72 behavioral_stmt  */
#line 2922 "frontends/verilog/verilog_parser.y"
                          {
		case_type_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7332 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 579: /* $@73: %empty  */
#line 2934 "frontends/verilog/verilog_parser.y"
        {
		AstNode *node = new AstNode(
				case_type_stack.size() && case_type_stack.back() == 'x' ? AST_CONDX :
				case_type_stack.size() && case_type_stack.back() == 'z' ? AST_CONDZ : AST_COND);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7344 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 580: /* $@74: %empty  */
#line 2940 "frontends/verilog/verilog_parser.y"
                      {
		case_type_stack.push_back(0);
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
	}
#line 7353 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 581: /* gen_case_item: $@73 case_select $@74 gen_stmt_block  */
#line 2943 "frontends/verilog/verilog_parser.y"
                         {
		case_type_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7362 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 584: /* case_expr_list: TOK_DEFAULT  */
#line 2953 "frontends/verilog/verilog_parser.y"
                    {
		AstNode *node = new AstNode(AST_DEFAULT);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
	}
#line 7372 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 585: /* case_expr_list: TOK_SVA_LABEL  */
#line 2958 "frontends/verilog/verilog_parser.y"
                      {
		AstNode *node = new AstNode(AST_IDENTIFIER);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
		ast_stack.back()->children.back()->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 7384 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 586: /* case_expr_list: expr  */
#line 2965 "frontends/verilog/verilog_parser.y"
             {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7392 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 587: /* case_expr_list: case_expr_list ',' expr  */
#line 2968 "frontends/verilog/verilog_parser.y"
                                {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7400 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 588: /* rvalue: hierarchical_id '[' expr ']' '.' rvalue  */
#line 2973 "frontends/verilog/verilog_parser.y"
                                                {
		(yyval.ast) = new AstNode(AST_PREFIX, (yyvsp[-3].ast), (yyvsp[0].ast));
		(yyval.ast)->str = *(yyvsp[-5].string);
		delete (yyvsp[-5].string);
	}
#line 7410 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 589: /* rvalue: hierarchical_id range  */
#line 2978 "frontends/verilog/verilog_parser.y"
                              {
		(yyval.ast) = new AstNode(AST_IDENTIFIER, (yyvsp[0].ast));
		(yyval.ast)->str = *(yyvsp[-1].string);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-1]), (yylsp[-1]));
		delete (yyvsp[-1].string);
		if ((yyvsp[0].ast) == nullptr && ((yyval.ast)->str == "\\$initstate" ||
				(yyval.ast)->str == "\\$anyconst" || (yyval.ast)->str == "\\$anyseq" ||
				(yyval.ast)->str == "\\$allconst" || (yyval.ast)->str == "\\$allseq"))
			(yyval.ast)->type = AST_FCALL;
	}
#line 7425 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 590: /* rvalue: hierarchical_id non_opt_multirange  */
#line 2988 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_IDENTIFIER, (yyvsp[0].ast));
		(yyval.ast)->str = *(yyvsp[-1].string);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-1]), (yylsp[-1]));
		delete (yyvsp[-1].string);
	}
#line 7436 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 591: /* lvalue: rvalue  */
#line 2996 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 7444 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 592: /* lvalue: '{' lvalue_concat_list '}'  */
#line 2999 "frontends/verilog/verilog_parser.y"
                                   {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 7452 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 593: /* lvalue_concat_list: expr  */
#line 3004 "frontends/verilog/verilog_parser.y"
             {
		(yyval.ast) = new AstNode(AST_CONCAT);
		(yyval.ast)->children.push_back((yyvsp[0].ast));
	}
#line 7461 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 594: /* lvalue_concat_list: expr ',' lvalue_concat_list  */
#line 3008 "frontends/verilog/verilog_parser.y"
                                    {
		(yyval.ast) = (yyvsp[0].ast);
		(yyval.ast)->children.push_back((yyvsp[-2].ast));
	}
#line 7470 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 601: /* single_arg: expr  */
#line 3026 "frontends/verilog/verilog_parser.y"
             {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7478 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 607: /* gen_stmt_or_module_body_stmt: attr ';'  */
#line 3037 "frontends/verilog/verilog_parser.y"
                 {
		free_attr((yyvsp[-1].al));
	}
#line 7486 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 608: /* genvar_identifier: TOK_ID  */
#line 3042 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = new AstNode(AST_IDENTIFIER);
		(yyval.ast)->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 7496 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 609: /* genvar_initialization: TOK_GENVAR genvar_identifier  */
#line 3049 "frontends/verilog/verilog_parser.y"
                                     {
		frontend_verilog_yyerror("Generate for loop variable declaration is missing initialization!");
	}
#line 7504 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 610: /* genvar_initialization: TOK_GENVAR genvar_identifier '=' expr  */
#line 3052 "frontends/verilog/verilog_parser.y"
                                              {
		if (!sv_mode)
			frontend_verilog_yyerror("Generate for loop inline variable declaration is only supported in SystemVerilog mode!");
		AstNode *node = new AstNode(AST_GENVAR);
		node->is_reg = true;
		node->is_signed = true;
		node->range_left = 31;
		node->range_right = 0;
		node->str = (yyvsp[-2].ast)->str;
		node->children.push_back(checkRange(node, nullptr));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-2].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
	}
#line 7525 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 611: /* genvar_initialization: genvar_identifier '=' expr  */
#line 3068 "frontends/verilog/verilog_parser.y"
                                   {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-2].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-2]), (yylsp[0]));
	}
#line 7535 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 612: /* $@75: %empty  */
#line 3076 "frontends/verilog/verilog_parser.y"
                    {
		AstNode *node = new AstNode(AST_GENFOR);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7545 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 613: /* $@76: %empty  */
#line 3080 "frontends/verilog/verilog_parser.y"
                                         {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7553 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 614: /* gen_stmt: TOK_FOR '(' $@75 genvar_initialization ';' expr $@76 ';' simple_behavioral_stmt ')' gen_stmt_block  */
#line 3082 "frontends/verilog/verilog_parser.y"
                                                        {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-10]), (yylsp[0]));
		rewriteGenForDeclInit(ast_stack.back());
		ast_stack.pop_back();
	}
#line 7563 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 615: /* $@77: %empty  */
#line 3087 "frontends/verilog/verilog_parser.y"
                            {
		AstNode *node = new AstNode(AST_GENIF);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		ast_stack.back()->children.push_back((yyvsp[-1].ast));
	}
#line 7574 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 616: /* gen_stmt: TOK_IF '(' expr ')' $@77 gen_stmt_block opt_gen_else  */
#line 3092 "frontends/verilog/verilog_parser.y"
                                      {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7583 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 617: /* $@78: %empty  */
#line 3096 "frontends/verilog/verilog_parser.y"
                               {
		AstNode *node = new AstNode(AST_GENCASE, (yyvsp[-1].ast));
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7593 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 618: /* gen_stmt: case_type '(' expr ')' $@78 gen_case_body TOK_ENDCASE  */
#line 3100 "frontends/verilog/verilog_parser.y"
                                    {
		case_type_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7603 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 619: /* $@79: %empty  */
#line 3105 "frontends/verilog/verilog_parser.y"
                      {
		AstNode *node = new AstNode(AST_TECALL);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7615 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 620: /* gen_stmt: TOK_MSG_TASKS $@79 opt_arg_list ';'  */
#line 3111 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-3]), (yylsp[-1]));
		ast_stack.pop_back();
	}
#line 7624 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 621: /* $@80: %empty  */
#line 3117 "frontends/verilog/verilog_parser.y"
                  {
		enterTypeScope();
	}
#line 7632 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 622: /* $@81: %empty  */
#line 3119 "frontends/verilog/verilog_parser.y"
                    {
		AstNode *node = new AstNode(AST_GENBLOCK);
		node->str = (yyvsp[0].string) ? *(yyvsp[0].string) : std::string();
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7643 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 623: /* gen_block: TOK_BEGIN $@80 opt_label $@81 module_gen_body TOK_END opt_label  */
#line 3124 "frontends/verilog/verilog_parser.y"
                                            {
		exitTypeScope();
		checkLabelsMatch("Begin label", (yyvsp[-4].string), (yyvsp[0].string));
		delete (yyvsp[-4].string);
		delete (yyvsp[0].string);
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7656 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 624: /* $@82: %empty  */
#line 3135 "frontends/verilog/verilog_parser.y"
        {
		AstNode *node = new AstNode(AST_GENBLOCK);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7666 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 625: /* gen_stmt_block: $@82 gen_stmt_or_module_body_stmt  */
#line 3139 "frontends/verilog/verilog_parser.y"
                                       {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7675 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 629: /* expr: basic_expr  */
#line 3148 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 7683 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 630: /* expr: basic_expr '?' attr expr ':' expr  */
#line 3151 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_TERNARY);
		(yyval.ast)->children.push_back((yyvsp[-5].ast));
		(yyval.ast)->children.push_back((yyvsp[-2].ast));
		(yyval.ast)->children.push_back((yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-5]), (yyloc));
		append_attr((yyval.ast), (yyvsp[-3].al));
	}
#line 7696 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 631: /* basic_expr: rvalue  */
#line 3161 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 7704 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 632: /* basic_expr: '(' expr ')' integral_number  */
#line 3164 "frontends/verilog/verilog_parser.y"
                                     {
		if ((yyvsp[0].string)->compare(0, 1, "'") != 0)
			frontend_verilog_yyerror("Cast operation must be applied on sized constants e.g. (<expr>)<constval> , while %s is not a sized constant.", (yyvsp[0].string)->c_str());
		AstNode *bits = (yyvsp[-2].ast);
		AstNode *val = const2ast(*(yyvsp[0].string), case_type_stack.size() == 0 ? 0 : case_type_stack.back(), !lib_mode);
		if (val == NULL)
			log_error("Value conversion failed: `%s'\n", (yyvsp[0].string)->c_str());
		(yyval.ast) = new AstNode(AST_TO_BITS, bits, val);
		delete (yyvsp[0].string);
	}
#line 7719 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 633: /* basic_expr: hierarchical_id integral_number  */
#line 3174 "frontends/verilog/verilog_parser.y"
                                        {
		if ((yyvsp[0].string)->compare(0, 1, "'") != 0)
			frontend_verilog_yyerror("Cast operation must be applied on sized constants, e.g. <ID>\'d0, while %s is not a sized constant.", (yyvsp[0].string)->c_str());
		AstNode *bits = new AstNode(AST_IDENTIFIER);
		bits->str = *(yyvsp[-1].string);
		SET_AST_NODE_LOC(bits, (yylsp[-1]), (yylsp[-1]));
		AstNode *val = const2ast(*(yyvsp[0].string), case_type_stack.size() == 0 ? 0 : case_type_stack.back(), !lib_mode);
		SET_AST_NODE_LOC(val, (yylsp[0]), (yylsp[0]));
		if (val == NULL)
			log_error("Value conversion failed: `%s'\n", (yyvsp[0].string)->c_str());
		(yyval.ast) = new AstNode(AST_TO_BITS, bits, val);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 7738 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 634: /* basic_expr: integral_number  */
#line 3188 "frontends/verilog/verilog_parser.y"
                        {
		(yyval.ast) = const2ast(*(yyvsp[0].string), case_type_stack.size() == 0 ? 0 : case_type_stack.back(), !lib_mode);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[0]), (yylsp[0]));
		if ((yyval.ast) == NULL)
			log_error("Value conversion failed: `%s'\n", (yyvsp[0].string)->c_str());
		delete (yyvsp[0].string);
	}
#line 7750 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 635: /* basic_expr: TOK_REALVAL  */
#line 3195 "frontends/verilog/verilog_parser.y"
                    {
		(yyval.ast) = new AstNode(AST_REALVALUE);
		char *p = (char*)malloc(GetSize(*(yyvsp[0].string)) + 1), *q;
		for (int i = 0, j = 0; j < GetSize(*(yyvsp[0].string)); j++)
			if ((*(yyvsp[0].string))[j] != '_')
				p[i++] = (*(yyvsp[0].string))[j], p[i] = 0;
		(yyval.ast)->realvalue = strtod(p, &q);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[0]), (yylsp[0]));
		log_assert(*q == 0);
		delete (yyvsp[0].string);
		free(p);
	}
#line 7767 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 636: /* basic_expr: TOK_STRING  */
#line 3207 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.ast) = AstNode::mkconst_str(*(yyvsp[0].string));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[0]), (yylsp[0]));
		delete (yyvsp[0].string);
	}
#line 7777 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 637: /* $@83: %empty  */
#line 3212 "frontends/verilog/verilog_parser.y"
                             {
		AstNode *node = new AstNode(AST_FCALL);
		node->str = *(yyvsp[-1].string);
		delete (yyvsp[-1].string);
		ast_stack.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		append_attr(node, (yyvsp[0].al));
	}
#line 7790 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 638: /* basic_expr: hierarchical_id attr $@83 '(' arg_list optional_comma ')'  */
#line 3219 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = ast_stack.back();
		ast_stack.pop_back();
	}
#line 7799 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 639: /* basic_expr: TOK_TO_SIGNED attr '(' expr ')'  */
#line 3223 "frontends/verilog/verilog_parser.y"
                                        {
		(yyval.ast) = new AstNode(AST_TO_SIGNED, (yyvsp[-1].ast));
		append_attr((yyval.ast), (yyvsp[-3].al));
	}
#line 7808 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 640: /* basic_expr: TOK_TO_UNSIGNED attr '(' expr ')'  */
#line 3227 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_TO_UNSIGNED, (yyvsp[-1].ast));
		append_attr((yyval.ast), (yyvsp[-3].al));
	}
#line 7817 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 641: /* basic_expr: '(' expr ')'  */
#line 3231 "frontends/verilog/verilog_parser.y"
                     {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 7825 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 642: /* basic_expr: '(' expr ':' expr ':' expr ')'  */
#line 3234 "frontends/verilog/verilog_parser.y"
                                       {
		delete (yyvsp[-5].ast);
		(yyval.ast) = (yyvsp[-3].ast);
		delete (yyvsp[-1].ast);
	}
#line 7835 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 643: /* basic_expr: '{' concat_list '}'  */
#line 3239 "frontends/verilog/verilog_parser.y"
                            {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 7843 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 644: /* basic_expr: '{' expr '{' concat_list '}' '}'  */
#line 3242 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_REPLICATE, (yyvsp[-4].ast), (yyvsp[-2].ast));
	}
#line 7851 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 645: /* basic_expr: '~' attr basic_expr  */
#line 3245 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_BIT_NOT, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7861 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 646: /* basic_expr: basic_expr '&' attr basic_expr  */
#line 3250 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_BIT_AND, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7871 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 647: /* basic_expr: basic_expr OP_NAND attr basic_expr  */
#line 3255 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_BIT_NOT, new AstNode(AST_BIT_AND, (yyvsp[-3].ast), (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7881 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 648: /* basic_expr: basic_expr '|' attr basic_expr  */
#line 3260 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_BIT_OR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7891 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 649: /* basic_expr: basic_expr OP_NOR attr basic_expr  */
#line 3265 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_BIT_NOT, new AstNode(AST_BIT_OR, (yyvsp[-3].ast), (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7901 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 650: /* basic_expr: basic_expr '^' attr basic_expr  */
#line 3270 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_BIT_XOR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7911 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 651: /* basic_expr: basic_expr OP_XNOR attr basic_expr  */
#line 3275 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_BIT_XNOR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7921 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 652: /* basic_expr: '&' attr basic_expr  */
#line 3280 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_REDUCE_AND, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7931 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 653: /* basic_expr: OP_NAND attr basic_expr  */
#line 3285 "frontends/verilog/verilog_parser.y"
                                                {
		(yyval.ast) = new AstNode(AST_REDUCE_AND, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
		(yyval.ast) = new AstNode(AST_LOGIC_NOT, (yyval.ast));
	}
#line 7942 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 654: /* basic_expr: '|' attr basic_expr  */
#line 3291 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_REDUCE_OR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7952 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 655: /* basic_expr: OP_NOR attr basic_expr  */
#line 3296 "frontends/verilog/verilog_parser.y"
                                               {
		(yyval.ast) = new AstNode(AST_REDUCE_OR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
		(yyval.ast) = new AstNode(AST_LOGIC_NOT, (yyval.ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
	}
#line 7964 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 656: /* basic_expr: '^' attr basic_expr  */
#line 3303 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_REDUCE_XOR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7974 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 657: /* basic_expr: OP_XNOR attr basic_expr  */
#line 3308 "frontends/verilog/verilog_parser.y"
                                                {
		(yyval.ast) = new AstNode(AST_REDUCE_XNOR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7984 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 658: /* basic_expr: basic_expr OP_SHL attr basic_expr  */
#line 3313 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_SHIFT_LEFT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7994 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 659: /* basic_expr: basic_expr OP_SHR attr basic_expr  */
#line 3318 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_SHIFT_RIGHT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8004 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 660: /* basic_expr: basic_expr OP_SSHL attr basic_expr  */
#line 3323 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_SHIFT_SLEFT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8014 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 661: /* basic_expr: basic_expr OP_SSHR attr basic_expr  */
#line 3328 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_SHIFT_SRIGHT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8024 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 662: /* basic_expr: basic_expr '<' attr basic_expr  */
#line 3333 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_LT, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8034 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 663: /* basic_expr: basic_expr OP_LE attr basic_expr  */
#line 3338 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_LE, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8044 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 664: /* basic_expr: basic_expr OP_EQ attr basic_expr  */
#line 3343 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_EQ, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8054 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 665: /* basic_expr: basic_expr OP_NE attr basic_expr  */
#line 3348 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_NE, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8064 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 666: /* basic_expr: basic_expr OP_EQX attr basic_expr  */
#line 3353 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_EQX, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8074 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 667: /* basic_expr: basic_expr OP_NEX attr basic_expr  */
#line 3358 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_NEX, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8084 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 668: /* basic_expr: basic_expr OP_GE attr basic_expr  */
#line 3363 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_GE, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8094 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 669: /* basic_expr: basic_expr '>' attr basic_expr  */
#line 3368 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_GT, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8104 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 670: /* basic_expr: basic_expr '+' attr basic_expr  */
#line 3373 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_ADD, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8114 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 671: /* basic_expr: basic_expr '-' attr basic_expr  */
#line 3378 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_SUB, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8124 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 672: /* basic_expr: basic_expr '*' attr basic_expr  */
#line 3383 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_MUL, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8134 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 673: /* basic_expr: basic_expr '/' attr basic_expr  */
#line 3388 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_DIV, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8144 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 674: /* basic_expr: basic_expr '%' attr basic_expr  */
#line 3393 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_MOD, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8154 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 675: /* basic_expr: basic_expr OP_POW attr basic_expr  */
#line 3398 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_POW, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8164 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 676: /* basic_expr: '+' attr basic_expr  */
#line 3403 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_POS, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8174 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 677: /* basic_expr: '-' attr basic_expr  */
#line 3408 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_NEG, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8184 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 678: /* basic_expr: basic_expr OP_LAND attr basic_expr  */
#line 3413 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_LOGIC_AND, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8194 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 679: /* basic_expr: basic_expr OP_LOR attr basic_expr  */
#line 3418 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_LOGIC_OR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8204 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 680: /* basic_expr: '!' attr basic_expr  */
#line 3423 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_LOGIC_NOT, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8214 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 681: /* basic_expr: TOK_SIGNED OP_CAST '(' expr ')'  */
#line 3428 "frontends/verilog/verilog_parser.y"
                                        {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_TO_SIGNED, (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 8225 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 682: /* basic_expr: TOK_UNSIGNED OP_CAST '(' expr ')'  */
#line 3434 "frontends/verilog/verilog_parser.y"
                                          {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_TO_UNSIGNED, (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 8236 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 683: /* basic_expr: basic_expr OP_CAST '(' expr ')'  */
#line 3440 "frontends/verilog/verilog_parser.y"
                                        {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_CAST_SIZE, (yyvsp[-4].ast), (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 8247 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 684: /* concat_list: expr  */
#line 3448 "frontends/verilog/verilog_parser.y"
             {
		(yyval.ast) = new AstNode(AST_CONCAT, (yyvsp[0].ast));
	}
#line 8255 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 685: /* concat_list: expr ',' concat_list  */
#line 3451 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.ast) = (yyvsp[0].ast);
		(yyval.ast)->children.push_back((yyvsp[-2].ast));
	}
#line 8264 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 686: /* integral_number: TOK_CONSTVAL  */
#line 3457 "frontends/verilog/verilog_parser.y"
                     { (yyval.string) = (yyvsp[0].string); }
#line 8270 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 687: /* integral_number: TOK_UNBASED_UNSIZED_CONSTVAL  */
#line 3458 "frontends/verilog/verilog_parser.y"
                                     { (yyval.string) = (yyvsp[0].string); }
#line 8276 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 688: /* integral_number: TOK_BASE TOK_BASED_CONSTVAL  */
#line 3459 "frontends/verilog/verilog_parser.y"
                                    {
		(yyvsp[-1].string)->append(*(yyvsp[0].string));
		(yyval.string) = (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 8286 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 689: /* integral_number: TOK_CONSTVAL TOK_BASE TOK_BASED_CONSTVAL  */
#line 3464 "frontends/verilog/verilog_parser.y"
                                                 {
		(yyvsp[-2].string)->append(*(yyvsp[-1].string)).append(*(yyvsp[0].string));
		(yyval.string) = (yyvsp[-2].string);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 8297 "frontends/verilog/verilog_parser.tab.cc"
    break;


#line 8301 "frontends/verilog/verilog_parser.tab.cc"

        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == FRONTEND_VERILOG_YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yyesa, &yyes, &yyes_capacity, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != FRONTEND_VERILOG_YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= FRONTEND_VERILOG_YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == FRONTEND_VERILOG_YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = FRONTEND_VERILOG_YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != FRONTEND_VERILOG_YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

